c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine Adapt_Check_NorthSouth

      !integer status(MPI_STATUS_SIZE)   
      
      include 'common.3D'
      
      integer i_BC_Possible_global(n_procs_max),i_BC(n_procs_max)
            
      itime_check = 10e8     !0    !10e8     !
      
      !-- Adaptive algorithm --
      !i_North_Boundary_Change =  0  : No Change
      !i_North_Boundary_Change = -1  : Shift boundary -2h
      !i_North_Boundary_Change =  1  : Shift boundary +2h
      i_North_Boundary_Change_Possible = 0
      i_North_Boundary_Change = 0
      i_South_Boundary_Change = 0

        ymin_rank_old = ymin_rank
        ymax_rank_old = ymax_rank
        ncy_local_old = ncy_local
        nsheet_local_old = nsheet_local
c        !if(rank_id.lt.n_procs-1.and.(.NOT.iCartTop_periodicity(1)))then
c        if(rank_id.lt.n_procs-1)then    !CHECK THIS!!!!!!!!!!!!!!!!!!!!!
c          if(nFP_local_North.gt.nFP_local + nFP_difference_max)then
c            if(ymax_rank_North-ymin_rank_North.gt.yrank_length_max)then   !8.05*h)then
c              i_North_Boundary_Change =  1
c            end if
c          end if
c          if(nFP_local_North.lt.nFP_local - nFP_difference_max)then
c            if(ymax_rank-ymin_rank.gt.yrank_length_max)then   !8.05*h)then
c              i_North_Boundary_Change = -1
c            end if
c          end if
c        end if
        !-- Checking between procs not adjacent --
        if(rank_idy.lt.n_procs_y-1.and.rank_idy.gt.0)then
         if(nFP_local_North -nFP_local_South.gt.nFP_difference_max)then
           if(ymax_rank_North-ymin_rank_North.gt.yrank_length_max)then
             i_North_Boundary_Change_Possible =  1
           end if
         end if
         if(nFP_local_North -nFP_local_South.lt.-nFP_difference_max)then
           if(ymax_rank-ymin_rank.gt.yrank_length_max)then
             i_North_Boundary_Change_Possible = -1
           end if
         end if
        end if
        !-- Checking first & final processors --
        if(rank_idy.eq.0)then
         if(nFP_local_North - nFP_local.gt.nFP_difference_max)then
           if(ymax_rank_North-ymin_rank_North.gt.yrank_length_max)then
             i_North_Boundary_Change_Possible =  1
           end if
         end if
         if(nFP_local_North - nFP_local.lt.-nFP_difference_max)then
           if(ymax_rank-ymin_rank.gt.yrank_length_max)then   !8.05*h)then
             i_North_Boundary_Change_Possible = -1
           end if
         end if
        end if
        !-- JUST MESSING TO TRY AND DEBUG --
        !if(itime.eq.0)then
        !  if(rank_id.eq.1)i_North_Boundary_Change = -1
        !  if(rank_id.eq.2)i_North_Boundary_Change =  1
        !if(rank_id.eq.1)then
        !  i_North_Boundary_Change = -1
        !elseif(rank_id.eq.2)then
        !  i_North_Boundary_Change =  1
        !else
        !  i_North_Boundary_Change = 0
        !endif

        !-- For initial balancing --
        if(itime.eq.0)then

         !-- Don't reverse previous partition shift for 3 previous shifts --
         if( (abs(nFP_local-nFP_local_previous1).gt.int(0.1*np/n_procs)
     &   .or.abs(nFP_local-nFP_local_previous2).gt.int(0.1*np/n_procs)
     &   .or.abs(nFP_local-nFP_local_previous3).gt.int(0.1*np/n_procs)
     &       ).and.
     &      (abs(nFP_local-nFP_local_previous1).lt.int(0.2*np/n_procs))
     &      )then
            i_North_Boundary_Change_Possible = 0
          endif

        endif

        !- Check Numbers of Particles either side of column -
        call MPI_GATHER(
     &        i_North_Boundary_Change_Possible , 1, MPI_INTEGER,
     &        i_BC_Possible_global(rank_id+1)  , 1, MPI_INTEGER,
     &        0, grid_comm, ierr)
c        if(rank_id.eq.0)then
c          print*,'i_BC_Possible_global ',
c     &            i_BC_Possible_global(1:n_procs)
c        endif
        do i_rank_y = 1,n_procs_y
          i_BC_sheet_stay = 0
          i_BC_sheet_moveSouth  = 0
          i_BC_sheet_moveNorth  = 0
          do i_rank_x = 1,n_procs_x
          do i_rank_z = 1,n_procs_z
            i_rank = i_rank_x + (i_rank_y - 1)*n_procs_x
     &                        + (i_rank_z - 1)*n_procs_x*n_procs_y
            !Check i_North_Boundary_Change_Possible
            if(i_BC_Possible_global(i_rank).gt.0)then
              i_BC_sheet_moveNorth = i_BC_sheet_moveNorth + 1
            elseif(i_BC_Possible_global(i_rank).lt.0)then
              i_BC_sheet_moveSouth = i_BC_sheet_moveSouth + 1
            else
              i_BC_sheet_stay = i_BC_sheet_stay + 1
            endif
          enddo
          enddo
          !- Determine which way entire column should move -
          i_BC_sheet  = 0
          if(i_rank_y.lt.n_procs_y)then
            if(i_BC_sheet_moveSouth.ge.i_BC_sheet_stay)then
              i_BC_sheet  = -1
            endif
            if(i_BC_sheet_moveNorth.ge.i_BC_sheet_moveSouth.and.
     &         i_BC_sheet_moveNorth.ge.i_BC_sheet_stay)then
              i_BC_sheet  = 1
            endif
          endif
          i_BC(i_rank_y) = i_BC_sheet
c          if(rank_id.eq.0)
c     &    print*,'rank_id, i_BC_column ',rank_id, i_BC_column,
c     &    i_BC_column_moveSouth,i_BC_column_stay,i_BC_column_moveNorth
        enddo

        !- Transmit movements to column -
        call MPI_BCast(i_BC, n_procs_max, MPI_INTEGER,
     &                 0, grid_comm, ierr)
        i_North_Boundary_Change = i_BC(rank_idy+1)
c        print*,'rank_id, i_North_Boundary_Change ',
c     &          rank_id, i_North_Boundary_Change
c
c        !stop


        call MPI_SENDRECV(
     &    i_North_Boundary_Change , 1, MPI_INTEGER, north, 1,
     &    i_South_Boundary_Change , 1, MPI_INTEGER, south, 1,
     &    grid_comm, status, ierr)
        if(i_North_Boundary_Change.eq.1)then
          ymax_rank  = ymax_rank  + two_h
          ymax_local = ymax_local + two_h
          ncy_local  = ncy_local + 1
          nsheet_local = ncx_local*ncy_local
          nct_local = nsheet_local*ncz_local
        end if
        if(i_North_Boundary_Change.eq.-1)then
          ymax_rank  = ymax_rank  - two_h
          ymax_local = ymax_local - two_h
          ncy_local  = ncy_local - 1
          nsheet_local = ncx_local*ncy_local
          nct_local = nsheet_local*ncz_local
        end if
        if(i_South_Boundary_Change.eq.1)then
          ymin_rank  = ymin_rank  + two_h
          ymin_local = ymin_local + two_h
          ncy_local  = ncy_local - 1
          nsheet_local = ncx_local*ncy_local
          nct_local = nsheet_local*ncz_local
        end if
        if(i_South_Boundary_Change.eq.-1)then
          ymin_rank  = ymin_rank  - two_h
          ymin_local = ymin_local - two_h
          ncy_local  = ncy_local + 1
          nsheet_local = ncx_local*ncy_local
          nct_local = nsheet_local*ncz_local
        end if
c      end if

      if(nct_local .ge. nct_max) then
        print*
        print*,'ERROR in Adapt_MPI_Check_3D.f'
        print*,'No. of cells exceeds nct_max in common.3D'
        print*,'rank_id  ',rank_id
        print*,'nct_local ',nct_local
        print*,'nct_max   ',nct_max
        print*
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif 
      
c      if(itime.ge.itime_check
c     &   .and.itime/n_itime_Adapt*n_itime_Adapt.eq.itime)then
        do i=0,n_procs-1
          if(i.eq.rank_id.and.itime.gt.itime_check.and.
     &      (i_North_Boundary_Change.ne.0.or.
     &       i_South_Boundary_Change.ne.0)   )then
            print*
            print*,'Index_check - Adaptive Check, itime ', itime
            print*,'rank_id, north, south ',rank_id, north, south 
            print*,'i_North&South_Boundary_Change ',
     &              i_North_Boundary_Change, i_South_Boundary_Change
            print*,'nFP_local, nFP_local_North, nFP_local_South ',
     &              nFP_local, nFP_local_North, nFP_local_South
            !print*,'i_North_Boundary_Change ',i_North_Boundary_Change
            !print*,'i_South_Boundary_Change ',i_South_Boundary_Change
            !print*,'nFP_local      ',nFP_local
            !print*,'nFP_local_North ',nFP_local_North
            !print*,'two_h, 8.0*h ',two_h, 8.0*h
            print*,'ymin_rank_old, ymin_rank ',ymin_rank_old, ymin_rank
            print*,'ymax_rank_old, ymax_rank ',ymax_rank_old, ymax_rank
            print*,'ncx_local_old, ncx_local ',ncx_local_old, ncx_local
            print*,'nsheet_local_old, nsheet_local ',
     &              nsheet_local_old, nsheet_local
            print*
          end if
          !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
        end do
        !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
        !stop
c      end if
      
      
      end subroutine
