c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.
      
      subroutine SendRecv_Data_toWest

      include 'common.3D'

      integer iabsolute_BP_going_West(nGuestmax)
      integer iabsolute_BP_from_East(nGuestmax)
      
      !-- Derived DataTypes --
      real(kind=kind_XYZ) P_xyz_data_going_West(nGuestmax,3)
      real(kind=kind_XYZ) P_xyz_data_from_East(nGuestmax,3)
      real P_data_going_West(nGuestmax,38)
      real P_data_from_East(nGuestmax,38)
      real BP_data_going_West(nGuestmax,13)
      real BP_data_from_East(nGuestmax,13)
      real Tau_data_going_West(nGuestmax,6)
      real Tau_data_from_East(nGuestmax,6)

      integer nps_in_lx_2(4), nps_from_East(4)
c      integer BP_DataType, P_DataType, Tau_DataType, deltaptb_DType
c
      
      itime_check = 10e8   !10e8   !0   !10e8
      irank_check = 0


      !SendRecv numbers of Guest Particles Between Host Processors

!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then 
!         if(rank_id.eq.0.and.itime.ge.0)then   !if(rank_id.eq.-10)then
!           print*
!           print*,'In SendRecv_Data'
!           !print*,'Particles to be exported'
!         end if
!         if(rank_id.eq.irank_check)then   !if(rank_id.eq.-10)then
!           nb_going_Below0 = nb_going_Below
!           np_going_Below0 = np_going_Below
!         end if
!         do i=0,n_procs-1
!           if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
!             print*
!             print*,'rank_id ', rank_id
!             print*,'itime   ', itime
!             print*,'nb_local       ',nb_local
!             print*,'np_local       ',np_local
!             print*,'nbf_in_lx_2    ',nbf_in_lx_2
!             print*,'nbfreem_in_lx_2  ',nbfreem_in_lx_2
!             print*,'nb_in_lx_2     ',nb_in_lx_2
!             print*,'nFP_in_lx_2    ',nFP_in_lx_2
!             print*,'np_in_lx_2     ',np_in_lx_2
!             print*,'nbf_in_lx_ncx_localminus1 ',
!      &              nbf_in_lx_ncx_localminus1
!             print*,'nbfreem_in_lx_ncx_localminus1  ',
!      &              nbfreem_in_lx_ncx_localminus1
!             print*,'nb_in_lx_ncx_localminus1   ',
!      &              nb_in_lx_ncx_localminus1
!             print*,'nFP_in_lx_ncx_localminus1  ',
!      &              nFP_in_lx_ncx_localminus1
!             print*,'np_in_lx_ncx_localminus1   ',
!      &              np_in_lx_ncx_localminus1
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!         call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
!       endif

      !-- Zero non-communicating processes --
      if(rank_idx.eq.0
     &   .and.(.NOT.iCartTop_periodicity(1)))then
        nbf_from_West = 0
        nbfm_from_West = 0
        nbfreem_from_West = 0
        np_from_West = 0
        if(n_procs_x.eq.1)then
          nbf_from_East = 0
          nbfm_from_East = 0
          nbfreem_from_East = 0
          np_from_East = 0
          nps_from_East = 0
        end if
      else if(rank_idx.eq.n_procs_x-1
     &   .and.(.NOT.iCartTop_periodicity(1)))then
        nbf_from_East = 0
        nbfm_from_East = 0
        nbfreem_from_East = 0
        np_from_East = 0
        nps_from_East = 0
        if(n_procs_x.eq.1)then
          nbf_from_West = 0
          nbfm_from_West = 0
          nbfreem_from_West = 0
          np_from_West = 0
        end if
      end if

!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.-10)then
!           print*,'Cartesian Topology'
!         end if
!         do i=0,n_procs-1
!           if(i.eq.-rank_id)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, east, west ',rank_id, east, west 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       end if
            
      !--- East-West Communications ---
        nbf_from_West        = 0  
        nbfm_from_West       = 0  
        nbfreem_from_West    = 0  
        np_from_West         = 0 

      !Send to West Neighbour
c        call MPI_SENDRECV(
c     &    nbf_in_lx_2  , 1, MPI_INTEGER, west, 104,
c     &    nbf_from_East, 1, MPI_INTEGER, east, 104,
c     &    grid_comm, status, ierr)
c        call MPI_SENDRECV(
c     &    nbfm_in_lx_2   , 1, MPI_INTEGER, west, 106,
c     &    nbfm_from_East , 1, MPI_INTEGER, east, 106,
c     &    grid_comm, status, ierr)
c        call MPI_SENDRECV(
c     &    nbfreem_in_lx_2   , 1, MPI_INTEGER, west, 106,
c     &    nbfreem_from_East , 1, MPI_INTEGER, east, 106,
c     &    grid_comm, status, ierr)
c        call MPI_SENDRECV(
c     &    np_in_lx_2    , 1, MPI_INTEGER, west, 107,
c     &    np_from_East  , 1, MPI_INTEGER, east, 107,
c     &    grid_comm, status, ierr)

      !- Pack incoming particle numbers -
      nps_in_lx_2(1) = nbf_in_lx_2
      nps_in_lx_2(2) = nbfm_in_lx_2
      nps_in_lx_2(3) = nbfreem_in_lx_2
      nps_in_lx_2(4) = np_in_lx_2
      !Send to West Neighbour
        call MPI_SENDRECV(
     &    nps_in_lx_2    , 1, iInt_IntegerType4, west, 107,
     &    nps_from_East  , 1, iInt_IntegerType4, east, 107,
     &    grid_comm, status, ierr)
      !- UNPack incoming particle numbers -
      nbf_from_East      = nps_from_East(1)
      nbfm_from_East     = nps_from_East(2)
      nbfreem_from_East  = nps_from_East(3)
      np_from_East       = nps_from_East(4)
      
          
      !- Zero additional counter for travelling guest particles (from East to Down) -          
      !if(n_procs_z.gt.1.or.iCartTop_periodicity(3))then
        nbf_in_lz_2_temp = 0
        nbfm_in_lz_2_temp = 0
        nbfreem_in_lz_2_temp = 0
      !endif      
      !- Zero additional counter for travelling guest particles (from East to Down) -          
      !if(n_procs_y.gt.1.or.iCartTop_periodicity(2))then
        nbf_in_ly_2_temp = 0
        nbfm_in_ly_2_temp = 0
        nbfreem_in_ly_2_temp = 0
      !endif      

      !With no Open Boundary Water Particles (OBWPs)
      nb_from_East = nbfreem_from_East
      nb_from_West = nbfreem_from_West
          
      !-- Set Particle Numbers of Image on each Processor --    
      nbf_image_local  = nbf_local   + nbf_from_East   + nbf_from_West
      nbfm_image_local = nbfm_local
     &                      + nbfm_from_East + nbfm_from_West
      nbfreem_image_local= nbfreem_local
     &                      + nbfreem_from_East + nbfreem_from_West
      nb_image_local   = nb_local + nb_from_East + nb_from_West
      np_image_local   = np_local + np_from_East + np_from_West     
       
      nbp1_image_local = nb_image_local + 1
      
      !Error catching
      if(np_from_East.gt.nGuestmax)then
        print*
        print*,'ERROR in SendRecv_Data_toWest.f'
        print*,'np_from_East.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_East ',np_from_East
        print*,'nGuestmax    ',nGuestmax
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      else if(np_from_West.gt.nGuestmax)then
        print*
        print*,'ERROR in SendRecv_Data_toWest.f'
        print*,'np_from_West.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_West ',np_from_West
        print*,'nGuestmax    ',nGuestmax
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      end if
      if(np_image_local.gt.npar)then
        print*
        print*,'ERROR in SendRecv_Data_toWest.f'
        print*,'np_image_local.gt.npar'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_image_local ',np_image_local
        print*,'npar           ',npar
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif
      if(nbfreem_image_local.ne.nb_image_local)then
        print*
        print*,'ERROR in SendRecv_Data_toWest.f'
        print*,'nbfreem_image_local.ne.nb_image_local'
        print*,'rank_id, itime ',rank_id, itime
        print*,'nbfreem_image_local ',nbfreem_image_local
        print*,'nb_image_local    ',nb_image_local
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif
            
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
498   format(5('  ',I5,'    '))     
      !--------------------------

      !Synchronize ip_index pointer array for resident particles
      nb_image_temp  =  nb_local
      nFP_image_temp = np_local - nb_local
            
      nbf_image_temp         =  nbf_local
      nbfm_image_temp        =  nbfm_local - nbf_local
      nbfreem_image_temp     =  nbfreem_local - nbfm_local

            
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---
      
      !-- Pack Particle data to be sent West--
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!       if(itime.ge.itime_check.and.rank_id.eq.1)then
!         print*
!         print*,'Packing Particle Data to go West'
!         print*,'rank_id, np_in_lx_2, nb_going_West, np_going_West ',
!      &          rank_id, np_in_lx_2, nb_going_West, np_going_West
!       end if
      nbfm_start    = nbf_in_lx_2 + 1
      nbfreem_start = nbfm_in_lx_2 + 1
      nFP_start     = nb_going_West + 1
      do ii=1,np_going_West     !do ii=1,np_in_lx_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_West_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_West_2(ii-nbf0_in_lx_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_West_3(ii-(nbf0_in_lx_2+nbfm0_in_lx_2))
        !if(ii.le.nb_going_West)then        
        !  i = iBP_going_West(ii)
        else
          i = iFP_going_West(ii-nb_going_West)
        end if        
        P_xyz_data_going_West(ii,1)  = xp(i)
        P_xyz_data_going_West(ii,2)  = yp(i)
        P_xyz_data_going_West(ii,3)  = zp(i)        
        P_data_going_West(ii,1)  = up(i)
        P_data_going_West(ii,2)  = vp(i)     
        P_data_going_West(ii,3)  = wp(i)        
        P_data_going_West(ii,4)  = rhop(i)
        P_data_going_West(ii,5)  = p(i)        
        P_data_going_West(ii,6)  = pm(i)        
        P_data_going_West(ii,7)  = pVol(i)        
        P_data_going_West(ii,8)  = cs(i)        
        P_data_going_West(ii,9)  = Volrhou(i)
        P_data_going_West(ii,10) = Volrhov(i)
        P_data_going_West(ii,11) = Volrhow(i)        
        P_data_going_West(ii,12) = Volrho(i)
        P_data_going_West(ii,13) = dudx_CSPH(i)
        P_data_going_West(ii,14) = dudy_CSPH(i)
        P_data_going_West(ii,15) = dudz_CSPH(i)
        P_data_going_West(ii,16) = dvdx_CSPH(i)
        P_data_going_West(ii,17) = dvdy_CSPH(i)
        P_data_going_West(ii,18) = dvdz_CSPH(i)
        P_data_going_West(ii,19) = dwdx_CSPH(i)
        P_data_going_West(ii,20) = dwdy_CSPH(i)
        P_data_going_West(ii,21) = dwdz_CSPH(i)
        P_data_going_West(ii,22) = drhodx_CSPH(i)
        P_data_going_West(ii,23) = drhody_CSPH(i)
        P_data_going_West(ii,24) = drhodz_CSPH(i)
        P_data_going_West(ii,25) = drhoudx_CSPH(i)
        P_data_going_West(ii,26) = drhoudy_CSPH(i)
        P_data_going_West(ii,27) = drhoudz_CSPH(i)
        P_data_going_West(ii,28) = drhovdx_CSPH(i)
        P_data_going_West(ii,29) = drhovdy_CSPH(i)
        P_data_going_West(ii,30) = drhovdz_CSPH(i)
        P_data_going_West(ii,31) = drhowdx_CSPH(i)
        P_data_going_West(ii,32) = drhowdy_CSPH(i)
        P_data_going_West(ii,33) = drhowdz_CSPH(i)
        P_data_going_West(ii,34) = VolTotalE(i)        
        P_data_going_West(ii,35) = TotalE(i)
        P_data_going_West(ii,36) = dTotalEdx_CSPH(i)
        P_data_going_West(ii,37) = dTotalEdy_CSPH(i)
        P_data_going_West(ii,38) = dTotalEdz_CSPH(i)
        Tau_data_going_West(ii,1) = tau_xx_uno_rho2(i)
        Tau_data_going_West(ii,2) = tau_xy_uno_rho2(i)
        Tau_data_going_West(ii,3) = tau_xz_uno_rho2(i)
        Tau_data_going_West(ii,4) = tau_yy_uno_rho2(i)
        Tau_data_going_West(ii,5) = tau_yz_uno_rho2(i)
        Tau_data_going_West(ii,6) = tau_zz_uno_rho2(i)
        if(ii.le.nb_going_West)then
          BP_data_going_West(ii,1) = xnb(i)
          BP_data_going_West(ii,2) = ynb(i)
          BP_data_going_West(ii,3) = znb(i)
          BP_data_going_West(ii,4) = xtb(i)
          BP_data_going_West(ii,5) = ytb(i)
          BP_data_going_West(ii,6) = ztb(i)
          BP_data_going_West(ii,7) = xsb(i)
          BP_data_going_West(ii,8) = ysb(i)
          BP_data_going_West(ii,9) = zsb(i)
          BP_data_going_West(ii,10) = deltaptb(i,1)
          BP_data_going_West(ii,11) = deltaptb(i,2)
          BP_data_going_West(ii,12) = deltapsb(i,1)
          BP_data_going_West(ii,13) = deltapsb(i,2)
          iabsolute_BP_going_West(ii) = iabsolute_BP_Pointer_index(i)
        end if
c        !-- Debug Code------
c        if(rank_id.eq.1.and.itime.ge.itime_check)then
c          print*,'ii, i',ii, i
cc          print*,'xp(i), yp(i), zp(i) ',
cc     &            xp(i), yp(i), zp(i) 
c          print*,
c     &          'P_xyz_data_going_West(ii, 1 & 2 & 3)  '
c          print*,P_xyz_data_going_West(ii,1),
c     &           P_xyz_data_going_West(ii,2),
c     &           P_xyz_data_going_West(ii,3)     
c          print*,
c     &          'P_data_going_West(ii,1), P_data_going_West(ii,2) '
c          print*,P_data_going_West(ii,1), P_data_going_West(ii,2),
c     &           P_data_going_West(ii,3), P_data_going_West(ii,4)
c          print*,P_data_going_West(ii,5)
c          print*,P_data_going_West(ii,6), P_data_going_West(ii,7)
c          print*,P_data_going_West(ii,8)
c          if(i_particleType(i).le.2)then
c            print*,'iabsolute_BP_going_West(ii) ',
c     &              iabsolute_BP_going_West(ii)
c          end if
c        end if
      end do
     
      !call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
            
c            
c      !- Send to West Neighbour -
      call MPI_SENDRECV(
     & iabsolute_BP_going_West, nb_going_West , MPI_INTEGER, west, 131,
     & iabsolute_BP_from_East , nb_from_East  , MPI_INTEGER, east, 131,
     & grid_comm, status, ierr)      
      !---Combined SendRecv's to West Neighbour ---
      call MPI_SENDRECV(
     &  P_xyz_data_going_West  , 1 , iP_xyzDataTypeA, west, 143,
     &  P_xyz_data_from_East   , 1 , iP_xyzDataTypeA, east, 143,
     &  grid_comm, status, ierr)
      call MPI_SENDRECV(
     &  P_data_going_West   , 1 , iP_DataTypeSRC, west, 144,
     &  P_data_from_East    , 1 , iP_DataTypeSRC, east, 144,
     &  grid_comm, status, ierr)
      call MPI_SENDRECV(
     &  BP_data_going_West, 1 , iBP_DataType  , west, 145,
     &  BP_data_from_East , 1 , iBP_DataType  , east, 145,
     &  grid_comm, status, ierr)
      call MPI_SENDRECV(
     &  Tau_data_going_West, 1 , iTau_DataType  , west, 146,
     &  Tau_data_from_East , 1 , iTau_DataType  , east, 146,
     &  grid_comm, status, ierr)

c      call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
      
c      !-- Debug Code------
c      if(itime.ge.itime_check)then
c        if(rank_id.eq.0)then
c          print*
c          print*,'In SendRecv_Data'
c          print*,'Particles numbers to be swapped'
c        end if
c        do i=0,n_procs-1
c          if(i.eq.-rank_id)then
c            write(*,*)
c            write(*,*),'rank_id ', rank_id
c            write(*,*),'nb_going_East ',nb_going_East
c            write(*,*),'np_going_East ',np_going_East
c            write(*,*),'nb_going_West ',nb_going_West
c            write(*,*),'np_going_West ',np_going_West
c            write(*,*),'nb_from_East ',nb_from_East
c            write(*,*),'np_from_East ',np_from_East
c            write(*,*),'nb_from_West ',nb_from_West
c            write(*,*),'np_from_West ',np_from_West
c          end if
c          call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
c        end do
c      end if



496   format(i6,3('     ',i5,'  '),'  ',2('   ',e12.6))  

      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
                       
c      !-- Debug Code------
c      if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-12)then
c        print*
c        print*,'Unpacking Particle Data from East'
c        print*,'rank_id, itime, np_from_East ',
c     &          rank_id,itime,np_from_East
c        print*,'nbf_local       ',nbf_local
c        print*,'nbfm_local ',nbfm_local
c        print*,'nbfreem_local     ',nbfreem_local
c        print*,'nb_local        ',nb_local
c        print*,'nbf_from_East       ',nbf_from_East
c        print*,'nbfm_from_East ',nbfm_from_East
c        print*,'nbfreem_from_East     ',nbfreem_from_East
c        print*,'nb_from_East        ',nb_from_East
c        print*,'nbf_image_local       ',nbf_image_local
c        print*,'nbfm_image_local ',nbfm_image_local
c        print*,'nbfreem_image_local     ',nbfreem_image_local
c        print*,'nb_image_local        ',nb_image_local
c        print*,'nbf_image_temp       ',nbf_image_temp
c        print*,'nbfm_image_temp ',nbfm_image_temp
c        print*,'nbfreem_image_temp     ',nbfreem_image_temp
c        print*,'nb_image_temp        ',nb_image_temp
c        print*,'np_local ',np_local
c        print*,'kk_highest ',kk_highest
c        print*,'ii, i_image, nb/FP_image_temp, ip_index_#P_local,
c     &xp(i_image), zp(i_image)'
c      end if
      !-- Unpack Particle data --
      zmin_rank_minus_h_over_1000 = zmin_rank- h_over_1000
      do ii=1,np_from_East
        !i_image = np_local + np_from_West + ii    !CORRECT THIS FOR DISORDERED PARTICLES!!!!
        !i_image = kk_highest + np_from_West + ii
        i_image = kk_highest + ii
        xp(i_image)             = P_xyz_data_from_East(ii,1)
        yp(i_image)             = P_xyz_data_from_East(ii,2)
        zp(i_image)             = P_xyz_data_from_East(ii,3)
        up(i_image)             = P_data_from_East(ii,1)
        vp(i_image)             = P_data_from_East(ii,2)
        wp(i_image)             = P_data_from_East(ii,3)
        rhop(i_image)           = P_data_from_East(ii,4)
        p(i_image)              = P_data_from_East(ii,5)
        pm(i_image)             = P_data_from_East(ii,6)
        pVol(i_image)           = P_data_from_East(ii,7)
        cs(i_image)             = P_data_from_East(ii,8)
        Volrhou(i_image)        = P_data_from_East(ii,9)
        Volrhov(i_image)        = P_data_from_East(ii,10)
        Volrhow(i_image)        = P_data_from_East(ii,11)   
        Volrho(i_image)         = P_data_from_East(ii,12)
        dudx_CSPH(i_image)      = P_data_from_East(ii,13)
        dudy_CSPH(i_image)      = P_data_from_East(ii,14)
        dudz_CSPH(i_image)      = P_data_from_East(ii,15)
        dvdx_CSPH(i_image)      = P_data_from_East(ii,16)
        dvdy_CSPH(i_image)      = P_data_from_East(ii,17)
        dvdz_CSPH(i_image)      = P_data_from_East(ii,18)
        dwdx_CSPH(i_image)      = P_data_from_East(ii,19)
        dwdy_CSPH(i_image)      = P_data_from_East(ii,20)
        dwdz_CSPH(i_image)      = P_data_from_East(ii,21)
        drhodx_CSPH(i_image)    = P_data_from_East(ii,22)
        drhody_CSPH(i_image)    = P_data_from_East(ii,23)
        drhodz_CSPH(i_image)    = P_data_from_East(ii,24)
        drhoudx_CSPH(i_image)   = P_data_from_East(ii,25)
        drhoudy_CSPH(i_image)   = P_data_from_East(ii,26)
        drhoudz_CSPH(i_image)   = P_data_from_East(ii,27)
        drhovdx_CSPH(i_image)   = P_data_from_East(ii,28)
        drhovdy_CSPH(i_image)   = P_data_from_East(ii,29)
        drhovdz_CSPH(i_image)   = P_data_from_East(ii,30)
        drhowdx_CSPH(i_image)   = P_data_from_East(ii,31)
        drhowdy_CSPH(i_image)   = P_data_from_East(ii,32)
        drhowdz_CSPH(i_image)   = P_data_from_East(ii,33)
        VolTotalE(i_image)      = P_data_from_East(ii,34)        
        TotalE(i_image)         = P_data_from_East(ii,35)
        dTotalEdx_CSPH(i_image) = P_data_from_East(ii,36)
        dTotalEdy_CSPH(i_image) = P_data_from_East(ii,37)
        dTotalEdz_CSPH(i_image) = P_data_from_East(ii,38)
        tau_xx_uno_rho2(i_image) = Tau_data_from_East(ii,1)
        tau_xy_uno_rho2(i_image) = Tau_data_from_East(ii,2)
        tau_xz_uno_rho2(i_image) = Tau_data_from_East(ii,3)
        tau_yy_uno_rho2(i_image) = Tau_data_from_East(ii,4)
        tau_yz_uno_rho2(i_image) = Tau_data_from_East(ii,5)
        tau_zz_uno_rho2(i_image) = Tau_data_from_East(ii,6)
        iflag(i_image) = 1
        !-- Append to ip_index pointer arrays --
        if(ii.le.nb_from_East)then
          if(i_image.gt.nb_max)then
            print*
            print*,'ERROR in SendRecv_Data_toWest_3D.f'
            print*,'i_image.gt.nb_max '
            print*,'Adjust nb_max in common.3D'
            print*,'rank_id, itime ',rank_id, itime
            print*,'i_image   ',i_image
            print*,'nb_max    ',nb_max
            print*
            stop
          endif
          nb_image_temp = nb_image_temp + 1
          ip_index_BP_local(nb_image_temp) = i_image
          !Normals
          xnb(i_image)        = BP_data_from_East(ii,1)
          ynb(i_image)        = BP_data_from_East(ii,2)
          znb(i_image)        = BP_data_from_East(ii,3)
          xtb(i_image)        = BP_data_from_East(ii,4)
          ytb(i_image)        = BP_data_from_East(ii,5)
          ztb(i_image)        = BP_data_from_East(ii,6)
          xsb(i_image)        = BP_data_from_East(ii,7)
          ysb(i_image)        = BP_data_from_East(ii,8)
          zsb(i_image)        = BP_data_from_East(ii,9)
          deltaptb(i_image,1) = BP_data_from_East(ii,10)
          deltaptb(i_image,2) = BP_data_from_East(ii,11)
          deltapsb(i_image,1) = BP_data_from_East(ii,12)
          deltapsb(i_image,2) = BP_data_from_East(ii,13)
          iabsolute_BP_Pointer_index(i_image)=iabsolute_BP_from_East(ii)
c          !- Array & Pointer printout -
c          if(rank_id.eq.0.and.itime.ge.itime_check)then
c            write(*,496),ii, i_image, nb_image_temp,  
c     &       ip_index_BP_local(nb_image_temp),xp(i_image), zp(i_image)
c            print*,'P_data_from_East'
c            write(*,*)P_xyz_data_from_East(ii,1), 
c     &                P_xyz_data_from_East(ii,2),
c     &                P_xyz_data_from_East(ii,3)
c            write(*,*)P_data_from_East(ii,1), P_data_from_East(ii,2)
c            write(*,*)P_data_from_East(ii,3), P_data_from_East(ii,4)
c            write(*,*)P_data_from_East(ii,5), P_data_from_East(ii,6)
c            write(*,*)P_data_from_East(ii,7)
c            write(*,*)'iabsolute_BP_Pointer_index(i_image) ',
c     &                 iabsolute_BP_Pointer_index(i_image)
c          end if
          !- Indexing -
          nb_image_temp2 = nb_image_temp - nb_local
          if(nb_image_temp2.le.nbf_from_East)then
            i_particleType(i_image) = 1   !Fixed Boundary Particle
            nbf_image_temp = nbf_image_temp + 1
            ip_index_BP_local_1(nbf_image_temp) = i_image
          else if(nb_image_temp2.le.nbfm_from_East)then
            i_particleType(i_image) = 2   !Forced Moving Boundary Particle
            nbfm_image_temp = nbfm_image_temp + 1
            ip_index_BP_local_2(nbfm_image_temp) = i_image
          else if(nb_image_temp2.le.nbfreem_from_East)then
            i_particleType(i_image) = 3   !Free Moving Boundary Particle
            nbfreem_image_temp = nbfreem_image_temp + 1
            ip_index_BP_local_3(nbfreem_image_temp) = i_image
          end if
        else
          nFP_image_temp = nFP_image_temp + 1
          ip_index_FP_local(nFP_image_temp) = i_image
c          !- Array & Pointer printout -
c          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-12)then
c            write(*,496),ii, i_image, nFP_image_temp,  
c     &       ip_index_FP_local(nFP_image_temp),xp(i_image), zp(i_image)
c            print*,'P_data_from_East'
c            write(*,*)P_xyz_data_from_East(ii,1), 
c     &                P_xyz_data_from_East(ii,2),
c     &                P_xyz_data_from_East(ii,3)
c            write(*,*)P_data_from_East(ii,1), P_data_from_East(ii,2) 
c            write(*,*)P_data_from_East(ii,3), P_data_from_East(ii,4)
c            write(*,*)P_data_from_East(ii,5), P_data_from_East(ii,6)
c            write(*,*)P_data_from_East(ii,7)
c          end if
          i_particleType(i_image) = 4   !Fluid Particle
        end if
        if(n_procs_z.gt.1.or.iCartTop_periodicity(3))then   !- 2-D & 3-D MPI Cartesian Topology -
          if(zp(i_image).lt.zmin_rank+two_h)then
            if(i_particleType(i_image).lt.4)then          !Boundary Particle
              if(i_particleType(i_image).lt.2)then        !Fixed BP 
                nbf_in_lz_2_temp = nbf_in_lz_2_temp + 1
                nb_in_lz_2 = nb_in_lz_2 + 1
                nbf0_in_lz_2 = nbf0_in_lz_2 + 1
                iBP_going_Below_1(nbf0_in_lz_2) = i_image
              else if(i_particleType(i_image).lt.3)then   !Forced Moving BP
                nbfm_in_lz_2_temp  = nbfm_in_lz_2_temp  + 1
                nb_in_lz_2 = nb_in_lz_2 + 1
                nbfm0_in_lz_2 = nbfm0_in_lz_2 + 1
                iBP_going_Below_2(nbfm0_in_lz_2) = i_image
              else !if(i_particleType(i_image).eq.3)then    !Free moving BP
                nbfreem_in_lz_2_temp  = nbfreem_in_lz_2_temp  + 1
                nb_in_lz_2 = nb_in_lz_2 + 1
                nbfreem0_in_lz_2 = nbfreem0_in_lz_2 + 1
                iBP_going_Below_3(nbfreem0_in_lz_2) = i_image
              end if                
              iBP_going_Below(nb_in_lz_2) = i_image
            else if(i_particleType(i_image).eq.4)then      !Fluid Particle
              nFP_in_lz_2  = nFP_in_lz_2   + 1
                if(nFP_in_lz_2.gt.nGuestmax)then
                  print*
                  print*,'ERROR in SendRecv_Data_toWest.f'
                  print*,'nFP_in_lz_2.gt.nGuestmax'
                  print*,'rank_id, itime ',rank_id, itime
                  print*,'nFP_in_lz_2 ',nFP_in_lz_2
                  print*,'nGuestmax    ',nGuestmax
                  print*,'Increase nGuestmax in common_MPI.3D'
                  call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
                  stop
                end if
              iFP_going_Below(nFP_in_lz_2) = i_image
            endif
          endif
        endif
        if(n_procs_y.gt.1.or.iCartTop_periodicity(2))then  !if(ndim.gt.2)then   !- 3-D MPI Cartesian Topology -
          if(yp(i_image).lt.ymin_rank+two_h.and.
     &       zp(i_image).gt.zmin_rank_minus_h_over_1000)then
            if(i_particleType(i_image).lt.4)then          !Boundary Particle
              if(i_particleType(i_image).lt.2)then        !Fixed BP 
                nbf_in_ly_2_temp = nbf_in_ly_2_temp + 1
                nb_in_ly_2 = nb_in_ly_2 + 1
                nbf0_in_ly_2 = nbf0_in_ly_2 + 1
                iBP_going_South_1(nbf0_in_ly_2) = i_image
              else if(i_particleType(i_image).lt.3)then   !Forced Moving BP
                nbfm_in_ly_2_temp  = nbfm_in_ly_2_temp  + 1
                nb_in_ly_2 = nb_in_ly_2 + 1
                nbfm0_in_ly_2 = nbfm0_in_ly_2 + 1
                iBP_going_South_2(nbfm0_in_ly_2) = i_image
              else !if(i_particleType(i_image).eq.3)then    !Free moving BP
                nbfreem_in_ly_2_temp  = nbfreem_in_ly_2_temp  + 1
                nb_in_ly_2 = nb_in_ly_2 + 1
                nbfreem0_in_ly_2 = nbfreem0_in_ly_2 + 1
                iBP_going_South_3(nbfreem0_in_ly_2) = i_image
              end if                
              iBP_going_South(nb_in_ly_2) = i_image
            else if(i_particleType(i_image).eq.4)then      !Fluid Particle
              nFP_in_ly_2  = nFP_in_ly_2   + 1
               if(nFP_in_ly_2.gt.nGuestmax)then
                  print*
                  print*,'ERROR in SendRecv_Data_toWest.f'
                  print*,'nFP_in_ly_2.gt.nGuestmax'
                  print*,'rank_id, itime ',rank_id, itime
                  print*,'nFP_in_ly_2 ',nFP_in_ly_2
                  print*,'nGuestmax    ',nGuestmax
                  print*,'Increase nGuestmax in common_MPI.3D'
                  call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
                  stop
                end if

              iFP_going_South(nFP_in_ly_2) = i_image
            endif
          endif
        endif
c        !-- Debug Code------
c        if(rank_id.eq.0.and.itime.ge.itime_check)then
c          print*,'i_particleType(i_image) ',i_particleType(i_image)
c          print*
c        endif
      end do
      
      kk_highest_after_SR_toWest = kk_highest + np_from_East
      if(ndim.gt.2.and.i_call_UpDown.eq.0)then
        kk_highest_after_SR_toBelow = kk_highest_after_SR_toWest
      endif


      if(n_procs_z.gt.1.or.iCartTop_periodicity(3))then   !if(ndim.gt.1)then
        !Make numbers absolute in reference to start of local list
        !This makes the nomenclature consistent
        nbf_in_lz_2 = nbf_in_lz_2  + nbf_in_lz_2_temp
        nbfm_in_lz_2 = nbfm_in_lz_2 + nbf_in_lz_2_temp
     &                              + nbfm_in_lz_2_temp
        nbfreem_in_lz_2 = nbfreem_in_lz_2 + nbf_in_lz_2_temp
     &                                    + nbfm_in_lz_2_temp
     &                                    + nbfreem_in_lz_2_temp
        np_in_lz_2 = nFP_in_lz_2  + nb_in_lz_2
c        nbfm_in_lz_ncz_localminus1 = nbf_in_lz_ncz_localminus1 
c     &                            + nbfm_in_lz_ncz_localminus1
c        nbfreem_in_lz_ncz_localminus1 = nbfm_in_lz_ncz_localminus1 
c     &                             + nbfreem_in_lz_ncz_localminus1
c        np_in_lz_ncz_localminus1 = nFP_in_lz_ncz_localminus1
c     &                           + nb_in_lz_ncz_localminus1
        nb_going_Above = nb_in_lz_ncz_localminus1
        np_going_Above = np_in_lz_ncz_localminus1
        nb_going_Below = nb_in_lz_2
        np_going_Below = np_in_lz_2
      endif      
      if(n_procs_y.gt.1.or.iCartTop_periodicity(2))then   !if(ndim.gt.2)then
        !Make numbers absolute in reference to start of local list
        !This makes the nomenclature consistent
        nbf_in_ly_2 = nbf_in_ly_2  + nbf_in_ly_2_temp
        nbfm_in_ly_2 = nbfm_in_ly_2 + nbf_in_ly_2_temp
     &                              + nbfm_in_ly_2_temp
        nbfreem_in_ly_2 = nbfreem_in_ly_2 + nbf_in_ly_2_temp
     &                                    + nbfm_in_ly_2_temp
     &                                    + nbfreem_in_ly_2_temp
        np_in_ly_2 = nFP_in_ly_2  + nb_in_ly_2
c        nbfm_in_ly_ncy_localminus1 = nbf_in_ly_ncy_localminus1 
c     &                            + nbfm_in_ly_ncy_localminus1
c        nbfreem_in_ly_ncy_localminus1 = nbfm_in_ly_ncy_localminus1 
c     &                             + nbfreem_in_ly_ncy_localminus1
c        np_in_ly_ncy_localminus1 = nFP_in_ly_ncy_localminus1
c     &                           + nb_in_ly_ncy_localminus1
        nb_going_North = nb_in_ly_ncy_localminus1
        np_going_North = np_in_ly_ncy_localminus1
        nb_going_South = nb_in_ly_2
        np_going_South = np_in_ly_2
      endif      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
c      !-- Printout Check for Image ---
c      if(itime.ge.itime_check.and.rank_id.eq.0)then   !if(rank_id.eq.-11)then
c      !if(itime.ge.0.and.rank_id.eq.2)then   !if(rank_id.eq.-11)then
c        print*
c        print*,'rank_id         ',rank_id
c        print*,'itime           ',itime
c        print*,'nbf_local       ',nbf_local
c        print*,'nbfm_local ',nbfm_local
c        print*,'nbfreem_local     ',nbfreem_local
c        print*,'nb_local        ',nb_local
c        print*,'np_local        ',np_local
c        print*,'nbf_from_West ',nbf_from_West
c        print*,'nbf_from_East ',nbf_from_East
c        print*,'nbfm_from_West  ',nbfm_from_West
c        print*,'nbfm_from_East  ',nbfm_from_East
c        print*,'nbfreem_from_West  ',nbfreem_from_West
c        print*,'nbfreem_from_East  ',nbfreem_from_East
c        print*,'nb_from_West    ',nb_from_West
c        print*,'nb_from_East    ',nb_from_East
c        print*,'np_from_West    ',np_from_West
c        print*,'np_from_East    ',np_from_East
c        print*,'nbf_image_local ',nbf_image_local
c        print*,'nbfm_image_local  ',nbfm_image_local
c        print*,'nbfreem_image_local      ',nb_image_local
c        print*,'nb_image_local   ',nb_image_local
c        print*,'np_image_local   ',np_image_local
c        print*,'nb_image_temp    ',nb_image_temp
c        print*,'nFP_image_temp   ',nFP_image_temp
c        if(1.eq.1)then
c          do ipcount=1,np_image_local
c            !if(ipcount.le.nb_image_local)then
c            !  i = ip_index_BP_local(ipcount)
c            !else
c            !  i = ip_index_FP_local(ipcount-nb_image_local)
c            !end if
c            if(ipcount.le.nbf_image_local)then
c              i = ip_index_BP_local_1(ipcount)
c            else if(ipcount.le.nbfm_image_local)then
c              i = ip_index_BP_local_2(ipcount-nbf_image_local)
c            else if(ipcount.le.nbfreem_image_local)then
c              i = ip_index_BP_local_3(ipcount-nbfm_image_local)
c            else
c              i = ip_index_FP_local(ipcount-nb_image_local)
c            end if
c            write(*,494),'ipcount -> i, xp, zp ',
c     &                  ipcount,i,xp(i),zp(i)
c          end do
c        end if
c        !call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
c      end if
494   format(1(a21,'  '),2(i6,'  '),2(f16.10,' '))
495   format(2(i6,'  '),8(f10.6,' '))
      
c      call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
      
c      !-- Debug Code------
c      if(1.eq.1.and.rank_id.eq.0.and.itime.ge.itime_check)then
c        print*
c        print*,'Image Normals, end of SendRecv_Data, rank_id ',rank_id
c        print*,
c     &' i    xp     zp     xnb     znb   deltaptb(i,1)   deltaptb(i,2)'
c        do ipcount = 1, nb_image_local 
c          i = ip_index_BP_local(ipcount)
c          write(*,495),ipcount,i,xp(i),zp(i),xnb(i),znb(i),
c     &               xtb(i),ztb(i),deltaptb(i,1),deltaptb(i,2)
c        end do
c        print*
c      end if
c      !--------------------

      !-  Check FLOATING BODY indices -
c      if(num_FB.gt.0)then
        nbfreem_start = nbfreem_local + (nbfm_image_local - nbfm_local)
        do ipcount = nbfreem_start+1,nbfreem_image_local
          i = ip_index_BP_local_3(ipcount - nbfm_image_local)
          i_absolute = iabsolute_BP_Pointer_Index(i)
          i_num_FB = i_FB_Pointer_Info(i_absolute)
          !- Error catching -
          if(i_num_FB.lt.1)then
            print*,'ERROR in SendRecv_Data_Conservative_toWest_3D.f'
            print*,'i_num_FB.lt.1'
            print*,'rank_id, itime ',rank_id, itime
            print*,'nbfm_local     ',nbf_local
            print*,'nbfm_local+1   ',nbfm_local+1
            print*,'nbfreem_local  ',nbfreem_local
            print*,'nbf_image_local+1     ',nbf_image_local+1
            print*,'nbfm_image_local+1    ',nbfm_image_local+1
            print*,'nbfreem_start+1       ',nbfreem_start+1
            print*,'nbfreem_image_local   ',nbfreem_image_local
            print*,'ipcount, i     ',ipcount, i
            print*,'i_absolute     ',i_absolute
            print*,'i_num_FB       ',i_num_FB
            print*,'i_particleType(i) ',i_particleType(i)
            print*,'xp, yp, zp',xp(i),yp(i),zp(i)
            stop
          endif
c          xp_temp = BP_xyz_Data(i_absolute,1)
c          yp_temp = BP_xyz_Data(i_absolute,2)
c          zp_temp = BP_xyz_Data(i_absolute,3)
c          xp_minus_R0(i) = xp_temp - Box_XC(i_num_FB)
c          yp_minus_R0(i) = yp_temp - Box_YC(i_num_FB)
c          zp_minus_R0(i) = zp_temp - Box_ZC(i_num_FB)
        enddo
c      endif
      
      !stop
      
      end subroutine
