c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine SendRecv_MLS_Matrices_toSouth
c
      include 'common.3D'
              
      real beta_MLS_going_South(nGuestmax,4) 
      real beta_MLS_from_North(nGuestmax,4)

      itime_check = 10e8   !0   !10e8   !0   !
      
!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.0)then
!           print*
!           print*,'In update_kernelSummations'
!           print*,'Cartesian Topology'
!         end if
!         do i=0,n_procs-1
!           if(itime.ge.itime_check.and.i.eq.rank_id-1)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, north, south ',rank_id, north, south 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       end if
      
      !-- Zero non-communicating processes --
      if(rank_idy.eq.0
     &   .and.(.NOT.iCartTop_periodicity(2)))then
        nb_going_South = 0
        np_going_South = 0
        if(n_procs_y.eq.1)then
          nb_going_North = 0
          np_going_North = 0
        end if
      else if(rank_idy.eq.n_procs_y-1
     &   .and.(.NOT.iCartTop_periodicity(2)))then
        nb_going_North = 0
        np_going_North = 0
        if(n_procs_y.eq.1)then
          nb_going_South = 0
          np_going_South = 0
        end if
      end if

!      !- Diagnostic Info -
!       if(itime.ge.itime_check.and.rank_id.eq.0)then
!         print*
!         print*,'In update_kernelSummations'
!         print*
!         print*,'rank_id        ',rank_id
!         print*,'nb_local       ',nb_local
!         print*,'np_local       ',np_local
!         print*,'nb_from_North   ',nb_from_North
!         print*,'np_from_North   ',np_from_North
!         print*,'nb_from_South   ',nb_from_South
!         print*,'np_from_South   ',np_from_South
!         print*,'nb_image_local ',nb_image_local
!         print*,'np_image_local ',np_image_local        
!         print*,'nb_going_North   ',nb_going_North
!         print*,'np_going_North   ',np_going_North
!         print*,'nb_going_South   ',nb_going_South
!         print*,'np_going_South   ',np_going_South
!         print*,'north, south      ',north, south 
!       end if
!       if(itime.ge.itime_check.and.rank_id.eq.5)then
!         print*,'In update_kernelSummations'
!         print*
!         print*,'rank_id        ',rank_id
!         print*,'nb_local       ',nb_local
!         print*,'np_local       ',np_local
!         print*,'nb_from_North   ',nb_from_North
!         print*,'np_from_North   ',np_from_North
!         print*,'nb_from_South   ',nb_from_South
!         print*,'np_from_South   ',np_from_South
!         print*,'nb_image_local ',nb_image_local
!         print*,'np_image_local ',np_image_local        
!         print*,'nb_going_North   ',nb_going_North
!         print*,'np_going_North   ',np_going_North
!         print*,'nb_going_South   ',nb_going_South
!         print*,'np_going_South   ',np_going_South
!         print*,'north, south      ',north, south 
!       end if
                
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---


!      !- Diagnostic Info -
!       if(itime.ge.itime_check.and.rank_id.eq.1)then
!         print*
!         print*,'Packing Particle Data to go South'
!         print*,'rank_id, np_in_lz_2, nb_going_South, np_going_South ',
!      &          rank_id, np_in_lz_2, nb_going_South, np_going_South
!       end if
      nbfm_start    = nbf_in_ly_2 + 1
      nbfreem_start = nbfm_in_ly_2 + 1
      nFP_start     = nb_going_South + 1
      do ii=1,np_going_South     !do ii=1,np_in_ly_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_South_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_South_2(ii-nbf0_in_ly_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_South_3(ii-(nbf0_in_ly_2+nbfm0_in_ly_2))
        !if(ii.le.nb_going_South)then        
        !  i = iBP_going_South(ii)
        else
          i = iFP_going_South(ii-nb_going_South)
        end if                
        beta_MLS_going_South(ii,1) = beta0_MLS(i)            
        beta_MLS_going_South(ii,2) = beta1x_MLS(i)            
        beta_MLS_going_South(ii,3) = beta1y_MLS(i)            
        beta_MLS_going_South(ii,4) = beta1z_MLS(i)            
          
!           if(itime.ge.itime_check.and.rank_id.eq.0)then
!             print*,
!      &      ii,i_image,xp(i_image),zp(i_image),
!      &      beta_MLS_going_South(ii,1)
!           end if         
        end do  
      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      !--- SendRecv kernel summation information back to original processors ---
      !Send data back South
        call MPI_SENDRECV(
     &   beta_MLS_going_South, 1,  iMLS_DataType2  , south, 1,
     &   beta_MLS_from_North , 1,  iMLS_DataType2  , north, 1,
     &   grid_comm, status, ierr)
            
            
      !-- Unpack Data & Update summations on original processors
      
      !-- UnPack Particle data from North--
!       if(itime.ge.itime_check.and.rank_id.eq.4)then
!         print*,'Unpacking data originally sent South'
!         print*,'np_from_North ',np_from_North
!         print*,'Summing sum_wab'
!         print*,'ii, i, sum_wab(i), beta_MLS_from_North(ii,1)'
!       end if
      do ii=1,np_from_North
        i_image = kk_highest_after_SR_toBelow + ii   !For kk_highest, see index_check.f
        beta0_MLS (i_image) = beta_MLS_from_North(ii,1)
        beta1x_MLS(i_image) = beta_MLS_from_North(ii,2)
        beta1y_MLS(i_image) = beta_MLS_from_North(ii,3)
        beta1z_MLS(i_image) = beta_MLS_from_North(ii,4)

c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          write(*,494),ii, i, sum_wab(i), beta_MLS_from_North(ii,1)
c        end if        
      end do

494   format(2(i5,'    '),4(f12.6,'    '))      
495   format(2(i5,'    '),4(e12.6,'    '))      
      
        
      end subroutine
