c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine SendRecv_filteredDensities_toSouth
c
      include 'common.3D'
              
      real filteredDensities_going_South(nGuestmax,5) 
      real filteredDensities_from_North(nGuestmax,5) 

       itime_check = 10e8   !0   !10e8   !0   !
!       
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.0)then
!           print*
!           print*,'In update_kernelSummations'
!           print*,'Cartesian Topology'
!         end if
!         do i=0,n_procs-1
!           if(itime.ge.itime_check.and.i.eq.rank_id-1)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, north, south ',rank_id, north, south 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       end if
      
      !-- Zero non-communicating processes --
      if(rank_idy.eq.0
     &   .and.(.NOT.iCartTop_periodicity(2)))then
        nb_going_South = 0
        np_going_South = 0
        if(n_procs_y.eq.1)then
          nb_going_North = 0
          np_going_North = 0
        end if
      else if(rank_idy.eq.n_procs_y-1
     &   .and.(.NOT.iCartTop_periodicity(2)))then
        nb_going_North = 0
        np_going_North = 0
        if(n_procs_y.eq.1)then
          nb_going_South = 0
          np_going_South = 0
        end if
      end if

                
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---


!      !- Diagnostic Info -
!       if(itime.ge.itime_check.and.rank_id.eq.17)then
!         print*
!         print*,'Packing Particle Data to go South'
!         print*,'rank_id, np_in_ly_2, nb_local, np_local ',
!      &          rank_id, np_in_ly_2, nb_local, np_local
!         print*,'nbf_in_ly_2    ',nbf_in_ly_2
!         print*,'nbfm_in_ly_2   ',nbfm_in_ly_2
!         print*,'nbf0_in_ly_2    ',nbf0_in_ly_2
!         print*,'nbfm0_in_ly_2   ',nbfm0_in_ly_2
!         print*,'nb_going_South ',nb_going_South
!         print*,'np_going_South ',np_going_South
!       end if
      nbfm_start    = nbf_in_ly_2 + 1
      nbfreem_start = nbfm_in_ly_2 + 1
      nFP_start     = nb_going_South + 1
      do ii=1,np_going_South     !do ii=1,np_in_ly_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_South_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_South_2(ii-nbf0_in_ly_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_South_3(ii-(nbf0_in_ly_2+nbfm0_in_ly_2))
        !if(ii.le.nb_going_South)then        
        !  i = iBP_going_South(ii)
        else
          i = iFP_going_South(ii-nb_going_South)
        end if
        if(i.lt.1.or.nbf_in_ly_2.ne.nbf0_in_ly_2)then
          print*
          print*,'ERROR in SendRecv_filteredDensities_toSouth'
          print*,'i.lt.1: ii, i = ',ii,i
          print*,'itime, rank_id ',itime, rank_id
          print*,'rank_id, np_in_ly_2, nb_local, np_local ',
     &            rank_id, np_in_ly_2, nb_local, np_local
          print*,'rank_idx/y/z ',rank_idx, rank_idy, rank_idz
          print*,'nbf_in_ly_2     ',nbf_in_ly_2
          print*,'nbfm_in_ly_2    ',nbfm_in_ly_2
          print*,'nbfreem_in_ly_2 ',nbfreem_in_ly_2
          print*,'nbf0_in_ly_2     ',nbf0_in_ly_2
          print*,'nbfm0_in_ly_2    ',nbfm0_in_ly_2
          print*,'nbfreem0_in_ly_2 ',nbfreem0_in_ly_2
          print*,'nbfm_start     ',nbfm_start
          print*,'nbfreem_start  ',nbfreem_start
          print*,'nFP_start      ',nFP_start
          print*,'nb_going_South ',nb_going_South
          print*,'np_going_South ',np_going_South
          stop
        endif                
        filteredDensities_going_South(ii,1) = rhop(i)            
        filteredDensities_going_South(ii,2) = p(i)            
        filteredDensities_going_South(ii,3) = pVol(i)            
        filteredDensities_going_South(ii,4) = cs(i)            
        filteredDensities_going_South(ii,5) = TEp(i)            
          
!           if(itime.ge.itime_check.and.rank_id.eq.17)then
!             print*,
!      &      ii,i,xp(i),yp(i),zp(i),
!      &      filteredDensities_going_South(ii,1)
!           end if         
        end do  
      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      !--- SendRecv kernel summation information back to original processors ---
      !Send data back South
      call MPI_SENDRECV(
     & filteredDensities_going_South, 1, i_filteredDensityType, south,1,
     & filteredDensities_from_North , 1, i_filteredDensityType, north,1,
     &   grid_comm, status, ierr)
            
            
      !-- Unpack Data & Update summations on original processors
      
!       !-- UnPack Particle data from North--
!       if(itime.ge.itime_check.and.rank_id.eq.4)then
!         print*,'Unpacking data originally sent South'
!         print*,'np_from_North ',np_from_North
!         print*,'Summing sum_wab'
!         print*,'ii, i, sum_wab(i), filteredDensities_from_North(ii,1)'
!       end if
      do ii=1,np_from_North
        i_image = kk_highest_after_SR_toBelow + ii   !For kk_highest, see index_check.f
        rhop(i_image) = filteredDensities_from_North(ii,1)
        p   (i_image) = filteredDensities_from_North(ii,2)
        pVol(i_image) = filteredDensities_from_North(ii,3)
        cs  (i_image) = filteredDensities_from_North(ii,4)
        TEp (i_image) = filteredDensities_from_North(ii,5)

c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          write(*,494),ii, i, sum_wab(i), filteredDensities_from_North(ii,1)
c        end if        
      end do

494   format(2(i5,'    '),4(f12.6,'    '))      
495   format(2(i5,'    '),4(e12.6,'    '))      
      
        
      end subroutine
