c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine densityFilter
       
      include 'common.3D'

      real Amatrix_temp(4,4),Amatrix_temp2(4,4),Ainv_check(4,4)
      real A_input_matrix(4,4), A_LU_equivalent_matrix(4,4)
      real b_input_vector(4)  , x_solution(4)
      real A_MLS_inverse(4,4) , col(4)
       

!      !- Diagnostic Info -
!       itime_check = 10e8   !0    !10e8   !0    !
!       i_rank_check = 1   !0   !1
!       i_ParticleCheck = 941   !2980   !941   !nb_local + 1   !3299   !
!       if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
!         rhop_old = rhop(i_ParticleCheck)
!       endif

      nstart_MLS = nbp1_local   !nstart
      i_MLS_typeMin = 3  
c     -- Zeroing Variables --         
      do ipcount = nstart_MLS,np_local
        i = ip_index_FP_local(ipcount-nb_local)
c        -- Kernel ReNormalisation ARRAYS --
         pVol(i) = pm(i)/rhop(i)

      enddo
      do i=1,npar
         sum_wab(i)  = 0.0
         rhop_sum(i) = 0.0
         rhop_sum_MLS(i) = 0.0
         A_MLS(i,1,1) = 0.0
         A_MLS(i,1,2) = 0.0
         A_MLS(i,1,3) = 0.0
         A_MLS(i,1,4) = 0.0
         A_MLS(i,2,1) = 0.0   !Same as A_MLS(i,1,2)
         A_MLS(i,2,2) = 0.0
         A_MLS(i,2,3) = 0.0
         A_MLS(i,2,4) = 0.0
         A_MLS(i,3,1) = 0.0   !Same as A_MLS(i,1,3)
         A_MLS(i,3,2) = 0.0   !Same as A_MLS(i,2,3)
         A_MLS(i,3,3) = 0.0
         A_MLS(i,3,4) = 0.0
         A_MLS(i,4,1) = 0.0   !Same as A_MLS(i,1,4)
         A_MLS(i,4,2) = 0.0   !Same as A_MLS(i,2,4)
         A_MLS(i,4,3) = 0.0   !Same as A_MLS(i,3,4)
         A_MLS(i,4,4) = 0.0
         !- test matrix -
         !A_input_matrix(1,1) =  1.0
         !A_input_matrix(1,2) = -1.0
         !A_input_matrix(1,3) =  2.0
         !A_input_matrix(2,1) =  3.0
         !A_input_matrix(2,2) =  0.0
         !A_input_matrix(2,3) =  1.0
         !A_input_matrix(3,1) =  1.0
         !A_input_matrix(3,2) =  0.0
         !A_input_matrix(3,3) =  2.0
         !b_input_vector(1) = 12.0
         !b_input_vector(2) = 11.0
         !b_input_vector(3) = 2.0
      enddo
                       
      i_MLS_part = 1
      call ac_MLS    !Perform the correction matrix construction

      !construct LU-decomposition matrix
      i_singularMatrix_count = 0
      length = 4
      do ipcount=nstart_MLS,np_local
        i = ip_index_FP_local(ipcount-nb_local)
        !temporary matrix 
        !Self contribution
        A_MLS(i,1,1) = A_MLS(i,1,1) + adh*pm(i)/rhop(i)  !self contribution
        A_MLS_11 = A_MLS(i,1,1)
        A_MLS(i,2,1) = A_MLS(i,1,2)     !Account for A_MLS Symmetry
        A_MLS(i,3,1) = A_MLS(i,1,3)     !Account for A_MLS Symmetry
        A_MLS(i,3,2) = A_MLS(i,2,3)     !Account for A_MLS Symmetry
        A_MLS(i,4,1) = A_MLS(i,1,4)     !Account for A_MLS Symmetry
        A_MLS(i,4,2) = A_MLS(i,2,4)     !Account for A_MLS Symmetry
        A_MLS(i,4,3) = A_MLS(i,3,4)     !Account for A_MLS Symmetry
        do ii = 1,length
          do jj =1,length
            A_input_matrix(ii,jj) = A_MLS(i,ii,jj)
          end do
        end do
        !Amatrix_temp(1,1) = temp  !sum_wab(i)
        i_A_MLS_step = 1
        call LU_decomposition(A_input_matrix,b_input_vector,length,
     &                        A_LU_equivalent_matrix,i_A_MLS_step,
     &                        i_Singular,x_solution,i)      
        !i_Singular = 1
        if(i_Singular.gt.0)then
!           !- Debugging Code -
!           if(i_Singular.gt.1.5)then
!             print*,'singular MLS matrix!'
!             print*,'rank_id, itime = ',rank_id, itime
!             print*,'rank_idx, rank_idy, rank_idz ',
!      &              rank_idx, rank_idy, rank_idz
!             print*,'ipcount, i',ipcount,i
!             print*,'i_particleType(i) ',i_particleType(i)
!             print*,'xp, yp, zp(i), ',xp(i),yp(i),zp(i)
!             print*,'up, vp, wp(i), ',up(i),vp(i),wp(i)
!             print*,'p(i), rhop(i), ',p(i),rhop(i)
!             print*
!             print*,'A_input_matrix '
!             do ii = 1,length
!               write(*,*) (A_input_matrix(ii,jj),jj=1,length)
!             end do
!             print*
!             print*,'A_LU_equivalent_matrix '
!             do ii = 1,length
!               write(*,*) (A_LU_equivalent_matrix(ii,jj),jj=1,length)
!             end do
!             print*
! !             print*,'b_input_vector '
! !             do ii = 1,length
! !               write(*,*) b_input_vector(ii)
! !             end do
!             !stop
!           endif
!         !- End of Debugging Code -
          if(A_MLS_11.eq.0.0)then
            write(80,*) 'A_MLS_11.eq.0.0'
            stop
          end if
          i_singularMatrix_count = i_singularMatrix_count +1
          beta0_MLS(i) = 1.0/A_MLS_11  !1.0/temp   !1.0/sum_wab(i)
          beta1x_MLS(i)= 0.0
          beta1y_MLS(i)= 0.0
          beta1z_MLS(i)= 0.0
          !print*,'Singular i, xp, zp ',i,xp(i),zp(i)
        else
          !Find inverse matrix by solving system n times 
          !on n successive unit vectors (Gerald & Wheatley, Numerical Analysis) 
          i_A_MLS_step = 2
          length = 4
          do jj = 1,4
            do ii =1,4
              b_input_vector(ii) = 0.0
            end do
            b_input_vector(jj) = 1.0
            call LU_decomposition(A_input_matrix,b_input_vector,length,
     &                            A_LU_equivalent_matrix,i_A_MLS_step,
     &                            i_Singular,x_solution,i)
            do ii =1,4
              A_MLS_inverse(ii,jj) = x_solution(ii)
            end do
          end do
          beta0_MLS(i) = A_MLS_inverse(1,1)
          beta1x_MLS(i)= A_MLS_inverse(2,1)
          beta1y_MLS(i)= A_MLS_inverse(3,1)
          beta1z_MLS(i)= A_MLS_inverse(4,1)
          
        endif
        
      end do
     
c      print*,'itime, MLS i_singularMatrix_count ',
c     &        itime, i_singularMatrix_count
      sum_wab = 0.0
      rhop_sum = 0.0
      i_MLS_part = 2
      
      call SendRecv_MLS_Matrices_toWest
      if(i_call_UpDown    .eq.1) call SendRecv_MLS_Matrices_toBelow
      if(i_call_NorthSouth.eq.1) call SendRecv_MLS_Matrices_toSouth  !3-D only

      call ac_MLS   !Perform the corrected density summation
       
      do ipcount=nstart_MLS,np_local
        i = ip_index_FP_local(ipcount-nb_local)
        rhop_sum_MLS(i) = rhop_sum_MLS(i) + beta0_MLS(i)*adh*pm(i)  !self contribution
        rhop(i) = rhop_sum_MLS(i)
        pVol(i) = pm(i)/rhop(i)
        call equation_of_state(rhop(i),TEp(i),p(i),cs(i))
      enddo

      call SendRecv_filteredDensities_toWest
      if(i_call_UpDown    .eq.1) call SendRecv_filteredDensities_toBelow
      if(i_call_NorthSouth.eq.1) call SendRecv_filteredDensities_toSouth  !3-D only

c       !- Debugging code -
c       if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
c        print*
c        print*,'In densityFilter_MLS.f,itime = ',itime
c        i =  i_ParticleCheck
c        print*,'i, xp, zp ',i,xp(i),zp(i)
c        print*,'rhop_old ',rhop_old
c        print*,'rhop(i)  ',rhop(i)
c        print*,'p(i)    ',p(i)
c        print*,'rhop_sum_MLS(i)  ',rhop_sum_MLS(i)
c        print*,'beta0_MLS(i) ',beta0_MLS(i)
c        print*,'A_MLS(i,1,1) ',A_MLS(i,1,1)
c        print*,'pVol(i) ',pVol(i)
c        print*,'nb_local ',nb_local
c        print*,'np_local ',np_local
c        print*
c        !read(*,*)
c        if(itime.ge.100)stop
c       end if

      return
      end

