c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine movingWedge

      include 'common.3D'
      
      real(kind=kind_XYZ) xp_togoto_Root(nb_max)
      real(kind=kind_XYZ) yp_togoto_Root(nb_max)
      real(kind=kind_XYZ) zp_togoto_Root(nb_max)
      integer i_BPP_togoto_Root(nb_max)
      
!       !- Debug Values - 
!       xp_0 = xp(nbfm_local)
!       yp_0 = yp(nbfm_local)
!       zp_0 = zp(nbfm_local)
!       up_0 = up(nbfm_local)
!       vp_0 = vp(nbfm_local)
!       wp_0 = wp(nbfm_local)
      
      i_absolute = 200   !default debug value
      t_factor = 1.0e4   !default debug value

      t = time

      do i = 2,i_RBend
          
        if(t.gt.RBtime(i-1).and.t.le.RBtime(i))then
          t_factor = (t - RBtime(i-1))/(RBtime(i) - RBtime(i-1))

          !do ipcount = nbfp1_local,nb_local
          !  iip = ip_index_BP_local(ipcount)
          nb_togoto_Root = 0
          !do ipcount = 1,nb_local
          ! iip = ip_index_BP_local(ipcount)
          ! if(i_particleType(iip).eq.2)then   !Forced Boundary Particle Motion
          do ipcount = nbf_local + 1,nbfm_local
           iip = ip_index_BP_local_2(ipcount-nbf_local)
           !if(i_particleType(iip).eq.2)then   !Forced Boundary Particle Motion
            i_absolute = iabsolute_BP_Pointer_Index(iip)
            xp_old = xp(iip)
            yp_old = yp(iip)
            zp_old = zp(iip)
            
            !Error Catching
            if(i_absolute-nbf.lt.1)then
              print*
              print*,'ERROR in movingWedge'
              print*,'i_absolute-nbf.lt.1'
              print*,'rank_id, itime ',rank_id,itime
              print*,'ipcount, iip ',ipcount, iip
              print*,'xp, yp, zp(iip) ',xp(iip),yp(iip),zp(iip)
              print*,'i_particleType   ',i_particleType(iip)
              print*,'i_absolute, nbf ',i_absolute, nbf
              print*,'nbf_local       ' ,nbf_local 
              print*,'nbfm_local ' ,nbfm_local 
              print*,'nbMBP_local     ' ,nbMBP_local 
              print*,'nb_local       ',nb_local
              print*,'np_local       ',np_local
              stop
            endif
            
            xp(iip) = xp_Wedge_initial(i_absolute-nbf) - RBxpos(i-1)
     &           - t_factor*(RBxpos(i) - RBxpos(i-1))
            !yp(iip) = yp(iip) !remains unchanged
            zp(iip) = zp_Wedge_initial(i_absolute-nbf)
     &           -(xp_Wedge_initial(i_absolute-nbf) - xp(iip))*bslope
            up(iip) = (xp(iip) - xp_old)/dt 
            vp(iip) = 0.0
            wp(iip) = (zp(iip) - zp_old)/dt 
            
            !Temporary hold
            !xp(iip) = xp_old
            !yp(iip) = yp_old
            !zp(iip) = zp_old
            !up(iip) = 0.0
            !vp(iip) = 0.0
            !wp(iip) = 0.0
        
            !Pack xyz data for sending to Root processor
            nb_togoto_Root = nb_togoto_Root + 1
            xp_togoto_Root(nb_togoto_Root)   = xp(iip)
            yp_togoto_Root(nb_togoto_Root)   = yp(iip)
            zp_togoto_Root(nb_togoto_Root)   = zp(iip)
            i_BPP_togoto_Root(nb_togoto_Root) = 
     &                 iabsolute_BP_Pointer_Index(iip)
          
           !endif   !End of:  if(i_particleType(iip).eq.2)then   !Forced Boundary Particle Motion
          end do
        
          call update_BPInfo_onRoot(
     &       nbf_local+1, nbfm_local, i_BPP_togoto_Root,
     &       xp_togoto_Root, yp_togoto_Root, zp_togoto_Root)
        
        end if
      
      end do
            
c          !- Debugging Code -
c          if(1.eq.2.and.rank_id.eq.0)then
c            iip = 144  !nbfm_local
c            print*
c            print*,'WEDGE POSITION'
c            print*,'iip, rank_id  ',iip,rank_id
c            print*,'itime         ',itime
c            print*,'nbfp1_local, nbfm_local, nb_local ',
c     &              nbfp1_local, nbfm_local, nb_local
c            print*,'xp_0   , yp_0 ,  zp_0   ',xp_0   , yp_0,   zp_0
c            print*,'up_0   , vp_0 ,  wp_0   ',up_0   , vp_0,   wp_0
c            print*,'xp(i), yp(i), zp(i) ',xp(i), yp(i), zp(i)
c            print*,'up(i), vp(i), wp(i) ',up(i), vp(i), wp(i)
c            print*,'i_absolute   ',i_absolute
c            print*,'nbf     ',nbf
c            print*,'xp_Wedge_initial  ',xp_Wedge_initial(i_absolute-nbf)
c            print*,'zp_Wedge_initial  ',zp_Wedge_initial(i_absolute-nbf)
c            print*,'i, RBxpos(i-1), RBxpos(i) ',i,RBxpos(i-1),RBxpos(i)
c            print*,'t, RBtime(i-1), RBtime(i) ',t,RBtime(i-1),RBtime(i)
c            print*,'bslope, t_factor   ',bslope, t_factor
c            print*,'t, time   ',t, time
c            print*
c            if(itime.ge.4)stop
c          end if

      end subroutine
c
c*********************************************************************
c