c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine poute(nf,name,Vortname)
c
      include 'common.3D'

      real x_rank_Positions(n_procs_max)
      integer np_local_ranks(n_procs_max)

      character name*40,Vortname*40
      character Normalsname*40,BPs_ptr*40,MovingObjectsFile*40
      character FMTtemp*9,FMTtemp2*6
      CHARACTER(LEN=5000) :: FMTnprocs
c

      if(i_vort.eq.1)then
        if(i_call_UpDown    .eq.1)then
          call update_vorticitySummations_fromSouth
        endif
        if(i_call_NorthSouth.eq.1)then
          call update_vorticitySummations_fromBelow
        endif
        call update_vorticitySummations_fromWest
      endif

      print*,'in POUTE, rank_id, itime = ',rank_id,itime
     &      ,', np_local = ',np_local
      
      Normalsname  = 'NORMALS.RESTART'
      BPs_ptr = 'BoundaryPs_MPI_Pointer.RESTART'
122   format(9(e16.8,' '),6(i6,' '),3(e16.8,' '))
      open(nf+2,file=BPs_ptr,STATUS='replace')
      if(iBC.eq.1)then
        open(nf+1,file=Normalsname ,STATUS='replace')
        if(rank_id.eq.0)then   !if(iBC.eq.1)then
          xnb_temp = 0.0
          ynb_temp = 0.0
          znb_temp = 0.0
          do i=1,nb
            write(nf+1,122) 
     &      xnb_temp,ynb_temp,znb_temp,   !=0, but these are recalculated on RESTART
     &      xnb_temp,ynb_temp,znb_temp,   !=0, but these are recalculated on RESTART
     &      xnb_temp,ynb_temp,znb_temp,   !=0, but these are recalculated on RESTART
     &      iBP_Pointer_Info(i,1),  !np_local on rank_id
     &      iBP_Pointer_Info(i,2),  !Rank_id
     &      iBP_Pointer_Info(i,3),  !i-1 neighbour
     &      iBP_Pointer_Info(i,4),  !i+1 neighbour
     &      iBP_Pointer_Info(i,5),  !j-1 neighbour
     &      iBP_Pointer_Info(i,6),  !j+1 neighbour
     &      BP_xyz_Data(i,1),
     &      BP_xyz_Data(i,2),
     &      BP_xyz_Data(i,3)
          enddo
        endif
        close(nf+1)
      endif
      close(nf+2)

      do jj = 1,4

        !call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point

        !Set file-write indices
c        if(jj.lt.4)then        !Boundary Particles   (BPs)
c          n_ini = 1
c          n_fin = nb_local
        if(jj.eq.1)then            !Fixed Boundary Particles   (BPs)
          n_ini = 1
          n_fin = nbf_local
        elseif(jj.eq.2)then        !Forced-Motion Boundary Particles   (BPs)
          n_ini = nbf_local+1
          n_fin = nbfm_local
        elseif(jj.eq.3)then        !Free-Motion Boundary Particles   (BPs)
          n_ini = nbfm_local + 1
          n_fin = nb_local
        else if(jj.gt.3)then   !Fluid Particles (FPs)
          n_ini = nb_local + 1
          n_fin = np_local
        end if

        call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
        !Write data from each processor
        do ii=0,n_procs-1
          if(ii.eq.rank_id)then
            !if(1.eq.1)then
            !  print*,'itime ',itime
            !  print*,'jj ',jj
            !  print*,'rank_id ',rank_id
            !  print*,'nbf_local ',nbf_local
            !  print*,'nbMBP_local  ',nbMBP_local
            !  print*,'nb_local   ',nb_local
            !  print*,'np_local   ',np_local
            !  print*,'n_ini= ',n_ini
            !  print*,'n_fin= ',n_fin
            !end if
            if(n_fin.ge.n_ini)then
              !open(nf,file=name,STATUS='old',ACCESS='append')
              open(nf,file=name,STATUS='old',POSITION='append')
              !if(iBC.eq.1)then
                open(nf+2,file=BPs_ptr,
     &               STATUS='old',POSITION='append')
              !endif
              if(jj.eq.1)then   !(ipcount.le.nbf_local)then
                do ipcount=n_ini,n_fin
                  i = ip_index_BP_local_1(ipcount)
                  write(nf,100) xp(i),yp(i),zp(i),up(i),vp(i),wp(i),
     &                  rhop(i),p(i),Volrho(i)
                  !if(iBC.eq.1)then
                    i_absolute = iabsolute_BP_Pointer_Index(i)
                    write(nf+2,*) i_absolute
                  !endif
                enddo
              else if(jj.eq.2)then   !ipcount.le.nbfm_local)then
                do ipcount=n_ini,n_fin
                  i = ip_index_BP_local_2(ipcount-nbf_local)
                  write(nf,100) xp(i),yp(i),zp(i),up(i),vp(i),wp(i),
     &                  rhop(i),p(i),Volrho(i)
                  !if(iBC.eq.1)then
                    i_absolute = iabsolute_BP_Pointer_Index(i)
                    write(nf+2,*) i_absolute
                  !endif
                enddo
              else if(jj.eq.3)then   !ipcount.le.nbMBP_local)then
                do ipcount=n_ini,n_fin
                  i = ip_index_BP_local_3(ipcount-nbfm_local)
                  write(nf,100) xp(i),yp(i),zp(i),up(i),vp(i),wp(i),
     &                  rhop(i),p(i),Volrho(i)
                  !if(iBC.eq.1)then
                    i_absolute = iabsolute_BP_Pointer_Index(i)
                    write(nf+2,*) i_absolute
                  !endif
                enddo
              else
                do ipcount=n_ini,n_fin
                  i = ip_index_FP_local(ipcount-nb_local)
                  write(nf,100) xp(i),yp(i),zp(i),up(i),vp(i),wp(i),
     &                  rhop(i),p(i),Volrho(i)
                enddo
              end if

              close(nf)

              if(iBC.eq.1)then
                close(nf+1)
              endif
              close(nf+2)

             !- Vorticity Output Files -
             if(i_vort.eq.1) then
              open(nf+1,file=Vortname,STATUS='old',POSITION='append')
              if(jj.eq.1)then   !(ipcount.le.nbf_local)then
                do ipcount=n_ini,n_fin
                  i = ip_index_BP_local_1(ipcount)
                  vortx_temp= 0.0  !Vorticity in an x=const plane
                  vorty_temp= 0.0  !Vorticity in an y=const plane
                  vortz_temp= 0.0  !Vorticity in an z=const plane
                  write(nf+1,105) vortx_temp,vorty_temp,vortz_temp
                enddo
              else if(jj.eq.2)then   !ipcount.le.nbfm_local)then
                do ipcount=n_ini,n_fin
                  i = ip_index_BP_local_2(ipcount-nbf_local)
                  vortx_temp= 0.0  !Vorticity in an x=const plane
                  vorty_temp= 0.0  !Vorticity in an y=const plane
                  vortz_temp= 0.0  !Vorticity in an z=const plane
                  write(nf+1,105) vortx_temp,vorty_temp,vortz_temp
                enddo
              else if(jj.eq.3)then   !ipcount.le.nbMBP_local)then
                do ipcount=n_ini,n_fin
                  i = ip_index_BP_local_3(ipcount-nbfm_local)
                  vortx_temp= 0.0  !Vorticity in an x=const plane
                  vorty_temp= 0.0  !Vorticity in an y=const plane
                  vortz_temp= 0.0  !Vorticity in an z=const plane
                  write(nf+1,105) vortx_temp,vorty_temp,vortz_temp
                enddo
              else
                do ipcount=n_ini,n_fin
                  i = ip_index_FP_local(ipcount-nb_local)
                  vortx_temp= curl3x_a(i)-curl3x_b(i)  !Vorticity in an x=const plane
                  vorty_temp= curl3y_a(i)-curl3y_b(i)  !Vorticity in an y=const plane
                  vortz_temp= curl3z_a(i)-curl3z_b(i)  !Vorticity in an z=const plane
                  write(nf+1,105) vortx_temp,vorty_temp,vortz_temp
                enddo
              end if
              close(nf+1)
             endif   !if(i_vort.eq.1) then

            end if
          end if
          call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
        end do

      end do

100   format(12e16.8)
105   format(3e16.8)


      !-- Store globally the numbers of particle types on each processor --
      call MPI_GATHER(xmax_rank                  , 1, MPI_REAL, 
     &                x_rank_Positions(rank_id+1), 1, MPI_REAL, 
     &                0, MPI_COMM_WORLD, ierr)
      call MPI_GATHER(np_local                  , 1, MPI_INTEGER, 
     &                np_local_ranks(rank_id+1) , 1, MPI_INTEGER, 
     &                0, MPI_COMM_WORLD, ierr)

      !- Construct Format editor for file MPI_Partition_Positions.txt'
      !- Make sure Length above is large enough!! (i.e. change 1000 appropriately)
      FMTtemp  = ',1x,e16.6'
      FMTtemp2 = ',1x,i8'

      !- Check length of character FMTnprocs -
      if(12+(n_procs+1)*(len(FMTtemp)+len(FMTtemp2))
     &  .gt.len(FMTnprocs))then
        if(rank_id.eq.0)then
          print*
          print*,'ERROR in Adapt_ini_MPI_2D.f'
          print*,'length of FMTnprocs exceeds defined length'
          print*,'rank_id  ',rank_id
          print*,'len(FMTnprocs) ',len(FMTnprocs)
          print*,
     &    '12+(n_procs+1)*(len(FMTtemp)+len(FMTtemp2))',
     &     12+(n_procs+1)*(len(FMTtemp)+len(FMTtemp2))
          print*
        endif
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif

      write(FMTnprocs,*)'(e16.8,1x,i8',
     &                   (FMTtemp, i_fmt=1,n_procs+1),
     &                   (FMTtemp2,j_fmt=1,n_procs),')'
      if(rank_id.eq.0.and.nf.ne.32)then
           write(38,FMTnprocs)time,itime,xmin_rank,
     &             (x_rank_Positions(jrank) ,jrank=1,n_procs),
     &             (np_local_ranks(krank) ,krank=1,n_procs)
      end if



      if(rank_id.eq.0.and.nf.ne.32)then
        write(*,*) 'In poute_2D, itime = ',itime
        write(*,*) 'time, dt  ',time,dt,'  ok'

        open(19,file='DT',status='old',POSITION='append')
          write(19,*) time, dt_1, dt_2, dt_new
        close(19)
      endif
      !stop

      if(rank_id.eq.0)then
        MovingObjectsFile='Floating_Bodies.RESTART'
        open(nf+2,file=MovingObjectsfile,STATUS='replace')
        write(nf+2,*)iopt_FloatingBodies
        write(nf+2,*)nbfm
        do i_num_FB=1,num_FB
          write(nf+2,*)i_num_FB
          write(nf+2,*)bigMass(i_num_FB)
          write(nf+2,*)bigInertiaXX(i_num_FB),
     &                 bigInertiaYY(i_num_FB),
     &                 bigInertiaZZ(i_num_FB)
          write(nf+2,*)XcylinderDimension(i_num_FB),
     &                 YcylinderDimension(i_num_FB),
     &                 ZcylinderDimension(i_num_FB)
          write(nf+2,*)cylinderDensity(i_num_FB)
          write(nf+2,*)FB_SpecificWeight(i_num_FB)
          write(nf+2,*)friction_coeff(i_num_FB)
          write(nf+2,*)Box_XC(i_num_FB),Box_YC(i_num_FB),
     &                 Box_ZC(i_num_FB)
          write(nf+2,*)bigU(i_num_FB),bigV(i_num_FB),bigW(i_num_FB),
     &       bigOmegaX(i_num_FB),bigOmegaY(i_num_FB),bigOmegaZ(i_num_FB)
          write(nf+2,*)nb_FB(i_num_FB)
        enddo
        close(nf+2)
      endif

      return 
      end

c     ___