c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.


      subroutine rigid_body_motion(i_midPoint)
c
      include 'common.3D'

      double precision dxp_dble1, dxp_dble2 
      double precision dyp_dble1, dyp_dble2 
      double precision dzp_dble1, dzp_dble2 

      real(kind=kind_XYZ) Box_XC_SOI, Box_YC_SOI, Box_ZC_SOI
      
      integer idisp0(n_procs_max), num_FB_temp(n_procs_max)
      real(kind=kind_XYZ) rigidBody_array1(num_FB_max,3)
      real    rigidBody_array2(num_FB_max,12)
      integer irigidBody_array3(num_FB_max)
      real   bigUdot_temp(num_FB_max,n_procs_max)
      real   bigVdot_temp(num_FB_max,n_procs_max)
      real   bigWdot_temp(num_FB_max,n_procs_max)
      real OmegaXdot_temp(num_FB_max,n_procs_max)
      real OmegaYdot_temp(num_FB_max,n_procs_max)
      real OmegaZdot_temp(num_FB_max,n_procs_max)
      real   bigUdot_local(num_FB_max), bigUdot_global(num_FB_max)
      real   bigVdot_local(num_FB_max), bigVdot_global(num_FB_max)
      real   bigWdot_local(num_FB_max), bigWdot_global(num_FB_max)
      real OmegaXdot_local(num_FB_max), OmegaXdot_global(num_FB_max)
      real OmegaYdot_local(num_FB_max), OmegaYdot_global(num_FB_max)
      real OmegaZdot_local(num_FB_max), OmegaZdot_global(num_FB_max)
      
      real bigUdot_init(num_FB_max)
      real bigVdot_init(num_FB_max)
      real bigWdot_init(num_FB_max)      
      real(kind=kind_XYZ) xp_togoto_Root(nb_max)
      real(kind=kind_XYZ) yp_togoto_Root(nb_max)
      real(kind=kind_XYZ) zp_togoto_Root(nb_max)
      integer i_BPP_togoto_Root(nb_max)
      
      real   X_Friction_temp(num_FB_max,n_procs_max)
      real   Y_Friction_temp(num_FB_max,n_procs_max)
      real   Z_Friction_temp(num_FB_max,n_procs_max)
      integer   nb_inFriction_temp(num_FB_max,n_procs_max)

      itime_check = 10e8    !17863    !10e8     !0    !10e8     !
      i_rank_check = 1
      num_FB_check = 1
      i_check = 1362
      
      !- Prepare index array for MPI_GATHERV -
      idisp0(1) = 0
      do i_rank = 0,n_procs-1
        if(i_rank.gt.0)then
          idisp0(i_rank + 1) = idisp0(i_rank) + num_FB_max
        end if
      end do
      
      !- Loop over bodies individually -
      do i_num_FB = 1,num_FB 
       
c        if(i_midPoint.eq.0)then   !if(i_midPoint.eq.0)then
          bigU_old(i_num_FB)      = BigU(i_num_FB)
          bigV_old(i_num_FB)      = BigV(i_num_FB)
          bigW_old(i_num_FB)      = BigW(i_num_FB)
          !bigOmegaY_old(i_num_FB) = bigOmegaY(i_num_FB)
          Box_XC_old(i_num_FB)    = Box_XC(i_num_FB)
          Box_YC_old(i_num_FB)    = Box_YC(i_num_FB)
          Box_ZC_old(i_num_FB)    = Box_ZC(i_num_FB)          
c        endif
        bigOmegaX_old(i_num_FB) = bigOmegaX(i_num_FB)
        bigOmegaY_old(i_num_FB) = bigOmegaY(i_num_FB)
        bigOmegaZ_old(i_num_FB) = bigOmegaZ(i_num_FB)
        bigUdot_local(i_num_FB) = 0.0
        bigVdot_local(i_num_FB) = 0.0
        bigWdot_local(i_num_FB) = 0.0
        OmegaXdot_local(i_num_FB) = 0.0
        OmegaYdot_local(i_num_FB) = 0.0
        OmegaZdot_local(i_num_FB) = 0.0
        OmegaXdot(i_num_FB) = 0.0
        OmegaYdot(i_num_FB) = 0.0
        OmegaZdot(i_num_FB) = 0.0
                
        bigUdot_init(i_num_FB) = X_Friction(i_num_FB)  !Friction forces summed so far (not per unit mass)
        bigVdot_init(i_num_FB) = Y_Friction(i_num_FB)  !Friction forces summed so far (not per unit mass)
        bigWdot_init(i_num_FB) = Z_Friction(i_num_FB)  !Friction forces summed so far (not per unit mass)
        
!         !Diagnostic info
!         if(itime.ge.itime_check.and.rank_id.eq.i_rank_check
!      &                         .and.i_num_FB.eq.num_FB_check)then
!           ipcount = nbfreem_local  !nbfm_local + 13  !nb_FB_local(i_num_FB)
!           if(ipcount.lt.nbfm_local)ipcount = nbfreem_local
!           i = ip_index_BP_local_3(ipcount-nbfm_local)
!           i = i_check  !temp value  !temp value
!           xo_temp = xp(i)
!           yo_temp = yp(i)
!           zo_temp = zp(i)
!           uo_temp = up(i)
!           vo_temp = vp(i)
!           wo_temp = wp(i)
!         endif
        
      enddo   !End of:  do i_num_FB = 1,num_FB 
        
!       if(i_num_FB.eq.num_FB_check.and.rank_id.eq.i_rank_check
!      &                    .and.itime.ge.itime_check)then
!         print*,'i_num_FB, i, xp, zp, ax, az, d_OmegaYdot_local,
!      & BigUdot_local, BigWdot_local, OmegaYdot_local'
!       endif

      do ipcount = nbfm_local+1,nbfreem_local
          i = ip_index_BP_local_3(ipcount-nbfm_local)
          i_absolute = iabsolute_BP_Pointer_Index(i)
          i_num_FB = i_FB_Pointer_Info(i_absolute)
          
          bigUdot_local(i_num_FB) = bigUdot_local(i_num_FB) + ax(i)   !This accn is not per unit mass
          bigVdot_local(i_num_FB) = bigVdot_local(i_num_FB) + ay(i)   !This accn is not per unit mass
          bigWdot_local(i_num_FB) = bigWdot_local(i_num_FB) + az(i)   !This accn is not per unit mass
          OmegaXdot_local(i_num_FB) = OmegaXdot_local(i_num_FB)
     &          + (yp_minus_R0(i)*az(i) - zp_minus_R0(i)*ay(i))
          OmegaYdot_local(i_num_FB) = OmegaYdot_local(i_num_FB)
     &          + (zp_minus_R0(i)*ax(i) - xp_minus_R0(i)*az(i))
          OmegaZdot_local(i_num_FB) = OmegaZdot_local(i_num_FB)
     &          + (xp_minus_R0(i)*ay(i) - yp_minus_R0(i)*ax(i))
     
c          !- Diagnostic printout -
c          if(i_num_FB.eq.num_FB_check.and.rank_id.eq.i_rank_check
c     &                    .and.itime.ge.itime_check)then
c            d_OmegaYdot_local =  ax(i)*zp_minus_R0(i)  
c     &                         - az(i)*xp_minus_R0(i)
c            write(*,255)
c     &      i_num_FB, i, xp(i), zp(i), 
c     &      ax(i), az(i), d_OmegaYdot_local,
c     &      BigUdot_local(i_num_FB), BigWdot_local(i_num_FB), 
c     &      OmegaYdot_local(i_num_FB)
c          endif
c255   format(i1,' ',i5,8(' ',e12.6))
     
      end do

c      !- Diagnostic Printout -
c      if(rank_id.eq.i_rank_check.and.itime.ge.itime_check)then
c        print*
c        print*,'Checking rigid body on root '
c        print*,'nb_inFriction_local ',nb_inFriction_local(num_FB_check)
c        print*,'rank_id, num_FB ',rank_id, num_FB
c        print*,'itime, i_num_FB, bigUdot_local, bigWdot_local, OmegaYdot
c     &_local'
c        do i_num_FB = 1,num_FB
c          print*,itime,i_num_FB, bigUdot_local(i_num_FB), 
c     &           bigWdot_local(i_num_FB), OmegaYdot_local(i_num_FB)
c        enddo
c        print*
c      endif
c      !stop

      !-- Wave force on one side of block --
      BodyForce_x = 0.0
      BodyForce_y = 0.0
      BodyForce_z = 0.0
      BodyForce_x_total = 0.0
      do ipcount = nbfm_local+1,nbfreem_local
        i = ip_index_BP_local_3(ipcount-nbfm_local)
        i_absolute = iabsolute_BP_Pointer_Index(i)
        i_num_FB = i_FB_Pointer_Info(i_absolute)
        if(xp(i).lt.Box_XC(i_num_FB))then
          BodyForce_x = BodyForce_x + ax(i)       !This accn is not per unit mass
        endif
        !BodyForce_x = BodyForce_x + ax(i)        !This accn is not per unit mass
        BodyForce_z = BodyForce_z + az(i)         !This accn is not per unit mass
        BodyForce_x_total = BodyForce_x_total + ax(i)      !This accn is not per unit mass
      end do
      BodyForce_x = BodyForce_x + bigMass(i_num_FB)*grx
      BodyForce_y = BodyForce_y + bigMass(i_num_FB)*gry 
      BodyForce_z = BodyForce_z + bigMass(i_num_FB)*grz 


      !- Gather partial summations for all floating bodies to root processor -
      num_FB_temp = num_FB
      bigUdot_temp(1:num_FB_max,1:n_procs_max) = 0.0
      bigVdot_temp(1:num_FB_max,1:n_procs_max) = 0.0
      bigWdot_temp(1:num_FB_max,1:n_procs_max) = 0.0
      OmegaXdot_temp(1:num_FB_max,1:n_procs_max) = 0.0
      OmegaYdot_temp(1:num_FB_max,1:n_procs_max) = 0.0
      OmegaZdot_temp(1:num_FB_max,1:n_procs_max) = 0.0
      call MPI_GATHERV(
     &    bigUdot_local  , num_FB        , MPI_REAL,
     &    bigUdot_temp   , num_FB_temp, idisp0, MPI_REAL,
     &    0, grid_comm, ierr)
      call MPI_GATHERV(
     &    bigVdot_local  , num_FB        , MPI_REAL,
     &    bigVdot_temp   , num_FB_temp, idisp0, MPI_REAL,
     &    0, grid_comm, ierr)
      call MPI_GATHERV(
     &    bigWdot_local  , num_FB        , MPI_REAL,
     &    bigWdot_temp   , num_FB_temp, idisp0, MPI_REAL,
     &    0, grid_comm, ierr)
      call MPI_GATHERV(
     &    OmegaXdot_local, num_FB        , MPI_REAL,
     &    OmegaXdot_temp , num_FB_temp, idisp0, MPI_REAL,
     &    0, grid_comm, ierr)
      call MPI_GATHERV(
     &    OmegaYdot_local, num_FB        , MPI_REAL,
     &    OmegaYdot_temp , num_FB_temp, idisp0, MPI_REAL,
     &    0, grid_comm, ierr)
      call MPI_GATHERV(
     &    OmegaZdot_local, num_FB        , MPI_REAL,
     &    OmegaZdot_temp , num_FB_temp, idisp0, MPI_REAL,
     &    0, grid_comm, ierr)
        
      X_Friction_temp(1:num_FB_max,1:n_procs_max) = 0.0
      Y_Friction_temp(1:num_FB_max,1:n_procs_max) = 0.0
      Z_Friction_temp(1:num_FB_max,1:n_procs_max) = 0.0
      nb_inFriction_temp(1:num_FB_max,1:n_procs_max) = 0.0
      call MPI_GATHERV(
     &    X_Friction_local  , num_FB             , MPI_REAL,
     &    X_Friction_temp   , num_FB_temp, idisp0, MPI_REAL,
     &    0, grid_comm, ierr)
      call MPI_GATHERV(
     &    Y_Friction_local  , num_FB             , MPI_REAL,
     &    Y_Friction_temp   , num_FB_temp, idisp0, MPI_REAL,
     &    0, grid_comm, ierr)
      call MPI_GATHERV(
     &    Z_Friction_local  , num_FB             , MPI_REAL,
     &    Z_Friction_temp   , num_FB_temp, idisp0, MPI_REAL,
     &    0, grid_comm, ierr)
      call MPI_GATHERV(
     &    nb_inFriction_local  , num_FB             , MPI_INTEGER,
     &    nb_inFriction_temp   , num_FB_temp, idisp0, MPI_INTEGER,
     &    0, grid_comm, ierr)
      !Unpack Data on Root processor
      !if(rank_id.eq.0)then
!         if(itime.ge.itime_check.and.rank_id.eq.-10)then
!           print*,'Unpacking rigid body on root '
!           !print*,'bigUdot_temp'
!           !print*, bigUdot_temp
! c          print*,'i_rank,1: num_FB,bigU-W-dot_global,bigUdot_temp'
!           print*,'ii,rank_id, 
!      &             nb_inFriction_temp(ii,i_rank+1), nb_inFriction(ii)'
!         end if
        bigUdot_global   = 0.0
        bigVdot_global   = 0.0
        bigWdot_global   = 0.0
        OmegaXdot_global = 0.0
        OmegaYdot_global = 0.0
        OmegaZdot_global = 0.0
        X_Friction    = 0.0
        Y_Friction    = 0.0
        Z_Friction    = 0.0
        nb_inFriction = 0.0
        do i_rank = 0,n_procs-1
          do ii = 1,num_FB
            bigUdot_global(ii) = 
     &         bigUdot_global(ii) + bigUdot_temp(ii,i_rank+1)
            bigVdot_global(ii) = 
     &         bigVdot_global(ii) + bigVdot_temp(ii,i_rank+1)
            bigWdot_global(ii) = 
     &         bigWdot_global(ii) + bigWdot_temp(ii,i_rank+1)
            OmegaXdot_global(ii) = 
     &         OmegaXdot_global(ii) + OmegaXdot_temp(ii,i_rank+1)
            OmegaYdot_global(ii) = 
     &         OmegaYdot_global(ii) + OmegaYdot_temp(ii,i_rank+1)
            OmegaZdot_global(ii) = 
     &         OmegaZdot_global(ii) + OmegaZdot_temp(ii,i_rank+1)
            X_Friction(ii) = 
     &         X_Friction(ii) + X_Friction_temp(ii,i_rank+1)
            Y_Friction(ii) = 
     &         Y_Friction(ii) + Y_Friction_temp(ii,i_rank+1)
            Z_Friction(ii) = 
     &         Z_Friction(ii) + Z_Friction_temp(ii,i_rank+1)
            nb_inFriction(ii) = 
     &         nb_inFriction(ii) + nb_inFriction_temp(ii,i_rank+1)
c            print*,ii,rank_id, 
c     &             nb_inFriction_temp(ii,i_rank+1), nb_inFriction(ii)
          end do
        end do
        
!         if(itime.ge.itime_check.and.rank_id.eq.0)then
! c          call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!           print*,'Total Accelerations, itime ',itime
!           do ii = 1,num_FB
!             print*,itime,ii,bigUdot_global(ii),bigWdot_global(ii),
!      &                       OmegaYdot_global(ii)
!           enddo          
!           print*,'Total Frictions, itime ',itime
!           do ii = 1,num_FB
!             print*,itime,ii,X_Friction(ii),Z_Friction(ii),
!      &      nb_inFriction(ii),nb_inFriction_temp(ii,rank_id+1)
!           enddo          
!         endif
        !stop
        
        !- Loop over bodies individually -
        do i_num_FB = 1,num_FB 
       
         !- Include Body Forces -
         bigUdot_global(i_num_FB) = bigUdot_global(i_num_FB)
     &                            + bigMass(i_num_FB)*grx
         bigVdot_global(i_num_FB) = bigVdot_global(i_num_FB)
     &                            + bigMass(i_num_FB)*gry
         bigWdot_global(i_num_FB) = bigWdot_global(i_num_FB)
     &                            + bigMass(i_num_FB)*grz
        
         !- Evaluate non-friction forces -
         if(nb_inFriction(i_num_FB).gt.0)then
          X_nonFriction(i_num_FB) = 
     &         (bigUdot_global(i_num_FB) - X_Friction(i_num_FB))       !Total non-friction forces
     &         /(nb_inFriction(i_num_FB))                              !per particle involved in Friction
          Y_nonFriction(i_num_FB) = 
     &         (bigVdot_global(i_num_FB) - Y_Friction(i_num_FB))       !Total non-friction forces
     &         /(nb_inFriction(i_num_FB))                              !per particle involved in Friction
          Z_nonFriction(i_num_FB) = 
     &         (bigWdot_global(i_num_FB) - Z_Friction(i_num_FB))       !Total non-friction forces
     &         /(nb_inFriction(i_num_FB))                              !per particle involved in Friction
         else
          X_nonFriction(i_num_FB) = 
     &         (bigUdot_global(i_num_FB) !+ bigMass(i_num_FB)*grx 
     &          - X_Friction(i_num_FB))                     !Total non-friction forces
          Y_nonFriction(i_num_FB) = 
     &         (bigVdot_global(i_num_FB) !+ bigMass(i_num_FB)*gry 
     &          - Y_Friction(i_num_FB))                     !Total non-friction forces
          Z_nonFriction(i_num_FB) = 
     &         (bigWdot_global(i_num_FB) !+ bigMass(i_num_FB)*grz 
     &          - Z_Friction(i_num_FB))                     !Total non-friction forces
         endif
        
!         if(itime.ge.itime_check.and.rank_id.eq.i_rank_check
!      &                         .and.i_num_FB.eq.num_FB_check)then
!           print*,'Before Packing Rigid Body Data'
!           print*,'Something else'
!           !i_num_FB = 20
!           print*,'rank_id, i_num_FB ',rank_id, i_num_FB
!           print*,'Box_XC, Box_ZC ',Box_XC(i_num_FB),Box_ZC(i_num_FB)
!           print*,'bigUdot_global(i_num_FB)) ',bigUdot_global(i_num_FB)
!           print*,'bigWdot_global(i_num_FB)  ',bigWdot_global(i_num_FB)
!           print*,'bigMass(i_num_FB) ',bigMass(i_num_FB)
!           print*,'grx, grz ',grx, grz
!           print*,'X_Friction(i_num_FB) ',X_Friction(i_num_FB)
!           print*,'Z_Friction(i_num_FB) ',Z_Friction(i_num_FB)
!           print*,'X_nonFriction(i_num_FB) ',X_nonFriction(i_num_FB)
!           print*,'Z_nonFriction(i_num_FB) ',Z_nonFriction(i_num_FB)
!           print*,'nb_inFriction(i_num_FB) ',nb_inFriction(i_num_FB)
!         endif

         !- Forces per unit mass -
         bigUdot(i_num_FB) = bigUdot_global(i_num_FB)/bigMass(i_num_FB)
         bigVdot(i_num_FB) = bigVdot_global(i_num_FB)/bigMass(i_num_FB)
         bigWdot(i_num_FB) = bigWdot_global(i_num_FB)/bigMass(i_num_FB)
         OmegaXdot(i_num_FB) = OmegaXdot_global(i_num_FB)
     &                        /bigInertiaXX(i_num_FB)
         OmegaYdot(i_num_FB) = OmegaYdot_global(i_num_FB)
     &                        /bigInertiaYY(i_num_FB)
         OmegaZdot(i_num_FB) = OmegaZdot_global(i_num_FB)
     &                        /bigInertiaZZ(i_num_FB)

         Box_XC(i_num_FB) = Box_XC(i_num_FB) + dt2*bigU(i_num_FB)
         Box_YC(i_num_FB) = Box_YC(i_num_FB) + dt2*bigV(i_num_FB)
         Box_ZC(i_num_FB) = Box_ZC(i_num_FB) + dt2*bigW(i_num_FB)
        
         bigU(i_num_FB) = bigU(i_num_FB) + dt2*bigUdot(i_num_FB)
         bigV(i_num_FB) = bigV(i_num_FB) + dt2*bigVdot(i_num_FB)
         bigW(i_num_FB) = bigW(i_num_FB) + dt2*bigWdot(i_num_FB)
         
         bigOmegaX(i_num_FB) = bigOmegaX(i_num_FB)
     &                       + dt2*OmegaXdot(i_num_FB)
         bigOmegaY(i_num_FB) = bigOmegaY(i_num_FB)
     &                       + dt2*OmegaYdot(i_num_FB)
         bigOmegaZ(i_num_FB) = bigOmegaZ(i_num_FB)
     &                       + dt2*OmegaZdot(i_num_FB)
     
        !- Account for periodicity
        if(i_periodicOBs(1).eq.1.or.iCartTop_periodicity(1))then  !Replace Box Centre on other side of domain
          if(Box_XC(i_num_FB).gt.xmax_container)then
            dxp_dble1 = dble(Box_XC(i_num_FB)) - xmax_container_double 
            Box_XC(i_num_FB) = real(dxp_dble1 +xmin_container_double)
          else if(Box_XC(i_num_FB).lt.xmin_container)then
            dxp_dble1 = xmin_container_double - dble(Box_XC(i_num_FB))   
            Box_XC(i_num_FB) = real(xmax_container_double - dxp_dble1)
          end if
        endif
        if(i_periodicOBs(2).eq.1.or.iCartTop_periodicity(2))then  !Replace Box Centre on other side of domain
          if(Box_YC(i_num_FB).gt.ymax_container)then
            dyp_dble1 = dble(Box_YC(i_num_FB)) - ymax_container_double 
            Box_YC(i_num_FB) = real(dyp_dble1 +ymin_container_double)
          else if(Box_YC(i_num_FB).lt.ymin_container)then
            dyp_dble1 = ymin_container_double - dble(Box_YC(i_num_FB))   
            Box_YC(i_num_FB) = real(ymax_container_double - dyp_dble1)
          end if
        endif
        if(i_periodicOBs(3).eq.1.or.iCartTop_periodicity(3))then  !Replace Box Centre on other side of domain
          if(Box_ZC(i_num_FB).gt.zmax_container)then
            dzp_dble1 = dble(Box_ZC(i_num_FB)) - zmax_container_double 
            Box_ZC(i_num_FB) = real(dzp_dble1 +zmin_container_double)
          else if(Box_ZC(i_num_FB).lt.zmin_container)then
            dzp_dble1 = zmin_container_double - dble(Box_ZC(i_num_FB))   
            Box_ZC(i_num_FB) = real(zmax_container_double - dzp_dble1)
          end if
        endif
        
!         if(-itime.ge.itime_check.and.rank_id.eq.i_rank_check
!      &                         .and.i_num_FB.eq.num_FB_check)then
!           print*
!           !i_num_FB = 20
!           print*,'rank_id, i_num_FB ',rank_id, i_num_FB
!           print*,'Box_XC, Box_ZC ',Box_XC(i_num_FB),Box_ZC(i_num_FB)
!           print*,'bigUdot, bigWdot ',bigUdot(i_num_FB),bigWdot(i_num_FB)
!           print*,'bigU, bigW ',bigU(i_num_FB),bigW(i_num_FB)
!           print*,'bigUdot_global(i_num_FB)) ',bigUdot_global(i_num_FB)
!           print*,'bigWdot_global(i_num_FB)  ',bigWdot_global(i_num_FB)
!           print*,'bigMass(i_num_FB) ',bigMass(i_num_FB)
!           print*,'grx, grz ',grx, grz
!         endif

         !- Pack for broadcasting to all procs -
         rigidBody_array1(i_num_FB,1)  = Box_XC(i_num_FB)
         rigidBody_array1(i_num_FB,2)  = Box_YC(i_num_FB)
         rigidBody_array1(i_num_FB,3)  = Box_ZC(i_num_FB)
         rigidBody_array2(i_num_FB,1)  = bigU(i_num_FB)
         rigidBody_array2(i_num_FB,2)  = bigV(i_num_FB)
         rigidBody_array2(i_num_FB,3)  = bigW(i_num_FB)
         rigidBody_array2(i_num_FB,4)  = bigOmegaX(i_num_FB)
         rigidBody_array2(i_num_FB,5)  = bigOmegaY(i_num_FB)
         rigidBody_array2(i_num_FB,6)  = bigOmegaZ(i_num_FB)
         rigidBody_array2(i_num_FB,7)  = X_Friction(i_num_FB)
         rigidBody_array2(i_num_FB,8)  = Y_Friction(i_num_FB)
         rigidBody_array2(i_num_FB,9)  = Z_Friction(i_num_FB)
         rigidBody_array2(i_num_FB,10) = X_nonFriction(i_num_FB)
         rigidBody_array2(i_num_FB,11) = Y_nonFriction(i_num_FB)
         rigidBody_array2(i_num_FB,12) = Z_nonFriction(i_num_FB)
         irigidBody_array3(i_num_FB)   = nb_inFriction(i_num_FB)

        end do   !End of:  do i_num_FB = 1,num_FB
        
        
!        !- Diagnostic Info -
!         if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
!           print*,'Finished Packing Rigid Body Data'
!           print*,'Something else 2'
!           i_num_FB = 1
!           print*,'rank_id, i_num_FB ',rank_id, i_num_FB
!           print*,'rigidBody_array1(i,1) ',rigidBody_array1(i_num_FB,1)
!           print*,'rigidBody_array1(i,2) ',rigidBody_array1(i_num_FB,2)
!           print*,'rigidBody_array2(i,1) ',rigidBody_array2(i_num_FB,1)
!           print*,'rigidBody_array2(i,2) ',rigidBody_array2(i_num_FB,2)
!           print*,'rigidBody_array2(i,3) ',rigidBody_array2(i_num_FB,3)
!           print*,'rigidBody_array2(i,4) ',rigidBody_array2(i_num_FB,4)
!           print*,'rigidBody_array2(i,5) ',rigidBody_array2(i_num_FB,5)
!           print*,'rigidBody_array2(i,6) ',rigidBody_array2(i_num_FB,6)
!           print*,'rigidBody_array2(i,7) ',rigidBody_array2(i_num_FB,7)
!           print*,'irigidBody_array3(i)  ',irigidBody_array3(i_num_FB)
!         endif
      !endif

      !- Broadcast new Rigid Body Data -
      call MPI_BCast(rigidBody_array1, 1, irigidBody_Data_Type1, 
     &               0, grid_comm, ierr)
      call MPI_BCast(rigidBody_array2, 1, irigidBody_Data_Type2, 
     &               0, grid_comm, ierr)
      call MPI_BCast(irigidBody_array3, num_FB_Max, MPI_INTEGER,
     &               0, grid_comm, ierr)
      !stop

      !- Unpack New Rigid Body Data -
      do i_num_FB = 1,num_FB 
        Box_XC(i_num_FB)        = rigidBody_array1(i_num_FB,1)
        Box_YC(i_num_FB)        = rigidBody_array1(i_num_FB,2)
        Box_ZC(i_num_FB)        = rigidBody_array1(i_num_FB,3)
        bigU(i_num_FB)          = rigidBody_array2(i_num_FB,1)
        bigV(i_num_FB)          = rigidBody_array2(i_num_FB,2)
        bigW(i_num_FB)          = rigidBody_array2(i_num_FB,3)
        bigOmegaX(i_num_FB)     = rigidBody_array2(i_num_FB,4)
        bigOmegaY(i_num_FB)     = rigidBody_array2(i_num_FB,5)
        bigOmegaZ(i_num_FB)     = rigidBody_array2(i_num_FB,6)
        X_Friction(i_num_FB)    = rigidBody_array2(i_num_FB,7) 
        Y_Friction(i_num_FB)    = rigidBody_array2(i_num_FB,8)
        Z_Friction(i_num_FB)    = rigidBody_array2(i_num_FB,9)
        X_nonFriction(i_num_FB) = rigidBody_array2(i_num_FB,10) 
        Y_nonFriction(i_num_FB) = rigidBody_array2(i_num_FB,11)
        Z_nonFriction(i_num_FB) = rigidBody_array2(i_num_FB,12)
        nb_inFriction(i_num_FB) = irigidBody_array3(i_num_FB)
        
      end do   !End of:  do i_num_FB = 1,num_FB

c      if(itime.ge.itime_check.and.rank_id.eq.1)then
c        print*,'itime  i_num_FB    U     W   OmegaY   Box_XC   Box_ZC '
c        do i_num_FB = 1,num_FB 
c          print*,itime, i_num_FB,bigU(i_num_FB),bigW(i_num_FB),
c     &           bigOmegaY(i_num_FB),Box_XC(i_num_FB),Box_ZC(i_num_FB)
c        enddo
c      endif
        
      
      i_tgt_count = 0
      do ipcount = nbfm_local+1,nbfreem_local
        i = ip_index_BP_local_3(ipcount-nbfm_local)
        i_absolute = iabsolute_BP_Pointer_Index(i)
        i_num_FB = i_FB_Pointer_Info(i_absolute)
          
        xdot(i) = up(i)
        ydot(i) = vp(i)
        zdot(i) = wp(i)

        xp(i) = xp(i) + dt2*xdot(i)
        yp(i) = yp(i) + dt2*ydot(i)
        zp(i) = zp(i) + dt2*zdot(i)

        xp_minus_R0(i) = xp(i) - Box_XC(i_num_FB)
        yp_minus_R0(i) = yp(i) - Box_YC(i_num_FB)
        zp_minus_R0(i) = zp(i) - Box_ZC(i_num_FB)

         !- Account for periodicity
         !THIS NEEDS TO BE DONE MORE ROBUSTLY!!
         if(i_periodicOBs(1).eq.1.or.iCartTop_periodicity(1))then
           if(xp_minus_R0(i).gt.(0.5*vlx))then
             dxp_dble1 = xmax_container_double-dble(xp(i))
             dxp_dble2 = dble(Box_XC(i_num_FB))-xmin_container_double
             xp_minus_R0(i) = -real(dxp_dble1+dxp_dble2)
           end if
           if(-xp_minus_R0(i).gt.(0.5*vlx))then
             dxp_dble1 = dble(xp(i))-xmin_container_double
             dxp_dble2 = xmax_container_double-dble(Box_XC(i_num_FB))
             xp_minus_R0(i) =  real(dxp_dble1+dxp_dble2)
           end if
         endif
         if(i_periodicOBs(2).eq.1.or.iCartTop_periodicity(2))then
           if(yp_minus_R0(i).gt.(0.5*vly))then
             dyp_dble1 = ymax_container_double-dble(yp(i))
             dyp_dble2 = dble(Box_YC(i_num_FB))-ymin_container_double
             yp_minus_R0(i) = -real(dyp_dble1+dyp_dble2)
           end if
           if(-yp_minus_R0(i).gt.(0.5*vly))then
             dyp_dble1 = dble(yp(i))-ymin_container_double
             dyp_dble2 = ymax_container_double-dble(Box_YC(i_num_FB))
             yp_minus_R0(i) =  real(dyp_dble1+dyp_dble2)
           end if
         endif
         if(i_periodicOBs(3).eq.1.or.iCartTop_periodicity(3))then
           if(zp_minus_R0(i).gt.(0.5*vlz))then
             dzp_dble1 = zmax_container_double-dble(zp(i))
             dzp_dble2 = dble(Box_ZC(i_num_FB))-zmin_container_double
             zp_minus_R0(i) = -real(dzp_dble1+dzp_dble2)
           end if
           if(-zp_minus_R0(i).gt.(0.5*vlz))then
             dzp_dble1 = dble(zp(i))-zmin_container_double
             dzp_dble2 = zmax_container_double-dble(Box_zC(i_num_FB))
             zp_minus_R0(i) =  real(dzp_dble1+dzp_dble2)
           end if
         endif


        up(i) = bigU(i_num_FB) + ( bigOmegaY(i_num_FB)*zp_minus_R0(i)
     &                           - bigOmegaZ(i_num_FB)*yp_minus_R0(i) )
        vp(i) = bigV(i_num_FB) + ( bigOmegaZ(i_num_FB)*xp_minus_R0(i)
     &                           - bigOmegaX(i_num_FB)*zp_minus_R0(i) )
        wp(i) = bigW(i_num_FB) + ( bigOmegaX(i_num_FB)*yp_minus_R0(i)
     &                           - bigOmegaY(i_num_FB)*xp_minus_R0(i) )
        
        !Pack xz data for sending to Root processor
        i_tgt_count = i_tgt_count + 1
        xp_togoto_Root(i_tgt_count)   = xp(i)
        yp_togoto_Root(i_tgt_count)   = yp(i)
        zp_togoto_Root(i_tgt_count)   = zp(i)
        i_BPP_togoto_Root(i_tgt_count) = iabsolute_BP_Pointer_Index(i)

      enddo


      !- Error catching -
      if(i_tgt_count.ne.nbfreem_local - nbfm_local)then
        print*
        print*,'ERROR in rigid_body_motion_MPI_3D.f'
        print*,'i_tgt_count.ne.nbfreem_local - nbfm_local'
        print*,'i_tgt_count     ',i_tgt_count
        print*,'nbfreem_local   ',nbfreem_local
        print*,'nbfm_local      ',nbfm_local
        print*,'rank_id, itime  ',rank_id, itime
        print*,'num_FB     ',num_FB
        print*,'i_num_FB, i_FB_start, nb_FB_local(i_num_FB)'
        stop
      endif

      call update_BPInfo_onRoot(
     &       nbfm_local+1, nbfreem_local, i_BPP_togoto_Root,
     &       xp_togoto_Root, yp_togoto_Root, zp_togoto_Root)


      !- Normals updated at end of step in MPI version -
      
      
!         !-- Diagnostic info --
!         if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
!           i_num_FB = num_FB_check
!           ipcount = nbfreem_local
!           if(ipcount.lt.nbfm_local)ipcount = nbfreem_local
!           i = ip_index_BP_local_3(ipcount-nbfm_local)
!           i = i_check
!           if(i_num_FB.eq.1)then
!             i_FB_start = nbfm_local + 1
!           else
!             i_FB_start = nb_FB_local(i_num_FB-1) + 1
!           end if
!           print*
!           print*,'Subroutine whole_body_motion finished'
!           print*,'rank_id ',rank_id
!           print*,'i_num_FB, num_FB ',i_num_FB, num_FB
!           print*,'itime, bigU, bigW ',
!      &            itime, bigU(i_num_FB), bigW(i_num_FB) 
!           print*,'bigOmegaY ',bigOmegaY(i_num_FB) 
!           if(rank_id.eq.0)then    
!             print*,'bigUdot, bigWdot ',
!      &              bigUdot(i_num_FB), bigWdot(i_num_FB)
!             print*,'OmegaYdot ',
!      &              OmegaYdot(i_num_FB) 
!             print*,'X_Friction, Z_Friction ',
!      &              X_Friction(i_num_FB), Z_Friction(i_num_FB)
!             print*,'X_nonFriction, Z_nonFriction ',
!      &              X_nonFriction(i_num_FB), Z_nonFriction(i_num_FB)
!             print*,'nb_inFriction ',
!      &              nb_inFriction(i_num_FB) 
!           endif
!           print*,'Box_XC, Box_ZC ',
!      &            Box_XC(i_num_FB), Box_ZC(i_num_FB)
!           print*,'i_FB_start, nb_FB_local(i_num_FB) ',
!      &            i_FB_start, nb_FB_local(i_num_FB)
!           print*,'i ',i
!           print*,'xdot(i)',xdot(i)
!           print*,'zdot(i)',zdot(i)
!           print*,'dt2    ',dt2
!           print*,'xo_temp, zo_temp',xo_temp, zo_temp
!           print*,'xp(i)  , zp(i)  ',xp(i), zp(i)   
!           print*,'uo_temp, wo_temp',uo_temp, wo_temp
!           print*,'up(i)  , wp(i)  ',up(i), wp(i)  
!           print*,'ax(i)  , udot(i)',ax(i), udot(i)
!           print*,'az(i)  , wdot(i)',az(i), wdot(i)
!           print*,'xp_minus_R0(i), zp_minus_R0(i) ',
!      &            xp_minus_R0(i), zp_minus_R0(i)
!           print*,'- OmegaY*zp_minus_R0(i) ',
!      &            - bigOmegaY(i_num_FB)*zp_minus_R0(i)
!           print*,'  OmegaY*xp_minus_R0(i) ',
!      &              bigOmegaY(i_num_FB)*xp_minus_R0(i)
!           print*,'xnb(i)  , znb(i)  ',xnb(i), znb(i)
!           !stop
!         end if    !End of:  if(1.eq.2)then
        !stop

      end subroutine
