c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.


      subroutine step

      include 'common.3D'
      

      dt2 = 0.5*dt

c	Predictor- Corrector Method

c  ...  compute acceleration
c

c      !-- Debug Code------
      itime_check = 10e8   !0    !10e8   !0    !
      i_rank_check = 0
      i_ParticleCheck = 118764      
!       itime_check2 = 122
!       if(rank_id.eq.0)then
!         print*,'itime, xmax_container ',itime, xmax_container
!       endif      

      if(rank_id.eq.0.and.itime/10*10 .eq. itime) then
        write(*,*) 'In step:   time = ',time,' itime = ',itime
      endif
       
       nb_image_local      = nb_local
       np_image_local      = np_local
       nbf_image_local     = nbf_local
       nbfm_image_local    = nbfm_local
       nbfreem_image_local = nbfreem_local
       nbp1_local = nb_local + 1
       nfbp1_local = nbf_local + 1     

c      !- Diagnostic Info -
c      if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
c        print*
c        print*,'In step_predictor_corrector.f BEFORE anything'
c        i =  i_ParticleCheck
c        print*,'i, xp, yp, zp ',i,xp(i),yp(i),zp(i)
c        print*,'up, vp, wp    ',up(i),vp(i),wp(i)
c        print*,'rhop(i) ',rhop(i)
c        print*,'p(i)    ',p(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        print*,'pVol(i) ',pVol(i)
c        if(i.lt.nbp1)then
c          print*,'xnb, ynb, znb    ',xnb(i),ynb(i),znb(i)
c          print*,'xtb, ytb, ztb    ',xtb(i),ytb(i),ztb(i)
c          print*,'xsb, ysb, zsb    ',xsb(i),ysb(i),zsb(i)
c        endif
c        print*,'nb_local ',nb_local
c        print*,'np_local ',np_local
c        print*,'nbf_image_local       = ',nbf_image_local
c        print*,'nbfm_image_local = ',nbfm_image_local
c        print*,'nbfreem_image_local     = ',nbfreem_image_local
c        print*,'nb_image_local ',nb_image_local
c        print*,'np_image_local ',np_image_local
cc        if(1.eq.2)then
cc          !-- Image Print-out --
cc          do ipcount=1,np_local
cc            if(ipcount.le.nbf_local)then
cc              i = ip_index_BP_local_1(ipcount)
cc            else if(ipcount.le.nbfm_local)then
cc              i = ip_index_BP_local_2(ipcount-nbf_local)
cc            else if(ipcount.le.nbfreem_local)then
cc              i = ip_index_BP_local_3(ipcount-nbfm_local)
cc            else
cc              i = ip_index_FP_local(ipcount-nb_local)
cc            end if
cc            print*,'ipcount -> i, Type, xp, yp, zp',
cc     &                  ipcount,i,i_particleType(i),xp(i),yp(i),zp(i)
cc          end do
cc        endif
c       print*
c      end if

c     --- Primary Divide for Resident Fluid Particles only ---
       i_resident_0 = 1  !Resident Moving Particles
       call check_limits_3D      
       call ini_divide(2)
       call divide(nbp1_local,np_local,2,i_resident_0)   !3rd argument = kind_p)  

c      --- Primary Divide for Resident Moving Boundary Particles only ---
       !call recover_list   !Why here nad not below? (see step_predictor_corrector_MPI_2D.f)
       if(iopt_movingObject.eq.1)then
         call recover_list
         call divide(nbfp1_local,nb_local,1,i_resident_0)   !3rd argument = kind_p)
       endif

      call divide_ParallelPrep(1)   !argument 1 selects densityFilter option

      call ac         


c
c  ... compute corrections to:
c         (a) rate of change of velocity due to
c             (i)  body forces, and
c             (ii) boundary forces
c
c         (b) rate of change of position (free-surface, XSPH)
c
c
      call correct


! c	To calculate time step 
!       if (ivar_dt.eq.1) then
! 	    call variable_time_step  
! 	    ddt_p=dt_new
!       endif
	
	
c
c  ... predictor
c

      do ipcount=nstart,np_local
         call ipcount_to_i(ipcount,i)
         xo(i)   = xp(i)
         yo(i)   = yp(i)
         zo(i)   = zp(i)
         uo(i)   = up(i)
         vo(i)   = vp(i)
         wo(i)   = wp(i)
         po(i)   = p(i)
         rhoo(i) = rhop(i)
         TEo(i)  = TEp(i)
      enddo

      do ipcount=nb_local+1,np_local
         i = ip_index_FP_local(ipcount-nb_local)
         
         xp(i) = xo(i) + dt2*xdot(i)
         yp(i) = yo(i) + dt2*ydot(i)
         zp(i) = zo(i) + dt2*zdot(i)

         up(i) = uo(i) + dt2*udot(i)
         vp(i) = vo(i) + dt2*vdot(i)
         wp(i) = wo(i) + dt2*wdot(i)
      
      enddo

      do ipcount=nb_local+1,np_local
         call ipcount_to_i(ipcount,i)
         rhop(i) = rhoo(i) + dt2*rdot(i)
         pVol(i) = pm(i)/rhop(i)
c  ...   compute thermal energy
         TEp(i)=TEo(i)+dt2*TEdot(i)
c  ...   compute pressure using the equation of state
         call equation_of_state(rhop(i),TEp(i),p(i),cs(i))
      enddo

      if(iBC.eq.2)then	!Hughes & Grahams 2009 correction 
         nstep_DBC=nstep_DBC+1
         iDBC=0
         if(mod(nstep_DBC,ndt_DBCPerform).eq.0)then
           do ipcount=1,nb_local
              call ipcount_to_i(ipcount,i)
              rhop(i) = rhoo(i) + dt2*rdot(i)
              if (rhop(i).lt.rho0) rhop(i)=rho0
              pVol(i) = pm(i)/rhop(i)
              TEp(i)=TEo(i)+dt2*TEdot(i)
              call equation_of_state(rhop(i),TEp(i),p(i),cs(i))
           enddo  
           iDBC=1
           nstep_DBC=0
         endif
      endif 

!       !-- Debug Code------
!       if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
!         print*
!         print*,'AFTER CORRECT, PREDICTOR, before movingOBJECTS'
!         print*,'rank_id, itime ',rank_id, itime
!         i = i_ParticleCheck  
!         print*,'i = ',i
!         print*,'xp, yp, zp  ',xp(i),yp(i),zp(i)
!         print*,'up, vp, wp  ',up(i),vp(i),wp(i)
!         print*,'rhop, p,  pVol, pm ',rhop(i),p(i) ,pVol(i),pm(i)
!         print*,'rhoo, po, Volo, pm ',rhoo(i),po(i),Volo(i),pm(i)
!         print*,'TEp ',TEp(i)
!         print*,'ar(i) ',ar(i)
!         print*,'ax(i) ',ax(i)
!         print*,'ay(i) ',ay(i)
!         print*,'az(i) ',az(i)
!         print*,'pVol(i), Volo(i) ',pVol(i), Volo(i)
!         print*,'dudx_CSPH(i)',dudx_CSPH(i)
!         print*,'dudz_CSPH(i)',dudz_CSPH(i)
!         print*,'dwdx_CSPH(i)',dwdx_CSPH(i)
!         print*,'dwdz_CSPH(i)',dwdz_CSPH(i)
!         print*,'drhodx_CSPH(i)',drhodx_CSPH(i)
!         print*,'drhody_CSPH(i)',drhody_CSPH(i)
!         print*,'drhodz_CSPH(i)',drhodz_CSPH(i)
!         print*,'sum_wab(i) ',sum_wab(i)
!         write(*,859)'ax(i) ',ax(i)
!         write(*,859)'ay(i) ',ay(i)
!         write(*,859)'az(i) ',az(i)
! 859     format(a7,1x,e16.10)
! c       if(1.eq.2)then 
! c        print*
! c        i = i_ParticleCheck  
! c        print*,'i = ',i
! c        print*,'xp, yp, zp  ',xp(i),yp(i),zp(i)
! c        print*,'up, vp, wp  ',up(i),vp(i),wp(i)
! c        print*,'rhop, p,  pVol, pm ',rhop(i),p(i) ,pVol(i),pm(i)
! c        print*,'rhoo, po, Volo, pm ',rhoo(i),po(i),Volo(i),pm(i)
! c        print*,'TEp ',TEp(i)
! c        print*,'ar(i) ',ar(i)
! c        print*,'ax(i) ',ax(i)
! c        print*,'ay(i) ',ay(i)
! c        print*,'az(i) ',az(i)
! c        print*,'pVol(i), Volo(i) ',pVol(i), Volo(i)
! c       end if
!         !stop
!       end if
c      !---------------------
      
      call movingObjects(0)
      if(iBC.eq.1.and.iopt_FloatingBodies.eq.1)then   !Repulsive Force BC
        i_particleTypeChoice = 3   !Free-moving BPs
        call updateNormals_3D(nbfreem_local+1,nb_local,
     &                          i_particleTypeChoice)   
      end if

c	To calculate time step 
      if (ivar_dt.eq.1) then
	    call variable_time_step  
	    ddt_p=dt_new
      endif
c
c  ...  corrector
c
       nb_image_local      = nb_local
       np_image_local      = np_local
       nbf_image_local     = nbf_local
       nbfm_image_local    = nbfm_local
       nbfreem_image_local = nbfreem_local
       nbp1_local  = nb_local + 1
       nfbp1_local = nbf_local + 1     

c     --- Primary Divide for Resident Fluid Particles only ---
       i_resident_0 = 1  !Resident Moving Particles
       call check_limits_3D      
       call ini_divide(2)
       call divide(nbp1_local,np_local,2,i_resident_0)   !3rd argument = kind_p)  

c      --- Primary Divide for Resident Moving Boundary Particles only ---
       !call recover_list   !Why here and not below? (see step_predictor_corrector_MPI_2D.f)
       if(iopt_movingObject.eq.1)then
         call recover_list
         call divide(nbfp1_local,nb_local,1,i_resident_0)   !3rd argument = kind_p)
       endif

      call divide_ParallelPrep(0)   !argument 1 selects densityFilter option
 
     
      call ac
      call correct

      
!       if (ivar_dt.eq.1) then
!           call variable_time_step  
!           ddt_c=dt_new
!           dt=min(ddt_p,ddt_c)  !Time step to be used in next loop
!       endif
!           if(rank_id.eq.i_rank_check.and.rank_id.eq.0)then
!             print*,'in STEP, rank_id, itime = ',rank_id, itime
!             print*,'ddt_p, ddt_c ',ddt_p,ddt_c
!             print*,'dt ',dt
!           endif
      
      do ipcount=nb_local+1,np_local
         i = ip_index_FP_local(ipcount-nb_local)

         xp(i) = xo(i) + dt2*xdot(i)
         yp(i) = yo(i) + dt2*ydot(i)
         zp(i) = zo(i) + dt2*zdot(i)

         up(i) = uo(i) + dt2*udot(i) 
         vp(i) = vo(i) + dt2*vdot(i) 
         wp(i) = wo(i) + dt2*wdot(i)

      enddo

      do ipcount=nb_local+1,np_local
         call ipcount_to_i(ipcount,i)
         rhop(i) = rhoo(i) + dt2*rdot(i)
         TEp(i)=TEo(i)+dt2*TEdot(i)
      enddo

      if(iBC.eq.2)then
        if(iDBC.eq.1)then	!Hughes & Grahams 2009 correction 
           do ipcount=1,nb_local
              call ipcount_to_i(ipcount,i)
              rhop(i) = rhoo(i) + dt2*rdot(i)
              if (rhop(i).lt.rho0) rhop(i)=rho0
              TEp(i)=TEo(i)+dt2*TEdot(i)
           enddo
        endif
      endif 

      !MPI Version 
      do ipcount=nb_local+1,np_local
         i = ip_index_FP_local(ipcount-nb_local)

         xp(i)   = 2.*xp(i) - xo(i)
         yp(i)   = 2.*yp(i) - yo(i)
         zp(i)   = 2.*zp(i) - zo(i)

         up(i)   = 2.*up(i) - uo(i)
         vp(i)   = 2.*vp(i) - vo(i)
         wp(i)   = 2.*wp(i) - wo(i)

      enddo
      
      do ipcount=nb_local+1,np_local
         call ipcount_to_i(ipcount,i)
         rhop(i) = 2.*rhop(i) - rhoo(i)
         pVol(i) = pm(i)/rhop(i)
c  ...   compute thermal energy
         TEp(i)=2.*TEp(i)-TEo(i)
c  ...   compute pressure using the equation of state
         call equation_of_state(rhop(i),TEp(i),p(i),cs(i))
      enddo
       
      if(iBC.eq.2)then
        if(iDBC.eq.1)then	!Hughes & Grahams 2009 correction 
           do ipcount=1,nb_local
            call ipcount_to_i(ipcount,i)
            rhop(i) = 2.*rhop(i) - rhoo(i)
            if (rhop(i).lt.rho0) rhop(i)=rho0
            pVol(i) = pm(i)/rhop(i)
            TEp(i)=2.*TEp(i)-TEo(i)
            call equation_of_state(rhop(i),TEp(i),p(i),cs(i)) 
           enddo
        endif
      endif 

      call movingObjects(1)

      if (ivar_dt.eq.1) then
          call variable_time_step  
          ddt_c=dt_new
          dt=min(ddt_p,ddt_c)  !Time step to be used in next loop
      endif
!       !- Diagnostic Info -
!       if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
!         print*
!         print*,'In STEP_PREDICTOR_CORRECTOR.f before INDEX_CHECK.f'
!         i =  i_ParticleCheck
!         print*,'rank_id, itime ',rank_id, itime
!         print*,'i, xp, yp, zp ',i,xp(i),yp(i),zp(i)
!         print*,'i, up, vp, wp ',i,up(i),vp(i),wp(i)
!         print*,'rhop(i)',rhop(i)
!         print*,'udot(i)',udot(i)
!         print*,'vdot(i)',vdot(i)
!         print*,'wdot(i)',wdot(i)
!         print*,'rdot(i)',rdot(i)
!         print*,'p(i)    ',p(i)
!         print*,'sum_wab(i) ',sum_wab(i)
!         print*
!       end if
!       stop
      
      call index_check_EastWest
      if(i_call_UpDown    .eq.1) call index_check_UpDown
      if(i_call_NorthSouth.eq.1) call index_check_NorthSouth  !3-D only


c     Normals are calculated in subroutine updateNormals
      if(iBC.eq.1)then   !Repulsive Force BC
       i_particleTypeChoice = 0
       if(i_MPI_Adapt.eq.1)then
         nbf_uN_start = 1             !All BPs
       else
         nbf_uN_start = nbf_local+1   !All moving BPs
       endif
       call updateNormals_3D(nbf_uN_start,nb_local,i_particleTypeChoice)   
      end if

c      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
c      !--- Diagnostic Print out ---
c      if(rank_id.eq.i_rank_check.and.itime.ge.itime_check)then
c          i = i_ParticleCheck  
c          print*
c          print*,'Accn Check, AFTER CORRECT, CORRECTOR'
c          print*,'rank_id, itime ',rank_id, itime
c          print*,'i',i
c          print*,'xp(i)',xp(i)
c          print*,'yp(i)',yp(i)
c          print*,'zp(i)',zp(i)
c          print*,'up(i)',up(i)
c          print*,'vp(i)',vp(i)
c          print*,'wp(i)',wp(i)
c          print*,'p(i)',p(i)
c          print*,'rhop(i)',rhop(i)
c          print*,'udot(i)',udot(i)
c          print*,'vdot(i)',vdot(i)
c          print*,'wdot(i)',wdot(i)
c          print*,'rdot(i)',rdot(i)
c          print*,'dudx_CSPH(i)',dudx_CSPH(i)
c          print*,'dudy_CSPH(i)',dudy_CSPH(i)
c          print*,'dudz_CSPH(i)',dudz_CSPH(i)
c          print*,'dvdx_CSPH(i)',dvdx_CSPH(i)
c          print*,'dvdy_CSPH(i)',dvdy_CSPH(i)
c          print*,'dvdz_CSPH(i)',dvdz_CSPH(i)
c          print*,'dwdx_CSPH(i)',dwdx_CSPH(i)
c          print*,'dwdy_CSPH(i)',dwdy_CSPH(i)
c          print*,'dwdz_CSPH(i)',dwdz_CSPH(i)
c          print*,'drhodx_CSPH(i)',drhodx_CSPH(i)
c          print*,'drhody_CSPH(i)',drhody_CSPH(i)
c          print*,'drhodz_CSPH(i)',drhodz_CSPH(i)
c          print*,'sum_wab(i) ',sum_wab(i)
c          print*,'rhop_sum(i)',rhop_sum(i)
c        !if(itime.ge.itime_check+0)stop
c      end if
      !stop


      end
c

