c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine update_BPInfo_onRoot(
     &       ipcount_start, ipcount_stop, i_pBPP_togoto_Root,
     &       xpp_togoto_Root, ypp_togoto_Root, zpp_togoto_Root)

      !integer status(MPI_STATUS_SIZE) 
      
      include 'common.3D'
      
      integer no_of_movingBPs(n_procs_max)
      integer i_BP_Pointer_temp(nb_max,n_procs_max)

      real(kind=kind_XYZ) xpp_togoto_Root(nb_max)
      real(kind=kind_XYZ) ypp_togoto_Root(nb_max)    
      real(kind=kind_XYZ) zpp_togoto_Root(nb_max)    
      real(kind=kind_XYZ) xp_BP_temp(nb_max,n_procs_max)
      real(kind=kind_XYZ) yp_BP_temp(nb_max,n_procs_max)
      real(kind=kind_XYZ) zp_BP_temp(nb_max,n_procs_max)
      integer i_pBPP_togoto_Root(nb_max), idisp(n_procs_max)

      no_of_movingBPs = 0
      idisp = 0


      !--- Error Catching ---
      if(n_procs.gt.n_procs_max)then
        print*
        print*,'ERROR In update_BPInfo_onRoot.f'
        print*,'rank_id, itime ',rank_id, itime
        print*,'n_procs.gt.n_procs_max'
        print*,'n_procs_max ',n_procs_max
        print*,'n_procs     ',n_procs
        print*
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      end if

      itime_check = 10e8    !0   !10e8    !0

      !ipcount_start = nbed_local+1
      !ipcount_stop = nbS_local
      no_of_movingBPs_local = ipcount_stop - ipcount_start+1
      
c      if(itime.ge.itime_check.and.rank_id.eq.2)then
c        print*
c        print*,'Inside update_BPInfo_onRoot'
c        print*,'Info to be sent'
c        print*,'itime ',itime
c        print*,'rank_id ',rank_id
c        print*,'nb_max  ',nb_max
c        print*,'ipcount_start ',ipcount_start
c        print*,'ipcount_stop  ',ipcount_stop
c        print*,'no_of_movingBPs_local', no_of_movingBPs_local
c        print*,'i, i_BPP_togoto_Root(i), xp_togoto_Root,yp_togoto_Root,z
c     &p_togoto_Root'
c        do i=1,no_of_movingBPs_local
c          print*,
c     &    i, i_pBPP_togoto_Root(i),
c     &    xpp_togoto_Root(i),ypp_togoto_Root(i),zpp_togoto_Root(i)
c        end do
c      end if
      
c      print*,'In update_BPInfo_onRoot, rank_id, no_of_movingBPs_local ',
c     &        rank_id, no_of_movingBPs_local      
      
      call MPI_GATHER(no_of_movingBPs_local     , 1, MPI_INTEGER,
     &                no_of_movingBPs(rank_id+1), 1, MPI_INTEGER,
     &                0, grid_comm, ierr)

      idisp(1) = 0
      do i_rank = 0,n_procs-1
        if(i_rank.gt.0)then
          idisp(i_rank + 1) = idisp(i_rank) + nb_max  !no_of_movingBPs(i_rank)
        end if
      end do

c      if(rank_id.eq.0.and.itime.ge.itime_check)then
c        print*,'no_of_movingBPs', no_of_movingBPs
c        print*,'idisp          ', idisp
c      end if

c      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      

      call MPI_GATHERV(
     &  i_pBPP_togoto_Root, no_of_movingBPs_local , MPI_INTEGER,
     &  i_BP_Pointer_temp , no_of_movingBPs, idisp, MPI_INTEGER,
     &  0, grid_comm, ierr)
      call MPI_GATHERV(
     &  xpp_togoto_Root, no_of_movingBPs_local , MPI_TYPE_XYZ,
     &  xp_BP_temp ,     no_of_movingBPs, idisp, MPI_TYPE_XYZ,
     &  0, grid_comm, ierr)
      call MPI_GATHERV(
     &  ypp_togoto_Root, no_of_movingBPs_local , MPI_TYPE_XYZ,
     &  yp_BP_temp ,     no_of_movingBPs, idisp, MPI_TYPE_XYZ,
     &  0, grid_comm, ierr)
      call MPI_GATHERV(
     &  zpp_togoto_Root, no_of_movingBPs_local , MPI_TYPE_XYZ,
     &  zp_BP_temp ,     no_of_movingBPs, idisp, MPI_TYPE_XYZ,
     &  0, grid_comm, ierr)
     
      !Unpack Data on Root processor
c      if(itime.ge.itime_check.and.rank_id.eq.0)then 
c        print*,'Unpacking normalData on root '
c        print*,'i_rank,1: no_of_movingBPs,i_absolute, BP_xyz_Data'
c      end if
      do i_rank = 0,n_procs-1
        do ii = 1,no_of_movingBPs(i_rank+1)
          i_absolute = i_BP_Pointer_temp(ii,i_rank+1)
          BP_xyz_Data(i_absolute,1) = xp_BP_temp(ii,i_rank+1)
          BP_xyz_Data(i_absolute,2) = yp_BP_temp(ii,i_rank+1)
          BP_xyz_Data(i_absolute,3) = zp_BP_temp(ii,i_rank+1)
          !iBP_Pointer_Info(i_absolute,2) = i_rank
c          if(itime.ge.itime_check.and.rank_id.eq.0)then
c            print*,i_rank,ii,i_absolute,
c     &           BP_xyz_Data(i_absolute,1),BP_xyz_Data(i_absolute,2),
c     &           BP_xyz_Data(i_absolute,3)
c          end if
        end do
      end do

      
c      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      call MPI_BCast(BP_xyz_Data     , 1, iBP_xyz_Data_Type, 
     &               0, MPI_COMM_WORLD, ierr)
c      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      !if(rank_id.eq.0)then
      !  i_max = maxval(no_of_movingBPs)
      !  print*,'i, i_BP_Pointer_temp(i,i_rank+1) '
      !  do i=1,i_max
      !    write(*,*),i, (i_BP_Pointer_temp(i,ir+1),ir=0,n_procs-1) 
      !  end do
      !end if
      
c      !-- Debugging Code --
c      if(itime.ge.itime_check.and.rank_id.eq.n_procs-1)then
c        print*
c        print*,
c     &  'Checking BPs NORMALS connectivity in update_BPInfo_onRoot'
c        print*,' rank_id ', rank_id
c        print*,' itime   ', itime
c        print*,' i, rank_id, index_on_rank, i-1,  i+1,   xp,   yp,   zp'
c        do i=1,nb
c          write(*,498),i,(iBP_Pointer_Info(i,j),j=1,6),
c     &                (BP_xyz_Data(i,k),k=1,3)
c        end do
c        call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
c      end if
c498   format(3(i4,'   '),('   '),4(i4,'   '),3(f12.6,'   '))
      
      !if(itime.eq.1)stop

      !if(rank_id.ge.0)then 
      !  print*
      !  print*,'End of update_BPInfo_onRoot.f, itime= ',itime
      !  print*,'rank_id ',rank_id
      !end if

            
      end subroutine  
