c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine update_MLS_densitySummations_fromSouth
c
      include 'common.3D'
                  
      real rhop_sum_going_back_North(nGuestmax)         
      real rhop_sum_back_from_South(nGuestmax) 
              
      itime_check = 10e8   !0   !10e8   !0   !
      
!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.0)then
!           print*
!           print*,'In update_kernelSummations'
!           print*,'Cartesian Topology'
!         end if
!         do i=0,n_procs-1
!           if(itime.ge.itime_check.and.i.eq.rank_id-1)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, north, south ',rank_id, north, south 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       end if
      
      !-- Zero non-communicating processes --
      if(rank_idy.eq.0
     &   .and.(.NOT.iCartTop_periodicity(2)))then
        nb_going_South = 0
        np_going_South = 0
        if(n_procs_y.eq.1)then
          nb_going_North = 0
          np_going_North = 0
        end if
      else if(rank_idy.eq.n_procs_y-1
     &   .and.(.NOT.iCartTop_periodicity(2)))then
        nb_going_North = 0
        np_going_North = 0
        if(n_procs_y.eq.1)then
          nb_going_South = 0
          np_going_South = 0
        end if
      end if

!      !- Diagnostic Info -
!       if(itime.ge.itime_check.and.rank_id.eq.0)then
!         print*
!         print*,'In update_kernelSummations'
!         print*
!         print*,'rank_id        ',rank_id
!         print*,'nb_local       ',nb_local
!         print*,'np_local       ',np_local
!         print*,'nb_from_North   ',nb_from_North
!         print*,'np_from_North   ',np_from_North
!         print*,'nb_from_South   ',nb_from_South
!         print*,'np_from_South   ',np_from_South
!         print*,'nb_image_local ',nb_image_local
!         print*,'np_image_local ',np_image_local        
!         print*,'nb_going_North   ',nb_going_North
!         print*,'np_going_North   ',np_going_North
!         print*,'nb_going_South   ',nb_going_South
!         print*,'np_going_South   ',np_going_South
!         print*,'north, south      ',north, south 
!       end if
!       if(itime.ge.itime_check.and.rank_id.eq.5)then
!         print*,'In update_kernelSummations'
!         print*
!         print*,'rank_id        ',rank_id
!         print*,'nb_local       ',nb_local
!         print*,'np_local       ',np_local
!         print*,'nb_from_North   ',nb_from_North
!         print*,'np_from_North   ',np_from_North
!         print*,'nb_from_South   ',nb_from_South
!         print*,'np_from_South   ',np_from_South
!         print*,'nb_image_local ',nb_image_local
!         print*,'np_image_local ',np_image_local        
!         print*,'nb_going_North   ',nb_going_North
!         print*,'np_going_North   ',np_going_North
!         print*,'nb_going_South   ',nb_going_South
!         print*,'np_going_South   ',np_going_South
!         print*,'north, south      ',north, south 
!       end if
                
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---

      !-- Pack Particle data to be sent back North--
c      if(itime.ge.itime_check.and.rank_id.eq.0)then
c        print*
c        print*,'Particles being sent back North'
c        print*,'rank_id ',rank_id
c        print*,'np_from_North ',np_from_North
c        print*,'kk_highest ',kk_highest
cc        print*,
cc     &  'ii, i_image, xp_going_back_North(ii), yp_going_back_North(ii)'
c        print*,
c     &  'ii,  i_image, xp, yp, zp(i_image), sum_wab_going_back_North(ii)'
c      end if
      do ii = 1,np_from_North
        !i_image = kk_highest + np_from_South + ii
        i_image = kk_highest_after_SR_toBelow + ii
        rhop_sum_going_back_North(ii)  = rhop_sum_MLS(i_image)
c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          print*,
c     &    ii,i_image,xp(i_image),zp(i_image),
c     &    sum_wab_going_back_North(ii)
c        end if         
      end do                

      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      !--- SendRecv kernel summation information back to original processors ---
      
      !Send data back North
      call MPI_SENDRECV(
     &   rhop_sum_going_back_North, np_from_North , MPI_REAL, north, 0,
     &   rhop_sum_back_from_South , np_going_South, MPI_REAL, south, 0,
     &   grid_comm, status, ierr)
      
      !-- Unpack Data & Update summations on original processors
      
      !-- UnPack Particle data originally sent South --
c      if(itime.ge.itime_check.and.rank_id.eq.0)then
c        print*,'Unpacking data originally sent South'
c        print*,'np_going_South ',np_going_South
c        print*,'Summing sum_wab'
c        print*,'ii, i, sum_wab(i), sum_wab_back_from_South(ii)'
c      end if
      nbfm_start    = nbf_in_ly_2 + 1
      nbfreem_start = nbfm_in_ly_2 + 1
      nFP_start     = nb_going_South + 1
      do ii=1,np_going_South     !do ii=1,np_in_ly_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_South_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_South_2(ii-nbf0_in_ly_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_South_3(ii-(nbf0_in_ly_2+nbfm0_in_ly_2))
        !if(ii.le.nb_going_South)then        
        !  i = iBP_going_South(ii)
        else
          i = iFP_going_South(ii-nb_going_South)
        end if 
        rhop_sum_MLS(i) = rhop_sum_MLS(i) + rhop_sum_back_from_South(ii)
c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          !print*
c          !write(*,495),ii, i, xp_check, yp_check 
c          !write(*,495),ii, i, xp(i), yp(i)
c          write(*,494),ii, i, sum_wab(i), sum_wab_back_from_South(ii)
c        end if        
      end do


c494   format(2(i5,'    '),4(f12.6,'    '))      
c495   format(2(i5,'    '),4(e12.6,'    '))      
      
        
      end subroutine
