c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine update_vorticitySummations_fromSouth

      include 'common.3D'
             
      !-- Using Derived DataTypes: ivort_DataType  --
      real curl_data_going_back_North(nGuestmax,6)
      real curl_data_back_from_South(nGuestmax,6)

      itime_check = 10e8   !0   !10e8

!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.0)then
!           print*,'In update_vorticitySummations'
!           print*,'Cartesian Topology'
!         end if
!         call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         do i=0,n_procs-1
!           if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, north, south ',rank_id, north, south 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       
!         !-- Zero non-communicating processes --
!       if(rank_idy.eq.0
!      &   .and.(.NOT.iCartTop_periodicity(2)))then
!         nb_going_South = 0
!         np_going_South = 0
!         if(n_procs_y.eq.1)then
!           nb_going_North = 0
!           np_going_North = 0
!         end if
!       else if(rank_idy.eq.n_procs_y-1
!      &   .and.(.NOT.iCartTop_periodicity(2)))then
!         nb_going_North = 0
!         np_going_North = 0
!         if(n_procs_y.eq.1)then
!           nb_going_South = 0
!           np_going_South = 0
!         end if
!       end if
! 
!         if(rank_id.eq.0)then
!           print*,'In update_accnSummations'
!           print*
!           print*,'rank_id        ',rank_id
!           print*,'nb_local       ',nb_local
!           print*,'np_local       ',np_local
!           print*,'nb_from_North   ',nb_from_North
!           print*,'np_from_North   ',np_from_North
!           print*,'nb_from_South   ',nb_from_South
!           print*,'np_from_South   ',np_from_South
!           print*,'nb_image_local ',nb_image_local
!           print*,'np_image_local ',np_image_local        
!           print*,'nb_going_North   ',nb_going_North
!           print*,'np_going_North   ',np_going_North
!           print*,'nb_going_South   ',nb_going_South
!           print*,'np_going_South   ',np_going_South
!           print*,'north, south      ',north, south 
!         end if
!       end if   !End of:  if(itime.ge.itime_check)then

      !-- Error Catching --
      if(np_from_North.gt.nGuestmax)then
        print*
        print*,'In update_vorticitySummations.f '
        print*,'np_from_North.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_North ',np_from_North
        stop
      end if
      if(np_from_South.gt.nGuestmax)then
        print*
        print*,'In update_vorticitySummations.f '
        print*,'np_from_South.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_South ',np_from_South
        stop
      end if
                
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---
      !-- Pack Particle data to be sent back North--
c      if(itime.ge.itime_check)then
c        if(rank_id.eq.0)then
c          print*
c          print*,'Particles Vorticity being sent back North'
c          print*,'rank_id ',rank_id
c          print*,'np_from_North ',np_from_North
c          print*,
c     &  'ii, i_image, xp(i_image), yp(i_image),zp(i_image)'
c        end if
c      end if
      do ii = 1,np_from_North
        !i_image = np_local + np_from_South + ii    !CORRECT THIS FOR DISORDERED PARTICLES!!!!
        !i_image = kk_highest + np_from_South + ii
        i_image = kk_highest_after_SR_toBelow + ii
        curl_data_going_back_North(ii,1)    = curl3x_a(i_image)            
        curl_data_going_back_North(ii,2)    = curl3y_a(i_image)            
        curl_data_going_back_North(ii,3)    = curl3z_a(i_image)            
        curl_data_going_back_North(ii,4)    = curl3x_b(i_image)            
        curl_data_going_back_North(ii,5)    = curl3y_b(i_image)            
        curl_data_going_back_North(ii,6)    = curl3z_b(i_image)            
c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          print*,
c     &    ii, i_image, xp(i_image), 
c     &    curl3y_a(i_image), curl_data_going_back_North(ii,1)
c        end if         
      end do           

      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      !--- SendRecv acceleration summation information back to original processors ---
       
c      !Send data back North
      !---Combined SendRecv to North Neighbour ---
      call MPI_SENDRECV(
     &   curl_data_going_back_North, 1  , ivort_DataType , north, 101,
     &   curl_data_back_from_South , 1  , ivort_DataType , south, 101,
     &   grid_comm, status, ierr)
     
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      
      !-- Unpack Data & Update summations on original processors
      
      !-- UnPack Particle data originally sent South --
c      if(itime.ge.itime_check.and.rank_id.eq.0)then
c        print*,'Unpacking data originally sent South'
c        print*,'np_going_South ',np_going_South
c        !print*,'Checking xy-positions'
c        !print*,'ii, i, xp_check, yp_check, xp(i), yp(i)'
c        print*,'ii, i, xp_check, zp_check, xp(i), zp(i),
c     &curl3x_a(i),curl_data_back_from_South(ii)'
c      end if
      nbfm_start    = nbf_in_ly_2 + 1
      nbfreem_start = nbfm_in_ly_2 + 1
      nFP_start     = nb_going_South + 1
      do ii=1,np_going_South     !do ii=1,np_in_ly_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_South_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_South_2(ii-nbf0_in_ly_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_South_3(ii-(nbf0_in_ly_2+nbfm0_in_ly_2))
        !if(ii.le.nb_going_South)then        
        !  i = iBP_going_South(ii)
        else
          i = iFP_going_South(ii-nb_going_South)
        end if 
c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          write(*,495),ii,i,xp(i),zp(i),curl3y_a(i),
c     &     curl_data_back_from_South(ii,1)
c        end if        
        curl3x_a(i)  = curl3x_a(i) + curl_data_back_from_South(ii,1)
        curl3y_a(i)  = curl3y_a(i) + curl_data_back_from_South(ii,2)
        curl3z_a(i)  = curl3z_a(i) + curl_data_back_from_South(ii,3)
        curl3x_b(i)  = curl3x_b(i) + curl_data_back_from_South(ii,4)
        curl3y_b(i)  = curl3y_b(i) + curl_data_back_from_South(ii,5)
        curl3z_b(i)  = curl3z_b(i) + curl_data_back_from_South(ii,6)
      end do


495   format(2(i5,'  '),4(e12.6,'  '))      
      
      !stop
        
      end subroutine
