c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.


c       initial data for SPH models                                                                     72

      program SPHYSICSgen_3D
      include 'common.gen3D'

      logical iCartTop_periodicity
      
       print*
       write(*,*) '<SPHYSICS>  Copyright (C) <2009>'
       write(*,*) 
     & '<Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, '
       write(*,*) 
     & 'Dr Benedict Rogers, Dr Alejandro Crespo, '
       write(*,*) 
     &'Dr Muthukumar Narayanaswamy, Dr Shan Zou, & Dr Andrea Panizzo >'
       write(*,*) 'This program comes with ABSOLUTELY NO WARRANTY;    '
       write(*,*) 'This is free software, and you are welcome to      '
       write(*,*) 'redistribute it under conditions stated in         '
       write(*,*) 'the GPL License;                                   '

       
      print*
      print*,' ---    SPHYSICSgen_3D.F     ---'
      print*,' ---   GENERATING GEOMETRY   ---'
      print*,' ---   Distributed under     ---'
      print*,' ---    the GPL License      ---'
      print*

      write(*,*) 'Choose Starting options:   Start new RUN = 0 ' 
      write(*,*) '                       : Restart old RUN = 1 '
      write(*,*) '     with CheckPointing:   Start new RUN = 2 '
      write(*,*) '                       : Restart old RUN = 3 '
      read(*,*) i_restartRun
      write(*,*) i_restartRun

C     KERNEL
      write(*,*)'Choose KERNEL'

      write(*,*)'Gaussian        = 1'
      write(*,*)'Quadratic       = 2'
      write(*,*)'Cubic- Spline   = 3'

      write(*,*)'Quintic Wendland= 5'
      read(*,*) i_kernel
      write(*,*) i_kernel
       
C     ALGORITHM
      write(*,*)'Choose ALGORITHM'
      write(*,*)'Predictor- Corrector = 1'
      write(*,*)'Verlet               = 2'
      write(*,*)'Symplectic           = 3'
      write(*,*)'Beeman               = 4'
      read(*,*) i_algorithm
      write(*,*) i_algorithm

      if(i_algorithm.eq.2)then
        write(*,*)' ndt_VerletPerform ? '
        read(*,*) ndt_VerletPerform
        write(*,*) ndt_VerletPerform
      else
	  ndt_VerletPerform=0
      endif


c     Density filter

      write(*,*) ' Use Density filter (0=no, 1=Shepard, 2=MLS) ??'
      read(*,*) i_densityFilter
      write(*,*) i_densityFilter

      if(i_densityFilter.gt.0)then
        write(*,*)' ndt_FilterPerform ? '
        read(*,*) ndt_FilterPerform
        write(*,*) ndt_FilterPerform
      else
        ndt_FilterPerform=0
      endif


c     Kernel & Gradient corrections
      write(*,*) ' Use kernel & gradient correction ??'
      write(*,*) ' 0=no, 1= Kernel correction, 
     + 2= Gradient kernel correction'
      read(*,*)  i_kernelcorrection
      write(*,*) i_kernelcorrection

c     Constants
c
      g=9.81
      pi=4.0*atan(1.0)


c     Initialise periodicity
c
      i_periodicOBs(1) = 0
      i_periodicOBs(2) = 0
      i_periodicOBs(3) = 0



c	Viscosity terms
      write(*,*) 'Kind of viscosity  ??'
      write(*,*) ' (1) Artificial (2) Laminar (3) Laminar +SPS'
      read(*,*) i_viscos
      write(*,*) i_viscos

      if (i_viscos.eq.1) then
          write(*,*) 'Alpha  ??'
          read(*,*)  viscos_val
      else
          write(*,*) 'Laminar Viscosity Nu  ??'
          read(*,*)  viscos_val
      endif

      write(*,*) viscos_val


c     vorticity printing
      write(*,*) 'vorticity printing ? (1=yes)'
      read(*,*) i_vort
      write(*,*) i_vort

c     pressure terms

      print*
      write(*,*) ' Choose Equation of State (EoS)'
      write(*,*) ' 1: Weakly Compressible Fluid (Taits equation)'
      write(*,*) ' 2: Ideal Gas Equation'
      write(*,*) ' 3: Weakly Compressible Fluid (Morris equation)'
      write(*,*) ' 4: Incompressible Fluid (Poissons equation)'
      read(*,*) i_EoS
      print*,'i_EoS' ,i_EoS

c     Define pressure terms


      write(*,*) ' Maximum Depth in the simulation, h_SWL'
      read(*,*)  h_SWL
      write(*,*) h_SWL


      if(i_EoS.eq.1.or.i_EoS.eq.3) then

        write(*,*) ' Coefficient of Speed of sound ( 10 , 40 ) ??'
        read(*,*) coef
        write(*,*) coef

        coef2=coef*coef

        rho0=1000.0 !initial density
        gamma=7.0
        expont=1./gamma
        TE0=0.0

        B=coef2*rho0*g*(h_SWL)/7.0  ! B is estimated using h_SWL and coef
        Co=((B*7.0)/rho0)**.5

        write(*,*) ' B=coef2*rho0*g*(h_SWL)/7.0 =',B
        write(*,*) ' Co=',coef,'*V=',Co

      else if (i_EoS.eq.2) then

        write(*,*) ' B and coefficient of speed of sound are not used '
        coef=0.0

        rho0=1.0 
        gamma=1.4
        expont=1./gamma
        write(*,*) ' Set an intial value for TE '
        read(*,*) TE0
        write(*,*) TE0
		

      else if (i_EoS.gt.3) then

         write(*,*) 'It is not avaliable yet'
         stop

      endif

c	boundary type

      write(*,*)'Choose Boundary Type'
      write(*,*)'Monaghan & Kos (1999) = 1'
      write(*,*)'Dalrymple & Knio (2001) = 2'
      read(*,*) IBC
      write(*,*) IBC

      if(iBC.eq.1)then
        print*,' Enter wall viscosity value for Monaghan & Kos (1999) '
        read(*,*) visc_wall
        print*,' visc_wall = ',visc_wall
        ndt_DBCPerform=0
      else
        visc_wall = 0.0
        print*,' Use Hughes & Graham (2009) correction ?  '
        print*,' ndt_DBCPerform ? (1 means no correction) '
        read(*,*) ndt_DBCPerform
        if(ndt_DBCPerform.eq.0) ndt_DBCPerform=1
        write(*,*) ndt_DBCPerform
        if(i_algorithm.eq.2.and.ndt_DBCPerform.ne.1)then
           write(*,*) 'Hughes & Graham (2009) correction is not 
     & going to work for Verlet algorithm'
           stop
        elseif(i_algorithm.eq.2) then
           write(*,*) 'Hughes & Graham (2009) correction is not 
     & avaliable for Verlet algorithm'
        endif
      endif


c       Define computational Space

      write(*,*) ' Geometry of the zone'
      write(*,*) ' (1) BOX '
      write(*,*) ' (2) BEACH '
      write(*,*) ' (3) EXTERNALLY FIXED GEOMETRY '
      read(*,*)  i_geometry
      write(*,*) i_geometry

      if (i_geometry.ne.3) then
         write(*,*) 'Fluid Particle Lattice Structure ??'
         print*,' (1) SC; (2) BCC'
         read(*,*) lattice
         write(*,*) 'Lattice Type = ', lattice
         if (lattice.eq.1) then !SC
           vnorm_mass=1.
         else  !BCC
           vnorm_mass=0.5
         endif
      endif

      call CPU_TIME (gen_Particles_time0)

      if (i_geometry.eq.1) then
         call box(g,expont,dx,dy,dz)
      else if (i_geometry.eq.2) then
         call beach(g,expont,dx,dy,dz)
      else if (i_geometry.eq.3) then
         call external_geometry(dx,dy,dz)
      else
         write(*,*) i_geometry,' is not a valid Geometry'
         stop
      endif

      call CPU_TIME (gen_Particles_time1)

      eps=0.5

      write(*,*)' please input the tmax and out:'
      read(*,*) tmax,out
      write(*,*) tmax,out
      write(*,*)' initial recording time'
      read(*,*) trec_ini
      write(*,*) trec_ini
      write(*,*)' For detailed recording during RUN'
      write(*,*)' step, start, end'
      read(*,*) dtrec_det, t_sta_det, t_end_det
      write(*,*) dtrec_det, t_sta_det, t_end_det

      time=0.
      write(*,*) 'input dt:, Variable time step (1=y)'
      read(*,*) dt,ivar_dt
      write(*,*) dt,ivar_dt

      write(*,*) 'CFL number (0.1 - 0.5)'
      read(*,*) CFL_number
      write(*,*) CFL_number

      write(*,*) ' h=coefficient*sqrt(dx*dx+dy*dy+dz*dz)'
      write(*,*) ' Coefficient ??'
      read(*,*)  coefficient
      write(*,*) coefficient




c     ______ Time Step Stability Check 
      Cr = CFL_number
      Cmax = sqrt(B*gamma/rho0)  !note adjusted formula
      Vmax = max(1.1*Cmax,Cmax)
      dtmax=Cr*min(dx,dy,dz)/Vmax

      print*
      print*,'--- Courant Stability Check ---'
      print*,'Courant No. Cr = ',Cr
      print*,'B    =           ',B
      print*,'Cmax =           ',Cmax
      print*,'dtmax: ',dtmax
      if(dtmax.lt.dt) then
        print*,'dt is TOO big!!!!'
        print*,'suggest: ',dtmax
      endif
      print*
      print*,'--- Viscous Stability Check ---'
      print*,'Kinematic Viscosity',1.0e-6
      print*,'Visc =           ',1.0e-6
      dtmax=Cr*((min(dx,dy,dz))**2)/(101.0*1.0e-6)
      write(*,*) 'dtmax: ',dtmax
      if(dtmax.lt.dt) then
        print*,'dt is TOO big!!!!'
        print*,'suggest: ',dtmax
      endif
      print*
      write(*,*) 'dt: ',dt
      print*


c     --- Choose Riemann Solver ---
      write(*,*) ' Choose Riemann Solver'
      write(*,*) ' 0: None '
      write(*,*) ' 1: Conservative (Vila 1999)'
      write(*,*) ' 2: Non-Conservative (Parshikov et al. 2000)'
      read(*,*)  iRiemannSolver
      print*,'iRiemannSolver ' ,iRiemannSolver
      if(iRiemannSolver.eq.1)then
        i_ConservativeFormulation = 1
      else
        i_ConservativeFormulation = 0
      endif
      if(iRiemannSolver.gt.0)then
        if(i_viscos.eq.1)then
          print*,'Cannot have Riemann Solver and Artificial Viscosity'
          stop
        endif
        if(i_densityFilter.gt.0)then
          print*
          print*,'It is not advised to have a density filter'
          print*,'AND a Riemann Solver simultaneously'
          print*,'DISABLING density filter '
          i_densityFilter = 0
          print*,'i_densityFilter =',i_densityFilter
        endif
        write(*,*) ' Use TVD, slope limiter (beta_lim)?'
        read(*,*) iTVD, beta_lim
        print*,'iTVD, beta_lim ' ,iTVD, beta_lim
        Cr = CFL_number
        Cmax = sqrt(B*gamma/rho0)  !note adjusted formula
        Vmax = max(1.1*Cmax,Cmax)
        dtmax_Riemann=Cr*min(dx,dy,dz)/Vmax
        print*
        print*,'--- Riemann Courant Stability Check ---'
        print*,'Courant No. Cr = ',Cr
        print*,'B    =           ',B
        print*,'Cmax =           ',Cmax
        print*,'dtmax_Riemann:   ',dtmax_Riemann
        if(dtmax_Riemann.lt.dt) then
          print*,'dt is TOO big!!!!'
          print*,'suggest: ',dtmax_Riemann
        endif
      else
        iTVD = 0
        beta_lim = 0.0
      end if

c	________________________   TO COMPILE

      write(*,*)
      write(*,*) 'Which compiler is desired? '
      write(*,*) '(5=MPI)'
      read(*,*) i_compile_opt
      write(*,*) i_compile_opt

c     ______  Choose Precision of XYZ Variables for Run _________
      call precisionWrite(i_compile_opt)

      write(*,*)
      write(*,*)'--- Now input MPI Parameters ---'

c     ______ Choose MPI Parameters ______
      if(i_compile_opt.eq.5) then
        !- Choose multi-dimensional MPI Cartesian Topology -
        write(*,*)
        write(*,*)
     &  'Choose dimension of MPI Cartesian Topology (1,2,3)?'
        read(*,*) MPI_CartDims
        write(*,*) MPI_CartDims
        if(MPI_CartDims.lt.0.or.MPI_CartDims.gt.3)then
          print*
          print*,'Invalid option for MPI Cartesian Topology '
          stop
        endif

        write(*,*)
        write(*,*)
     &  'Use Automatic domain decomposition (1=yes) '
        write(*,*) '0=no --> choose n_procs (x,y,z)'
        read(*,*) MPI_AutoDomainProcs,n_procs_x0,n_procs_y0,n_procs_z0
        write(*,*) MPI_AutoDomainProcs,n_procs_x0,n_procs_y0,n_procs_z0
        if(MPI_CartDims.eq.1)then
          print*,'MPI_CartDims=1, using Automatic domain decomposition'
          MPI_AutoDomainProcs = 1
          print*,'MPI_AutoDomainProcs =',MPI_AutoDomainProcs
        endif
        if(MPI_AutoDomainProcs.eq.0)then
          if(n_procs_x0.le.0)then
            print*,'Error: n_procs_x = ',n_procs_x0
            n_procs_x0 = 1
            print*,'Correcting n_procs_x to = ',n_procs_x0
          endif
          if(n_procs_y0.le.0)then
            print*,'Error: n_procs_y = ',n_procs_y0
            n_procs_y0 = 1
            print*,'Correcting n_procs_y to = ',n_procs_y0
          endif
          if(n_procs_z0.le.0)then
            print*,'Error: n_procs_z = ',n_procs_z0
            n_procs_z0 = 1
            print*,'Correcting n_procs_z to = ',n_procs_z0
          endif
        endif

        call tocompile_MPI

        write(*,*)
        write(*,*)
     &  'Use MPI Adaptation?'
     &  //'(nFP_difference_max, n_itime_Adapt, n_ini_Adapt)'
        write(*,*) '(1=yes)'
        read(*,*)  i_MPI_Adapt, nFP_difference_max,
     &             n_itime_Adapt, n_ini_Adapt
        write(*,*) i_MPI_Adapt, nFP_difference_max,
     &             n_itime_Adapt, n_ini_Adapt
        iCartTop_periodicity(1) = .false.  !default value, X-direction MPI Periodiciy available only
        iCartTop_periodicity(2) = .false.  !default value, X-direction MPI Periodiciy available only
        iCartTop_periodicity(3) = .false.  !default value, X-direction MPI Periodiciy available only
        !- Checking (over) specification of i_periodicOBs & MPI periodicity -
        if(i_periodicOBs(1).eq.1.and.iCartTop_periodicity(1))then
          print*,'i_periodicOBs(1).eq.1.and.iCartTop_periodicity(1)'
          print*,'UnSetting of i_periodicOBs(1) for MPI'
          i_periodicOBs(1) = 0
        else if(i_periodicOBs(1).eq.1.and.
     &          (.NOT.iCartTop_periodicity(1)) )then
          print*,'Activating MPI X-dir Periodicity in place of '
          print*,'normal i_periodicOBs(1)'
          print*,'  1. Setting iCartTop_periodicity(1)=.true.'
          print*,'  2. De-activating i_periodicOBs(1) = 1'
          i_periodicOBs(1) = 0
          iCartTop_periodicity(1) = .true.
          print*
        endif
        if(i_periodicOBs(2).eq.1.and.iCartTop_periodicity(2))then
          print*,'i_periodicOBs(2).eq.1.and.iCartTop_periodicity(2)'
          print*,'UnSetting of i_periodicOBs(2) for MPI'
          i_periodicOBs(2) = 0
        else if(i_periodicOBs(2).eq.1.and.MPI_CartDims.gt.2.and.
     &          (.NOT.iCartTop_periodicity(2)) )then
          print*,'Activating MPI Y-dir Periodicity in place of '
          print*,'normal i_periodicOBs(2)'
          print*,'  1. Setting iCartTop_periodicity(2)=.true.'
          print*,'  2. De-activating i_periodicOBs(2) = 1'
          i_periodicOBs(2) = 0
          iCartTop_periodicity(2) = .true.
          print*
        endif
        if(i_periodicOBs(3).eq.1.and.iCartTop_periodicity(3))then
          print*,'i_periodicOBs(3).eq.1.and.iCartTop_periodicity(3)'
          print*,'UnSetting of i_periodicOBs(3) for MPI'
          i_periodicOBs(3) = 0
        else if(i_periodicOBs(3).eq.1.and.MPI_CartDims.gt.1.and.
     &          (.NOT.iCartTop_periodicity(3)) )then
          print*,'Activating MPI Z-dir Periodicity in place of '
          print*,'normal i_periodicOBs(3)'
          print*,'  1. Setting iCartTop_periodicity(3)=.true.'
          print*,'  2. De-activating i_periodicOBs(3) = 1'
          i_periodicOBs(3) = 0
          iCartTop_periodicity(3) = .true.
          print*
        endif
        write(*,*) 'i_periodicOBs        = ',i_periodicOBs
        write(*,*) 'iCartTop_periodicity = ',iCartTop_periodicity
        print*    
      else
        print*
        print*,'Invalid option for compiler option '
        stop
      end if


      dpx = dx
      dpy = dy
      dpz = dz
188   format(es13.7)      


c	___________ File INDAT

      open(11,file='INDAT')

      write(11,*)i_kernel					! 1
      write(11,*)i_algorithm
      write(11,*)i_densityFilter
      write(11,*)i_viscos
      write(11,*)iBC						! 5
      write(11,*)i_periodicOBs(1)
      write(11,*)i_periodicOBs(2)
      write(11,*)i_periodicOBs(3)
      write(11,*)lattice
      write(11,*)i_EoS						! 10
      write(11,*)h_SWL
      write(11,*)B
      write(11,*)gamma
      write(11,*)coef
      write(11,*)eps						! 15
      write(11,*)rho0
      write(11,*)viscos_val
      write(11,*)visc_wall
      write(11,*)vlx
      write(11,*)vly						! 20
      write(11,*)vlz
      write(11,188)dx
      write(11,188)dy
      write(11,188)dz
      h=coefficient*sqrt(dx*dx+dy*dy+dz*dz)
      write(11,*)h						! 25
      write(11,*)np
      write(11,*)nb
      write(11,*)nbf
      write(11,*)ivar_dt
      write(11,*)dt						! 30
      write(11,*)tmax
      write(11,*)out
      write(11,*)trec_ini
      write(11,*)dtrec_det
      write(11,*)t_sta_det					! 35
      write(11,*)t_end_det
      write(11,*)i_restartRun
      write(11,*)CFL_number
      write(11,*)TE0	
      write(11,*)i_kernelcorrection				! 40
      write(11,*)iRiemannSolver
      write(11,*)iTVD
      write(11,*)beta_lim
      write(11,*)i_vort
      write(11,*)ndt_VerletPerform
      write(11,*)ndt_FilterPerform
      write(11,*)ndt_DBCPerform
      close(11)

      xb_min = 0.0
      xb_max = vlx
      yb_min = 0.0
      yb_max = vly
      zb_min = 0.0
      zb_max = vlz

      call position_check(dx,dy,dz)

c	________ SUBROUTINES FOR DEALING WITH NORMALS (SERIAL Version)

      if(iBC.eq.1)then
        call normals_Calc_3D
        call normals_FileWrite_3D    
      end if
      print*

      open(21,file='BoundaryPs_MPI_Pointer.init')
      do i=1,nb
        write(21,*)i
      enddo
      close(21)
      
      print*,'BoundaryPs_MPI_Pointer.init file written'
      print*
      print*,'Writing IPART file ...'
      print*

c	__________  File IPART

      open(13,file='IPART')

      !- MPI Dimensions Check -
      xp_min = xp(1)
      xp_max = xp(1)
      yp_min = yp(1)
      yp_max = yp(1)
      zp_min = zp(1)
      zp_max = zp(1)
      
      do i=1,np

        write(13,111) xp(i),yp(i),zp(i),up(i),vp(i),wp(i),
     +                 rhop(i),p(i),pm(i)

        !- MPI Dimensions Check -
        if(xp(i).lt.xp_min) xp_min = xp(i)
        if(xp(i).gt.xp_max) xp_max = xp(i)
        if(yp(i).lt.yp_min) yp_min = yp(i)
        if(yp(i).gt.yp_max) yp_max = yp(i)
        if(zp(i).lt.zp_min) zp_min = zp(i)
        if(zp(i).gt.zp_max) zp_max = zp(i)
      
      enddo


111   format(9e16.8)
      close(13)

      print*,'IPART file written'
      print*

c	__________  File MATLABIN

      open(18,file='matlabin')
        write(18,*) np
        write(18,*) vlx
        write(18,*) vly
        write(18,*) vlz
        write(18,*) out
        write(18,*) nb
        write(18,*) nbf
      close(18)


c	__________  File RESTART  
      !--  Printout RESTART file new run using CheckPointing --
      if(i_restartRun.eq.2)then
         open(44,file='RESTART',status='unknown')
         write(44,146)0,0.0,0,dt    !=itime,time,ngrab,dt
         close(44)
      endif
146   format(i8,e16.8,i8,e16.8)


      !- MPI -corrections -
      if(zp_max.gt.zb_max)then
        zb_max = zp_max
      endif
      if(i_compile_opt.eq.5) then
       open(18,file='MPI_container_Limits.txt')
       if(iBC.eq.2)then
        if(i_periodicOBs(1).ne.1.and.(.NOT.iCartTop_periodicity(1)))then
          xb_length = xb_max - xb_min
          xb_min = xb_min - 0.05*xb_length
          xb_max = xb_max + 0.05*xb_length
        elseif(iCartTop_periodicity(1).and.xp_max.ne.xb_max)then
          print*,'Changing xb_max to ensure particles at '
          print*,'xb_min and xb_max are at correct spacing  '
          print*,'across periodic boundary'
          print*,'xp_min, xp_max ',xp_min, xp_max
          print*,'Initial xb_max ',xb_max
          if(iBC.eq.1)then
            xb_max = (1+nint((xp_max-0.05*dx)/dx))*dx
            print*,'--> Corrected xb_max = ',xb_max
          elseif(iBC.eq.2)then
            xb_min = xp_min
            xb_max = xp_max + vnorm_mass*dx
            print*,'--> Corrected xb_min, xb_max = ',xb_min, xb_max
          endif
          print*
        endif
        if(i_periodicOBs(2).ne.1.and.(.NOT.iCartTop_periodicity(2)))then
          yb_length = yb_max - yb_min
          yb_min = yb_min - 0.05*yb_length
          yb_max = yb_max + 0.05*yb_length
        elseif(i_periodicOBs(2).eq.1.and.yp_max.ne.yb_max)then
          print*,'Changing yb_max to ensure particles at '
          print*,'yb_min and yb_max are at correct spacing  '
          print*,'across periodic boundary'
          print*,'yp_min, yp_max ',yp_min, yp_max
          print*,'Initial yb_max ',yb_max
          if(iBC.eq.1)then
            yb_max = (1+nint((yp_max-0.05*dy)/dy))*dy
            print*,'--> Corrected yb_max = ',yb_max
          elseif(iBC.eq.2)then
            yb_min = yp_min
            yb_max = yp_max + vnorm_mass*dy
            print*,'--> Corrected yb_min, yb_max = ',yb_min, yb_max
          endif
          print*
        endif
        if(i_periodicOBs(3).ne.1.and.(.NOT.iCartTop_periodicity(3)))then
          zb_length = zb_max - zb_min
          zb_min = zb_min - 0.05*zb_length
          zb_max = zb_max + 0.05*zb_length
        elseif(iCartTop_periodicity(3).and.zp_max.ne.zb_max)then
          print*,'Changing zb_max to ensure particles at '
          print*,'zb_min and zb_max are at correct spacing  '
          print*,'across periodic boundary'
          print*,'zp_min, zp_max ',zp_min, zp_max
          print*,'Initial zb_max ',zb_max
          if(iBC.eq.1)then
            zb_max = (1+nint((zp_max-0.05*dz)/dz))*dz
            print*,'--> Corrected zb_max = ',zb_max
          elseif(iBC.eq.2)then
            zb_min = zp_min
            zb_max = zp_max + vnorm_mass*dz
            print*,'--> Corrected zb_min, zb_max = ',zb_min, zb_max
          endif
          print*
        endif
       endif
       write(18,*) iCartTop_periodicity
       write(18,*) xb_min,xb_max
       write(18,*) yb_min,yb_max
       write(18,*) zb_min,zb_max
       write(18,*) i_MPI_Adapt, nFP_difference_max, 
     &             n_itime_Adapt,n_ini_Adapt
       write(18,*) nbfm
       write(18,*) MPI_CartDims
       write(18,*) MPI_AutoDomainProcs,n_procs_x0,n_procs_y0,n_procs_z0
       close(18)
      end if

      print*,'nbf  ',nbf
      print*,'nbfm ',nbfm
      print*,'nb   ',nb
      print*,'np   ',np

      write(*,145)'Generated np = ',np,' particles in ',
     &        gen_Particles_time1-gen_Particles_time0,' seconds'
145   format(a15,1x,i9,a14,1x,f5.2,a8)
      

      stop

      end    ! END OF PROGRAM


c	________________________   SUBROUTINE BOX
c
       subroutine box(g,expont,dx,dy,dz)
       include 'common.gen3D'
       
       pi=4.*atan(1.)
c       
c     _______ Generate a 3D BOX
c

         print*
         print*,'--- Generating 3-D Box ---'
         print*

         write(*,*) ' Box dimension LX,LY,LZ?'
         read(*,*)  vlx,vly,vlz
         write(*,*) vlx,vly,vlz

         write(*,*) ' Spacing dx,dy,dz?'
         read(*,*)  dx,dy,dz
         write(*,*) dx,dy,dz

         write(*,*) ' Inclination of floor in X ( beta ) in deg ?? '  
         read(*,*)  beta_deg
         write(*,*) beta_deg
         beta=beta_deg*pi/180

         write(*,*) ' Inclination of floor in Y ( theta ) in deg ?? '  
         read(*,*)  theta_deg
         write(*,*) theta_deg
         theta=theta_deg*pi/180
 
         N=nint(vlx/dx)
         M=nint(vly/dy)		
         L=nint(vlz/dz)
       
       
       write(*,*) ' Dimension (pixels)', N,M,L

       print*
       write(*,*) ' Enter Periodicity Information:'
       write(*,*) ' Add Periodic Lateral boundaries'
       write(*,*) ' in X, Y, & Z-Directions ? (1=yes)'
       read(*,*) i_periodicOBs(1),i_periodicOBs(2),i_periodicOBs(3)
       print*
       print*,'i_periodicOBs'
       print*,'X-Direction: ',i_periodicOBs(1)
       print*,'Y-Direction: ',i_periodicOBs(2)
       print*,'Z-Direction: ',i_periodicOBs(3)
       if((i_periodicOBs(1).ne.0.and.i_periodicOBs(1).ne.1).or.
     &    (i_periodicOBs(2).ne.0.and.i_periodicOBs(2).ne.1).or.
     &    (i_periodicOBs(3).ne.0.and.i_periodicOBs(3).ne.1))then    
          print*
          print*,'Not a valid Periodic Boundaries Option'
          print*
          stop
       end if
             
       nn=0	! Initial number of particles

       write(*,*)' If wavemaker will be added, left wall is not needed'
       read(*,*)  iopt_wavemaker
       write(*,*) iopt_wavemaker

       !Activate these iopts within subroutines boundaries_front,back,left,right
       !to avoid duplicate boundary particles
       iopt_front = 0
       iopt_back  = 0
       iopt_left  = 0
       iopt_right = 0
      
       if(i_periodicOBs(2).ne.1)then  !Lateral Boundaries
         call boundaries_front(nn,0,N,M,L,dx,dy,dz,beta,theta)     !y = y1
         call boundaries_back(nn,0,N,M,L,dx,dy,dz,beta,theta)      !y = y2
         iopt_front = 1
         iopt_back  = 1
       endif
      
       if(i_periodicOBs(1).ne.1)then  !Lateral Boundaries
         if(iopt_wavemaker.ne.1)then
           call boundaries_left(nn,0,N,M,L,dx,dy,dz,beta,theta)    !x = x1
           iopt_left  = 1
         endif
         call boundaries_right(nn,0,N,M,L,dx,dy,dz,beta,theta)     !x = x2
         iopt_right = 1
       endif
      
       if(i_periodicOBs(3).ne.1)then  !Lateral Boundaries
         call boundaries_bottom(nn,0,N,M,L,dx,dy,dz,beta,theta)    !z = z1
       endif

	write(*,*) ' Add wall inside the box (1=y)'
	read(*,*)  iopt_addwall
	write(*,*) iopt_addwall

	do while (iopt_addwall.eq.1)
	   call wall(nn,dx,dy,dz,beta,theta)
	   write(*,*) ' Add another wall inside the box (1=y)'
	   read(*,*)  iopt_addwall
	   write(*,*) iopt_addwall
	enddo

	write(*,*) ' Add wall with slot inside the box (1=y)'
	read(*,*)  iopt_addwallslot
	write(*,*) iopt_addwallslot

	do while (iopt_addwallslot.eq.1)
	   write(*,*) ' Just in Y direction'
	   call wall_slot(nn,dx,dy,dz,beta,theta)
	   write(*,*) ' Add new wall with slot inside the box (1=y)'
	   read(*,*)  iopt_addwallslot
	   write(*,*) iopt_addwallslot
	enddo
	
	write(*,*) ' Add wall with round hole inside the box (1=y)'
	read(*,*)  iopt_addwallhole
	write(*,*) iopt_addwallhole


	do while (iopt_addwallhole.eq.1)
	   write(*,*) ' Just in Y direction'
	   call wall_hole(nn,dx,dy,dz,beta,theta)
	   write(*,*) 'Add new wall with round slot inside the box (1=y)'
	   read(*,*)  iopt_addwallhole
	   write(*,*) iopt_addwallhole
	enddo



      open(55,file='obstacle')

	write(*,*) ' Add obstacle inside the box (1=y)'
	read(*,*)  iopt_obst
	write(*,*) iopt_obst

	write(55,*) iopt_obst

        n_trapezoid = 0
        do while (iopt_obst.eq.1)
          i_obstacleShape = 0
          write(*,*) 'Choose rectangular (1) or trapezoid (2) '
          read(*,*) i_obstacleShape
          write(*,*)'i_obstacleShape ',i_obstacleShape
          if(i_obstacleShape.eq.1)then
            call obstacle(nn,dx,dy,dz,beta,0.,iopt_obst)
          elseif(i_obstacleShape.eq.2)then
            call trapezoid(nn,dx,dy,dz,beta,0.,iopt_obst)
          else
            print*,'invalid option'
            stop
          endif
          write(*,*) ' Add another obstacle inside the beach (1=y)'
          read(*,*)  iopt_obst
          write(*,*) iopt_obst
        enddo

	nbf=nn

	write(*,*) 'No of B. Fixed Particles',nbf


	open(66,file='wavemaker')

	write(*,*) ' Add wavemaker inside the box (1=y)'
	read(*,*)  iopt_wavemaker
	write(*,*) iopt_wavemaker

	write(66,*) iopt_wavemaker

	do while (iopt_wavemaker.eq.1)
	   write(*,*) ' Just in Y direction'
	   call wavemaker(nn,dx,dy,dz,beta,theta)
	   write(*,*) ' Add another wavemaker inside the box (1=y)'
	   read(*,*)  iopt_opt
	   write(*,*) iopt_wavemaker
	enddo

	close(66)


      open(77,file='gate')

	write(*,*) ' Add gate inside the box (1=y)'
	read(*,*)  iopt_gate
	write(*,*) iopt_gate

	write(77,*) iopt_gate

	do while (iopt_gate.eq.1)
	   write(*,*) ' Just in Y direction'
	   call gate(nn,dx,dy,dz,beta,theta)
	   write(*,*) ' Add another gate inside the box (1=y)'
	   read(*,*)  iopt_gate
	   write(*,*) iopt_gate
	enddo

	close(77)

       open(88,file='Tsunami_Landslide.txt')
       iopt_RaichlenWedge=0
       write(88,*)iopt_RaichlenWedge
       if(iopt_RaichlenWedge.eq.1.and.iopt_wavemaker.eq.1)then
         print*,'Cannot have Raichlen Wedge and wavemaker'
         print*,' at the same time'
         stop
       end if
       if(iopt_RaichlenWedge.eq.1)then
          call RaichlenWedge_Particles(nn,N1,N,M,dx,dy,dz,beta)
       endif
       close(88)


       print*
       num_FB = 0
       open(88,file='Floating_Bodies.txt')
       write(*,*)' Add Floating Bodies (1=yes) ?'
       read(*,*)  iopt_FloatingBodies
       write(*,*) iopt_FloatingBodies
       write(88,*)iopt_FloatingBodies
       nbfm = nn
       print*,'nbfm ',nbfm
       write(88,*)nbfm
       do while (iopt_FloatingBodies.eq.1)
         call FloatingBodies_Particles(nn,N1,N,M,dx,dy,dz,beta)
         write(*,*) ' Add another Floating Body (1=yes)'
         read(*,*)  iopt_FloatingBodies
         write(*,*) iopt_FloatingBodies
       enddo
       !write(88,*)num_FB
       close(88)


	nb=nn

	write(*,*) 'No of B. Particles',nb

	call fluid_particles(nn,N,M,L,dx,dy,dz,expont,g,i_correct_pb,
     +            XXmin,XXmax,YYmin,YYmax,ZZmin,ZZmax,beta,theta)

	np=nn
	write(*,*) 'No of Particles',np

	if(i_correct_pb.eq.1) then
	   call correct_p_boundaries(expont,g,XXmin,XXmax,YYmin,
     +			             YYmax,ZZmin,ZZmax,dx,dy,dz)
        else
	   call p_boundaries(dx,dy,dz)
	endif

	write(*,*) 'End'
	end


c	________________________   SUBROUTINE BEACH

      subroutine beach(g,expont,dx,dy,dz)
      include 'common.gen3D'

	pi=4.*atan(1.)

             
c
c      |                                                         /
c      |                                                        /
c      |                                                       /
c      |                                                      /
c      |                                                     /
c      |                                                    /
c      |                                                   /
c      |_________________________________________________ /
c      |                                                 /
c      |                                                /
c      |                                               /
c      |          i_water = 1                         /
c      |                                             /
c      |                                            /
c      |                                           /
c      |                                          /    angle beta
c      |_________________________________________/ _ _ _ _ _
c
c      <--------------- vlx1 = N1.dx------------><-- vlx2 = N2.dx -->
c      <------------------------- vlx = N.dx------------------------>
c


c     _________ Generate a BEACH


         print*
         print*,'--- Generating 3-D Beach ---'
         print*
         write(*,*) ' Box dimension LX,LY,LZ?'   
         read(*,*)  vlx,vly,vlz
         write(*,*) vlx,vly,vlz
       
         write(*,*) ' Spacing dx,dy,dz?'
         read(*,*)  dx,dy,dz
         write(*,*) dx,dy,dz
       
         write(*,*) ' Length of the flat bed before beach ?? '  
         read(*,*)  vlx1
         write(*,*) vlx1
       
         vlx2=vlx-vlx1
         
         print*,'vlx1 ',vlx1
         print*,'vlx2 ',vlx2
         print*,'vlx  ',vlx
       
         write(*,*) ' Slope (deg) of the inclined plane ( beta ) ?? '  
         read(*,*)  beta_deg
         write(*,*) beta_deg
         beta = beta_deg*pi/180.0
         !ang_beta=beta
       
         N=nint(vlx/dx)
         N1=nint(vlx1/dx)
         N2=nint(vlx2/dx)
         M=nint(vly/dy)
         L=nint(vlz/dz)

         print*
         write(*,*) ' Enter Periodicity Information:'
         write(*,*) ' Add Periodic Lateral boundaries'
         write(*,*) ' in X, Y, & Z-Directions ? (1=yes)'
         read(*,*) i_periodicOBs(1),i_periodicOBs(2),i_periodicOBs(3)
         print*
         print*,'i_periodicOBs'
         print*,'X-Direction: ',i_periodicOBs(1)
         print*,'Y-Direction: ',i_periodicOBs(2)
         print*,'Z-Direction: ',i_periodicOBs(3)
         if(i_periodicOBs(1).eq.1.or.i_periodicOBs(3).eq.1)then
           print*
           print*,'Periodic Boundaries in X & Z-Directions'
           print*,'Not yet activated in code'
           print*
           stop
         else if((i_periodicOBs(1).ne.0.and.i_periodicOBs(1).ne.1).or.
     &           (i_periodicOBs(2).ne.0.and.i_periodicOBs(2).ne.1).or.
     &           (i_periodicOBs(3).ne.0.and.i_periodicOBs(3).ne.1))then    
           print*
           print*,'Not a valid Periodic Boundaries Option'
           print*
           stop
         end if

       
        write(*,*) ' Dimension (pixels)', N,M,L
       
	nn=0	! Initial number of particles


       write(*,*)' If wavemaker will be added, left wall is not needed'
       read(*,*)  iopt_wavemaker
       write(*,*) iopt_wavemaker

       iopt_front = 0
       iopt_back  = 0
       iopt_left  = 0
       iopt_right = 0
      

c     ______ plane
       
       if(i_periodicOBs(2).ne.1)then  !Lateral Boundaries
         call boundaries_front(nn,0,N1,M,L,dx,dy,dz,0.,0.)   !y = y1
         call boundaries_back(nn,0,N1,M,L,dx,dy,dz,0.,0.)    !y = y2
         iopt_front = 1
         iopt_back  = 1
       endif
       if(i_periodicOBs(1).ne.1)then
         if(iopt_wavemaker.ne.1)then
           call boundaries_left(nn,0,N1,M,L,dx,dy,dz,0.,0.)      !x = x1
           iopt_left = 1
         endif
       endif

       iopt_front = 0
       iopt_back  = 0

c     _______ tilted plane
       
       if(i_periodicOBs(2).ne.1)then  !Lateral Boundaries
         call boundaries_front(nn,N1,N,M,L,dx,dy,dz,beta,0.)   !y = y1
         call boundaries_back (nn,N1,N,M,L,dx,dy,dz,beta,0.)   !y = y2
         iopt_front = 1
         iopt_back  = 1
       endif
       if(i_periodicOBs(1).ne.1)then
         call boundaries_right (nn,N1,N,M,L,dx,dy,dz,beta,0.)    !x = x2
           iopt_right = 1
       endif
       if(i_periodicOBs(3).ne.1)then  !Lateral Boundaries
         call boundaries_bottom(nn,0,N1,M,L,dx,dy,dz,0.  ,0.)    !flat bottom plane
         call boundaries_bottom(nn,N1,N,M,L,dx,dy,dz,beta,0.)    !inclined beach plane
       endif     
     

      open(55,file='obstacle')

      write(*,*) ' Add obstacle inside the beach (1=y)'
      read(*,*)  iopt_obst
      write(*,*) iopt_obst

	write(55,*) iopt_obst
	
	n_trapezoid = 0
	do while (iopt_obst.eq.1)
		  i_obstacleShape = 0
		  write(*,*) 'Choose rectangular (1) or trapezoid (2) '
           read(*,*) i_obstacleShape
            write(*,*)'i_obstacleShape ',i_obstacleShape
	   if(i_obstacleShape.eq.1)then
		  call obstacle(nn,dx,dy,dz,beta,0.,iopt_obst)
	   elseif(i_obstacleShape.eq.2)then
		  call trapezoid(nn,dx,dy,dz,beta,0.,iopt_obst)
		else
			print*,'invalid option'
		stop
		endif
	   write(*,*) ' Add another obstacle inside the beach (1=y)'
	   read(*,*)  iopt_obst
	   write(*,*) iopt_obst
	enddo

	nbf=nn

	write(*,*) 'No of B. Fixed Particles',nbf

	open(66,file='wavemaker')

	write(66,*) iopt_wavemaker

      iopt_wavemaker_temp = iopt_wavemaker  !Using temporary variable as iopt_wavemaker is used in fill_part
      do while(iopt_wavemaker_temp.eq.1)
         write(*,*) ' Just in Y direction'
         call wavemaker(nn,dx,dy,dz,beta,0.)
         write(*,*) ' Add another wavemaker For beach (1=y)'
         read(*,*)  iopt_wavemaker_temp
         write(*,*) iopt_wavemaker_temp
      enddo

      close(66)

      open(77,file='gate')

	write(*,*) ' Add gate inside the beach (1=y)'
	read(*,*)  iopt_gate
	write(*,*) iopt_gate

	write(77,*) iopt_gate

	do while (iopt_gate.eq.1)
	   write(*,*) ' Just in Y direction'
	   call gate(nn,dx,dy,dz,beta,0.)
	   write(*,*) ' Add another gate inside the beach (1=y)'
	   read(*,*)  iopt_gate
	   write(*,*) iopt_gate
	enddo

	close(77)
       
      open(88,file='Tsunami_Landslide.txt')
       write(*,*)' Add slidingWedge ?'
       read(*,*)  iopt_RaichlenWedge
       write(*,*) iopt_RaichlenWedge
       write(88,*)iopt_RaichlenWedge
       if(iopt_RaichlenWedge.eq.1.and.iopt_wavemaker.eq.1)then
         print*,'Cannot have Raichlen Wedge and wavemaker'
         print*,' at the same time'
         stop
       end if
       if(iopt_RaichlenWedge.eq.1)then
          call RaichlenWedge_Particles(nn,N1,N,M,dx,dy,dz,beta)
       endif
       close(88)
              
       print*
       num_FB = 0
       open(88,file='Floating_Bodies.txt')
       write(*,*)' Add Floating Bodies (1=yes) ?'
       read(*,*)  iopt_FloatingBodies
       write(*,*) iopt_FloatingBodies
       write(88,*)iopt_FloatingBodies
       if(iopt_FloatingBodies.eq.1.and.iBC.ne.1)then
         print*,'Cannot have Floating Bodies and any other '
         print*,'Boundary Condition other than Repulsive Force'
         print*,'at this time'
         stop
       end if
       nbfm = nn
       print*,'nbfm ',nbfm
       write(88,*)nbfm
       do while (iopt_FloatingBodies.eq.1)
         call FloatingBodies_Particles(nn,N1,N,M,dx,dy,dz,beta)
         write(*,*) ' Add another Floating Body (1=yes)'
         read(*,*)  iopt_FloatingBodies
         write(*,*) iopt_FloatingBodies
       enddo
       !write(88,*)num_FB
       close(88)

 	nb=nn
	write(*,*) 'No of B. Particles',nb

      i_correct_pb=1

c	______ water in the flat region

      write(*,*) ' Add water in the flat region ?? (1=y)'
      read(*,*)    i_water
      write(*,*)   i_water

      if(i_water.eq.1) then
         call fill_part(nn,XXmin,XXmax,YYmin,YYmax,ZZmin,ZZmax,
     +               g,dx,dy,dz,expont,0.,0.)
      endif

      i_correct_pb=1

c     _______ water in the inclined region

      write(*,*) ' Add water in the inclined region ?? (1=y)'
      read(*,*)    i_water2
      write(*,*)   i_water2

      if(i_water2.eq.1) then
         call fill_part(nn,XXmin,XXmax,YYmin,YYmax,ZZmin,ZZmax,
     +               g,dx,dy,dz,expont,beta,0.)
      endif


c	profile of the wave

      write(*,*) ' Add a solitary wave ?? (1=y)'
      read(*,*)    i_wave
      write(*,*)   i_wave

      if (i_wave.eq.1) then
          call wave(nn,XXmin,XXmax,YYmin,YYmax
     +                ,ZZmin,ZZmax,g,dx,dy,dz,expont)
      endif

      np=nn
      write(*,*) 'No of Particles',np


      if(i_correct_pb.eq.1) then
         call correct_p_boundaries(expont,g,XXmin,XXmax,YYmin,
     +                             YYmax,ZZmin,ZZmax,dx,dy,dz)
      else
         call p_boundaries(dx,dy,dz)
      endif

      return
      end

c	_________________ SUBROUTINE EXTERNAL_GEOMETRY

	subroutine external_geometry(dx,dy,dz)
      include 'common.gen3D'

      print*,'EXTERNAL GEOMETRY FOR 3D Not yet activated in code'
 
      return
	end


c	_________________ SUBROUTINE BOUNDARIES FRONT

      subroutine boundaries_front(NN,N0,N,M,L,dx,dy,dz,beta,theta)
      include 'common.gen3D'

c     -----------------------------------------------------------------
c     - Boundaries have 1 or 2 layers depending on choice of iBC      -
c     - iBC = 0 : Dalrymple BC - Fixed Fluid Particles     (2 layers) -
c     - iBC = 1 : Repulsive BC - Repulsive Force Particles (1 layer) -
c     -----------------------------------------------------------------

	
      !- Lateral Walls: Front y = y1 -
      print*,'Front lateral wall (y = y1) starts at ',nn+1

      if(iBC.eq.2)then        !Dalrymple BC - Fixed Fluid Particles
      
        !- Inner Layer -      
        do i=N0,N
          hk=(i-N0)*dx*tan(beta)
          Lini=nint(hk/dz)
          do k=Lini,L
            j=0
            nn=nn+1
		  call pos_veloc(nn,i*dx,j*dy,k*dz,0.,0.,0.)

          enddo
        enddo
       
        !- Outer Layer -
        do i=N0,N-1
          hk=(i-N0)*dx*tan(beta)
          Lini=nint(hk/dz)
          do k=Lini,L
            j=0
            nn=nn+1
            call pos_veloc(nn,(i+0.5)*dx,(j-0.5)*dy,(k-0.5)*dz,0.,0.,0.)
          enddo
        enddo

      
      else if(iBC.eq.1)then   !Repulsive BC - Repulsive Force Particles with Normals
        
        N_start  = N0
        if(beta.gt.0.0)then
          N_start = N_start + 1
        end if
        N_finish = N
        L_finish = L
c        print*,'N0   ,    N_start,    N_finish ',
c     &          N0, N_start, N_finish
c        print*,'dx*N0, dx*N_start, dx*N_finish ',
c     &          dx*N0, dx*N_start, dx*N_finish
        j=0
        do i = N_start,N_finish
          if(i.gt.N_start)then
            L_start_old = L_start
          else
            L_start_old = nint((i-N_start)*dx*tan(beta)/dz)
          end if
          !- Current Column  -
          hk=(i-N_start)*dx*tan(beta)  !beta = slope angle in x-direction
          L_start=nint(hk/dz)
          !- Previous Column -
          if(i.eq.N_start)then
            L_start_previous = L_start
          else
            L_start_previous = L_start_old
          end if
          !- Next Column -
          if(i.eq.N_finish)then
            L_start_next = L_start
          else
            hk_next = (i+1-N_start)*dx*tan(beta) 
            L_start_next = nint(hk/dz)
          end if
          do k = L_start,L_finish
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,k*dz,0.,0.,0.)
            if(k.eq.L_start)then
              j_minus1 = nn
              j_plus1  = nn + 1
            else if(k.eq.L_finish)then
              j_minus1 = nn - 1
              j_plus1  = nn
            else
              j_minus1 = nn - 1
              j_plus1  = nn + 1
            end if
            !- Adjust i+1 neighbour for same L_start but different i -
            if(L_start_next.eq.L_start)then
              L_minus1 = 0
            else
              L_minus1 = 1
            end if
            if(i.eq.N_start)then
              if(k.eq.L_start)then
                i_minus1 = nn + (L_finish - L_start + 1)
                i_plus1  = nn
              else
                i_minus1 = nn + (L_finish - L_start + 1 - L_minus1)
                i_plus1  = nn
              end if
            else if(i.eq.N_finish)then
              i_minus1 = nn
              i_plus1  = nn - (L_finish - L_start + 1)
            else
              if(k.eq.L_start)then
                i_minus1 = nn + (L_finish - L_start + 1)
                i_plus1  = nn - (L_finish - L_start + 1)
              else
                i_minus1 = nn + (L_finish - L_start + 1 - L_minus1)
                i_plus1  = nn - (L_finish - L_start + 1)
              end if
            end if
            !-- Normal information - neighbour data for        --
            !-- Repulsive Boundary Particles (BPs)             --
            iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
            iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
            iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
            iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          enddo
        enddo
      
      end if     !End of:  if(iBC.eq.1)then
      print*

      return
      end


c     _________________ SUBROUTINE BOUNDARIES BACK

      subroutine boundaries_back(NN,N0,N,M,L,dx,dy,dz,beta,theta)
      include 'common.gen3D'

c     -----------------------------------------------------------------
c     - Boundaries have 1 or 2 layers depending on choice of iBC      -
c     - iBC = 0 : Dalrymple BC - Fixed Fluid Particles     (2 layers) -
c     - iBC = 1 : Repulsive BC - Repulsive Force Particles (1 layer) -
c     -----------------------------------------------------------------

      !- Lateral Walls: Back y = y2 -
      print*,'Back  lateral wall (y = y2) starts at ',nn+1

      N_start  = N0
      N_finish = N
      L_finish = L

      if(iBC.eq.2)then        !Dalrymple BC - Fixed Fluid Particles
      
        !- Inner Layer -
        j=M
        do i=N0,N
          hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
          Lini=nint(hk/dz)
          do k=Lini,L           
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,k*dz,0.,0.,0.)
          enddo
        enddo

        !- Outer Layer -
        do i=N0,N-1
          j=M
          hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
          Lini=nint(hk/dz)
          do k=Lini,L                       
            nn=nn+1
            call pos_veloc(nn,(i+0.5)*dx,(j+0.5)*dy,(k-0.5)*dz,0.,0.,0.)
          enddo
        enddo
      
      else if(iBC.eq.1)then   !Repulsive BC - Repulsive Force Particles with Normals
        
        N_start  = N0
        if(beta.gt.0.0)then
          N_start = N_start + 1
        end if
        N_finish = N
        L_finish = L
c        print*,'N0   ,    N_start,    N_finish ',
c     &          N0, N_start, N_finish
c        print*,'dx*N0, dx*N_start, dx*N_finish ',
c     &          dx*N0, dx*N_start, dx*N_finish
        j=M
        do i = N_start,N_finish
          if(i.gt.N_start)then
             L_start_old = L_start
          else
            L_start_old = nint((i-N_start)*dx*tan(beta)/dz)
          end if
          !- Current Column  -
          hk=(i-N_start)*dx*tan(beta)              !beta = slope angle in x-direction
          L_start=nint(hk/dz)
          !- Previous Column -
          if(i.eq.N_start)then
            L_start_previous = L_start
          else
            L_start_previous = L_start_old
          end if
          !- Next Column -
          if(i.eq.N_finish)then
            L_start_next = L_start
          else
            hk_next = (i+1-N_start)*dx*tan(beta)  !beta = slope angle in x-direction
            L_start_next = nint(hk/dz)
          end if
          do k = L_start,L_finish
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,k*dz,0.,0.,0.)
            if(k.eq.L_start)then
              j_minus1 = nn
              j_plus1  = nn + 1
            else if(k.eq.L_finish)then
              j_minus1 = nn - 1
              j_plus1  = nn
            else
              j_minus1 = nn - 1
              j_plus1  = nn + 1
            end if
            !- Adjust i+1 neighbour for same L_start but different i -
            if(L_start_next.eq.L_start)then
              L_minus1 = 0
            else
              L_minus1 = 1
            end if
            if(i.eq.N_start)then
              if(k.eq.L_start)then
                i_minus1 = nn
                i_plus1  = nn + (L_finish - L_start + 1)
              else
                i_minus1 = nn
                i_plus1  = nn + (L_finish - L_start + 1 - L_minus1)
              end if
            else if(i.eq.N_finish)then
              i_minus1 = nn - (L_finish - L_start + 1)
              i_plus1  = nn
            else
              if(k.eq.L_start)then
                i_minus1 = nn - (L_finish - L_start + 1)
                i_plus1  = nn + (L_finish - L_start + 1)
              else
                i_minus1 = nn - (L_finish - L_start + 1)
                i_plus1  = nn + (L_finish - L_start + 1 - L_minus1)
              end if
            end if
            !-- Normal information - neighbour data for        --
            !-- Repulsive Boundary Particles (BPs)             --
            iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
            iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
            iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
            iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          end do
        end do
      end if     !End of:  if(iBC.eq.1)then

      return
      end



c     _________________ SUBROUTINE BOUNDARIES LEFT

      subroutine boundaries_left(NN,N0,N,M,L,dx,dy,dz,beta,theta)
      include 'common.gen3D'

      ! Lateral Walls: Left  x = x1
      print*,'Left  wall (x = x1) starts at ',nn+1
      N_start  = N0
      N_finish = N
      L_finish = L

      if(iBC.eq.2)then        !Dalrymple BC - Fixed Fluid Particles

        M_start_inner = 0
        M_finish_inner = M
        if(iopt_front.eq.1)then
          !M_start_inner = M_start_inner + 1   !Activate this to avoid duplicate boundary particles
        endif
        if(iopt_back.eq.1)then
          !M_finish_inner = M_finish_inner - 1  !Activate this to avoid duplicate boundary particles
        endif

        !- Inner Layer -
        i=N0
        do j=M_start_inner,M_finish_inner   !do j=0,M
          hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
          Lini=nint(hk/dz)
          do k=Lini,L
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,k*dz,0.,0.,0.)
          enddo
        enddo

	 !- Outer Layer -

          do j=0,M-1
            i=N0
            hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
            Lini=nint(hk/dz)
            do k=Lini,L
              nn=nn+1
              call pos_veloc(nn,(i-0.5)*dx,(j+0.5)*dy,(k-0.5)*dz,
     &                       0.,0.,0.)
            enddo
          enddo
   
        
      else if(iBC.eq.1)then   !Repulsive BC - Repulsive Force Particles with Normals
        
        if(i_periodicOBs(2).eq.1)then
          M_start = 0 
          M_finish = M-1
          
        else
          M_start = 0 
          M_finish = M
        end if
        N_start = 0
        N_finish = 0
        !- One Layer -
        i=N_start
        do j=M_start,M_finish    !In 2-D both are zero --> one column of BPs
          hk=(i-N_start)*dx*tan(beta)+j*dy*tan(theta)
          L_start=nint(hk/dz)
          do k=L_start,L_finish
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,k*dz,0.,0.,0.)
           !3-D Normals
              if(j.eq.M_start)then
                j_minus1 = nn
                j_plus1  = nn + (L_finish - L_start + 1)
              else if(j.eq.M_finish)then
                j_minus1 = nn - (L_finish - L_start + 1)
                j_plus1  = nn
              else
                j_minus1 = nn - (L_finish - L_start + 1)
                j_plus1  = nn + (L_finish - L_start + 1)
              end if
              if(k.eq.L_start)then
                i_minus1 = nn + 1
                i_plus1  = nn 
              else if(k.eq.L_finish)then
                i_minus1 = nn 
                i_plus1  = nn - 1
              else
                i_minus1 = nn + 1
                i_plus1  = nn - 1
              end if
              !-- Normal information - neighbour data for        --
              !-- Repulsive Boundary Particles (BPs)             --
              iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
              iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
              iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
              iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
           
          enddo
        enddo

      end if     !End of:  if(iBC.eq.1)then

      return
      end

c     _________________ SUBROUTINE BOUNDARIES RIGHT

      subroutine boundaries_right(NN,N0,N,M,L,dx,dy,dz,beta,theta)
      include 'common.gen3D'

      ! Lateral Walls: Right  x = x2
      print*,'Right wall (x = x2) starts at ',nn+1
      
      N_start  = N0
      N_finish = N
      L_finish = L
      if(i_periodicOBs(2).eq.1)then
        M_start = 0
        M_finish = M-1
      else
        M_start = 0 
        M_finish = M
      end if

      if(iBC.eq.2)then        !Dalrymple BC - Fixed Fluid Particles

        M_start_inner  = M_start
        M_finish_inner = M_finish
        if(iopt_front.eq.1)then
          !M_start_inner = M_start_inner + 1  !Activate this to avoid duplicate boundary particles
        endif
        if(iopt_back.eq.1)then
          !M_finish_inner = M_finish - 1  !Activate this to avoid duplicate boundary particles
        endif

        !- Inner Layer -
        do j=M_start_inner,M_finish_inner   !do j=M_start,M_finish
          i=N
          hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
          Lini=nint(hk/dz)
          do k=Lini,L
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,k*dz,0.,0.,0.)
          enddo
        enddo

	 !- Outer Layer -

          do j=M_start,M_finish-1
            i=N
            hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
            Lini=nint(hk/dz)
            do k=Lini,L
              nn=nn+1
              call pos_veloc(nn,(i+0.5)*dx,(j+0.5)*dy,(k-0.5)*dz,
     &                          0.,0.,0.)
            enddo
          enddo
               
      else if(iBC.eq.1)then   !Repulsive BC - Repulsive Force Particles with Normals
        
        N_start = N0
        N_finish = N
        !- One Layer -
        i=N_finish
        do j=M_start,M_finish      !In 2-D both are zero --> one column of BPs
          hk=(i-N_start)*dx*tan(beta)+j*dy*tan(theta)
          L_start=nint(hk/dz)
          do k=L_start,L_finish
            nn=nn+1
            !print*,'nn,i*dx,j*dy,k*dz ',nn,i*dx,j*dy,k*dz
            call pos_veloc(nn,i*dx,j*dy,k*dz,0.,0.,0.)
            !print*,'nn,xp, yp, zp ',nn,xp(nn),yp(nn),zp(nn)
              if(j.eq.M_start)then
                j_minus1 = nn
                j_plus1  = nn + (L_finish - L_start + 1)
              else if(j.eq.M_finish)then
                j_minus1 = nn - (L_finish - L_start + 1)
                j_plus1  = nn
              else
                j_minus1 = nn - (L_finish - L_start + 1)
                j_plus1  = nn + (L_finish - L_start + 1)
              end if
              if(k.eq.L_start)then
                i_minus1 = nn 
                i_plus1  = nn + 1
              else if(k.eq.L_finish)then
                i_minus1 = nn - 1
                i_plus1  = nn 
              else
                i_minus1 = nn - 1
                i_plus1  = nn + 1
              end if
              !-- Normal information - neighbour data for        --
              !-- Repulsive Boundary Particles (BPs)             --
              iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
              iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
              iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
              iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          
          enddo
        enddo
        
      end if     !End of:  if(iBC.eq.1)then

      return
      end


c     _________________ SUBROUTINE BOUNDARIES BOTTOM

      subroutine boundaries_bottom(NN,N0,N,M,L,dx,dy,dz,beta,theta)
      include 'common.gen3D'

      double precision hk
      logical i_xPeriodic, i_yPeriodic, i_zPeriodic


      !- Bottom -
      if(beta.gt.0.0)then
        print*,'Inclined Plane boundary starts at ',nn+1
      else 
        print*,'Bottom boundary starts at         ',nn+1
      end if

      !- One Layer -
      if(i_periodicOBs(2).eq.1)then
        M_start = 0 
        M_finish = M-1
      else
        M_start = 0 
        M_finish = M
      end if
      
      if(i_periodicOBs(1).eq.1)then
        i_xPeriodic = .true.
        N_BC2_finish = N
      else
        i_xPeriodic = .false.
        N_BC2_finish = N-1
      endif
      if(i_periodicOBs(2).eq.1)then
        i_yPeriodic = .true.
        M_finish_OuterLayer = M_finish
      else
        i_yPeriodic = .false.
        M_finish_OuterLayer = M_finish - 1
      endif
      if(i_periodicOBs(3).eq.1)then
        i_zPeriodic = .true.
      else
        i_zPeriodic = .false.
      endif
c      print*,'i_xPeriodic, i_yPeriodic, i_zPeriodic ',
c     &        i_xPeriodic, i_yPeriodic, i_zPeriodic
c      print*,'vlx, vly, vlz ',vlx, vly, vlz
c      print*,'vlx, vly, vlz ',vlx, vly, vlz

      if(iBC.eq.2)then        !Dalrymple BC - Fixed Fluid Particles

        M_start_inner  = M_start
        M_finish_inner = M_finish
        if(iopt_front.eq.1)then
          !M_start_inner  = M_start_inner + 1  !Activate this to avoid duplicate boundary particles
        endif
        if(iopt_back.eq.1)then
          !M_finish_inner = M_finish_inner - 1  !Activate this to avoid duplicate boundary particles
        endif

        N0_inner           = N0
        N_BC2_finish_inner = N_BC2_finish
        if(iopt_left.eq.1)then
          N0_inner = N0_inner + 1
        endif
        if(iopt_right.eq.1)then
          N_BC2_finish_inner = N_BC2_finish_inner - 1
        endif

        !- Inner Layer -
        do i=N0_inner,N_BC2_finish_inner !N
          do j=M_start_inner,M_finish_inner
            if((i*dx.lt.0.99*vlx.and.i_xPeriodic)
     &                                      .or.(.NOT.i_xPeriodic))then
              hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
              nn=nn+1
              call pos_veloc(nn,i*dx,j*dy,hk,0.,0.,0.)
            endif
          enddo
        enddo

        !- Outer Layer -
        if(iBC.ne.1)then
          do i=N0,N_BC2_finish  !N-1
            do j=M_start,M_finish_OuterLayer   !do j=M_start,M_finish-1
             if(((i+0.5)*dx.lt.1.00*vlx.and.i_xPeriodic)
     &                                      .or.(.NOT.i_xPeriodic))then
              hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
              nn=nn+1
              call pos_veloc(nn,(i+0.5)*dx,(j+0.5)*dy,hk-0.5*dz,
     &                          0.,0.,0.)
             endif
            enddo
          enddo
        endif
               
      else if(iBC.eq.1)then   !Repulsive BC - Repulsive Force Particles with Normals
        

        if(i_geometry.eq.2)then   !Sloping Beach
          !N_finish = int((x_beach_start - 0.0)/dx) + 1
          if(beta.gt.0.0)then  !Inclined Plane Section
            !N_start = int((vlx1/dx)) + 1
            N_start = nint((vlx1/dx))   !BE CAREFUL HERE, use nint when Corner Particles are active
            N_finish = N
          else                     !Flat Bed Section
            N_start = 0
            N_finish = int((vlx1/dx))
          end if
        else
          N_start = 0
          N_finish = N
        end if
        
        print*,'In bottom_boundary, beta', beta
        print*,'vlx1, dx ',vlx1, dx
        print*,'N_start, N_finish ',N_start, N_finish
        print*,'N_start*dx  ',N_start*dx
        print*,'N_finish*dx ',N_finish*dx

        do i=N_start,N_finish
          do j=M_start,M_finish         !do j=0,M

            hk=(i-N_start)*dx*tan(beta)+j*dy*tan(theta)  
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,hk,0.,0.,0.)
            
              if(j.eq.M_start)then
                j_minus1 = nn
                j_plus1  = nn + 1
              else if(j.eq.M_finish)then
                j_minus1 = nn - 1
                j_plus1  = nn
              else
                j_minus1 = nn - 1
                j_plus1  = nn + 1
              end if
              if(i.eq.N_start)then
                i_minus1 = nn
                i_plus1  = nn + (M_finish - M_start + 1)
              else if(i.eq.N_finish)then
                i_minus1 = nn - (M_finish - M_start + 1)
                i_plus1  = nn
              else
                i_minus1 = nn - (M_finish - M_start + 1)
                i_plus1  = nn + (M_finish - M_start + 1)
              end if
              !-- Normal information - neighbour data for        --
              !-- Repulsive Boundary Particles (BPs)             --
              iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
              iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
              iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
              iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
       
          enddo
        enddo
        
      end if     !End of:  if(iBC.eq.1)then
      
      print*

      return
      end

c      ____

c	___________________   SUBROUTINE POS_VELOC

	subroutine pos_veloc(nn,xpos,ypos,zpos,uveloc,vveloc,wveloc)
        include 'common.gen3D'

       double precision xpos,ypos,zpos

	xp(nn)=xpos
	yp(nn)=ypos
	zp(nn)=zpos
	up(nn)=uveloc
	vp(nn)=vveloc
	wp(nn)=wveloc



	return
	end

C	____

c	____________________ SUBROUTINE FLUID_PARTICLES

	subroutine fluid_particles(nn,N,M,L,dx,dy,dz,expont,g,
     +                              i_correct_pb,XXmin,XXmax,YYmin,
     +                              YYmax,ZZmin,ZZmax,beta,theta)
      include 'common.gen3D'

	write(*,*) 'Initial conditions'
	write(*,*) '1) Set of particles without grid'
	write(*,*) '2) Fill a square shaped region '
	write(*,*) '3) Round shaped drop  '
	write(*,*) '  Which Initial condition ??'
	read(*,*)  initial
	write(*,*) initial
	 
C	 I_CORRECT_PB =   1 bound. pressure will  be corrected
C		          0 boundary pressure will not be corrected


	if(initial.eq.1) then
          i_correct_pb=0
	    call set(nn,g,expont,ZZmin,ZZmax,dx,dy,dz)
	else if(initial.eq.2) then
          write(*,*) ' Correct pressure at boundaries ?? (1=y)'
	    read(*,*)    i_correct_pb
	    write(*,*)   i_correct_pb
	    iopt_fill_part=1
	    do while (iopt_fill_part.eq.1)
	       call fill_part(nn,XXmin,XXmax,YYmin,YYmax
     +                     ,ZZmin,ZZmax,g,dx,dy,dz,expont,beta,theta)
	       write(*,*)'Last Particle',nn
             write(*,*) ' Fill a new region ?? (1=y)'
	       read(*,*)    iopt_fill_part
	       write(*,*)   iopt_fill_part
	    enddo
	else if(initial.eq.3) then
          i_correct_pb=0
	    call drop(nn,g,dx,dy,dz,expont)
	
	else
          write(*,*) initial,' is not a valid I. Condition'
	    stop
	endif

	return

	end

c	_____

c	____________________ SUBROUTINE PRESSURE

      subroutine pressure(nn,ZZmax,dx,dy,dz,expont,g)
      include 'common.gen3D'

      rhop(nn)=rho0*(1.0+rho0*g*(ZZmax-zp(nn))/B)**expont
      p(nn)=B*((rhop(nn)/rho0)**gamma-1.0)
	
      pm(nn)=vnorm_mass*rhop(nn)*dx*dy*dz

      return
	end


c	____________________ SUBROUTINE CORRECT_P_BOUNDARIES

      subroutine correct_p_boundaries (expont,g,XXmin,XXmax,YYmin,
     +			                 YYmax,ZZmin,ZZmax,dx,dy,dz)
      include 'common.gen3D'

	dr=dx*dy*dz


	do nn=1,nb
	   if (xp(nn).le.XXmax. and. xp(nn).ge.XXmin.and.
     +	       yp(nn).le.YYmax. and. yp(nn).ge.YYmin.and.
     +	       Zp(nn).le.ZZmax. and. zp(nn).ge.ZZmin) then

               rhop(nn)=rho0*(1.0+rho0*g*(ZZmax-zp(nn))/B)**expont
	   else
		     rhop(nn)=rho0
	   endif

         p(nn)=B*((rhop(nn)/rho0)**gamma-1.0)

	   if (IBC.eq.1) then
            pm(nn)=rhop(nn)*dr
	   else if (IBC.eq.2) then
            if(nn.gt.nbfm) then
               pm(nn)=rhop(nn)*dr   ! only one layer of particles for Floating Bodies faces
            else
               pm(nn)=0.5*rhop(nn)*dr
            endif
	   endif

	enddo

      return

	end

c	______

c	____________________ SUBROUTINE P_BOUNDARIES

      subroutine p_boundaries (dx,dy,dz)
      include 'common.gen3D'

      dr=dx*dy*dz


	do nn=1,nb
	   rhop(nn)=rho0
         p(nn)=0.

	   if (IBC.eq.1) then
            pm(nn)=rhop(nn)*dr
	   else if (IBC.eq.2) then
            if(nn.gt.nbfm) then
               pm(nn)=rhop(nn)*dr   ! only one layer of particles for Floating Bodies faces
            else
               pm(nn)=0.5*rhop(nn)*dr
            endif
	   endif

	enddo

      return

	end

c	______

c	____________________ SUBROUTINE SET

      subroutine set (nn,g,expont,ZZmin,ZZmax,dx,dy,dz)
      include 'common.gen3D'

      write(*,*) ' Number of particles ??'
	read(*,*) number
	write(*,*) number

	do num=1,number
	   nn=nn+1
	   
	   write(*,*) 'Position X,Y,Z'     
	   read(*,*)  xp(nn),yp(nn),zp(nn)
	   write(*,*) xp(nn),yp(nn),zp(nn)  
	   write(*,*) 'Velocity X,Y,Z'     
	   read(*,*)  up(nn),vp(nn),wp(nn)
	   write(*,*) up(nn),vp(nn),wp(nn)
	   	
         call pressure(nn,zp(nn),dx,dy,dz,expont,g)
	enddo

c	NOTE:For a set of particles without grid B is estimated
c          using the Z coordinate of the box

      return
	end
c	______
c	____________________ SUBROUTINE FILL_PART
       
       subroutine fill_part(nn,XXmin,XXmax,YYmin,YYmax,ZZmin,ZZmax,
     +	                     g,dx,dy,dz,expont,beta,theta)
       include 'common.gen3D'
       
      double precision x1,y1,z1
      double precision XXmin_initial, YYmin_initial, ZZmin_initial
      double precision XXmax_initial, YYmax_initial, ZZmax_initial
       
       write(*,*) ' Cube containing particles'
       write(*,*) ' XMin, Xmax ??'
       read(*,*) XXmin,XXmax
       write(*,*) XXmin,XXmax

       write(*,*) ' YMin, Ymax ??'	 
       read(*,*) YYmin,YYmax
       write(*,*) YYmin,YYmax
       
       write(*,*) ' ZMin, Zmax ??'
       read(*,*) ZZmin,ZZmax
       write(*,*) ZZmin,ZZmax
       
       N_end=nint(XXmax/dx)
       N_ini=nint(XXmin/dx)
       
       Nstepsx=nint((XXmax-XXmin)/dx)+1
       Nstepsy=nint((YYmax-YYmin)/dy)+1
       Nstepsz=nint((ZZmax-ZZmin)/dz)+1
       
       !- Info to stop WPs being placed at same exact location as BPs -
       XXmin_initial = XXmin
       XXmax_initial = XXmax
       YYmin_initial = YYmin
       YYmax_initial = YYmax
       ZZmin_initial = ZZmin
       ZZmax_initial = ZZmax
       write(*,*)
       write(*,*)'XXmin_initial ',XXmin_initial
       write(*,*)'XXmax_initial ',XXmax_initial
       write(*,*)'YYmin_initial ',YYmin_initial
       write(*,*)'YYmax_initial ',YYmax_initial
       write(*,*)'ZZmin_initial ',ZZmin_initial
       write(*,*)'ZZmax_initial ',ZZmax_initial
       write(*,*)
       !---------------------
       
       print*,'num_FB ',num_FB
       if(num_FB.gt.0)then
         print*,'x_cyl_min(num_FB) ',x_cyl_min(num_FB)
         print*,'y_cyl_min(num_FB) ',y_cyl_min(num_FB)
         print*,'z_cyl_min(num_FB) ',z_cyl_min(num_FB)
         print*,'x_cyl_max(num_FB) ',x_cyl_max(num_FB)
         print*,'y_cyl_max(num_FB) ',y_cyl_max(num_FB)
         print*,'z_cyl_max(num_FB) ',z_cyl_max(num_FB)       
       endif      
       
       XXmin = N_ini*dx
       XXmax = N_end*dx
       
       if(XXmin.gt.XXmin_initial + vnorm_mass*0.5*dx)then
         XXmin = XXmin_initial   !Undoes rounding effect nint above for certain domains
       else if(XXmin.lt.XXmin_initial + 0.99*vnorm_mass*0.5*dx)then
         XXmin = XXmin_initial   !Undoes rounding effect nint above for certain domains
       end if       


       M_end=nint(YYmax/dy)
       M_ini=nint(YYmin/dy)
 
       YYmin=M_ini*dy
       YYmax=M_end*dy

       if(iBC.eq.1)then    !Repulsive force Boundary Condition             
         if(i_periodicOBs(2).eq.1)then
           M_ini = M_ini - 1
           YYmin = YYmin - dy       !Corrects for use of nint
           YYmax = YYmax - 0.5*dy
         else if(i_geometry.ne.1)then
           YYmin = YYmin - 0.5*dy
           YYmax = YYmax - 0.5*dy
         end if
       end if
     
       if(YYmin.gt.YYmin_initial + vnorm_mass*0.5*dy)then
         YYmin = YYmin_initial   !Undoes rounding effect nint above for certain domains
       else if(YYmin.lt.YYmin_initial + 0.99*vnorm_mass*0.5*dy)then
         YYmin = YYmin_initial   !Undoes rounding effect nint above for certain domains
       end if
       if(YYmax.gt.YYmax_initial + vnorm_mass*0.5*dy)then
         YYmax = YYmax_initial   !Undoes rounding effect nint above for certain domains
       else if(YYmax.lt.YYmax_initial + 0.99*vnorm_mass*0.5*dy)then
         YYmax = YYmax_initial   !Undoes rounding effect nint above for certain domains
       end if
              
       L_end=nint(ZZmax/dz)
       ZZmax=L_end*dz
       L_ini=nint(ZZmin/dz)
       ZZmin=L_ini*dz
       
       if(ZZmax.gt.h_SWL) ZZmax = h_SWL
       
       if (iBC.eq.1) then    !Repulsive force Boundary Condition          
         if(i_periodicOBs(3).ne.1)then
           L_ini = L_ini-1
           ZZmin = (L_ini+0.5)*dz
         endif
       endif

                  
       write(*,*) 'Recalculated max and min X ',XXmax,XXmin
       write(*,*) 'Recalculated max and min Y ',YYmax,YYmin
       write(*,*) 'Recalculated max and min Z ',ZZmax,ZZmin
       
       print*,'Nstepsy ',Nstepsy
       print*,'j=1*dy     ',dy
       print*,'Nstepsy*dy ',Nstepsy*dy
       print*,'M_ini, M_end ',M_ini, M_end
       print*,'M_ini*dy     ',M_ini*dy
       print*,'M_end*dy     ',M_end*dy

       print*
       print*
       print*,'i_obstacleShape ',i_obstacleShape
       if(i_obstacleShape.gt.1)then
          print*,'n_trapezoid ',n_trapezoid
c         print*,'x,z_trapezoid(n_trapezoid,1) ',
c     &   x_trapezoid(n_trapezoid,1), z_trapezoid(n_trapezoid,1)
c         print*,'x,z_trapezoid(n_trapezoid,2) ',
c     &   x_trapezoid(n_trapezoid,2), z_trapezoid(n_trapezoid,2)
c         print*,'x,z_trapezoid(n_trapezoid,3) ',
c     &   x_trapezoid(n_trapezoid,3), z_trapezoid(n_trapezoid,3)
c         print*,'x,z_trapezoid(n_trapezoid,4) ',
c     &   x_trapezoid(n_trapezoid,4), z_trapezoid(n_trapezoid,4)
       endif
       print*,'iopt_wavemaker ',iopt_wavemaker
       print*,'i_paddleType   ',i_paddleType
       print*,'beta',beta  
       print*    
    
       print*,'N_ini, N_end ',N_ini, N_end
       write(*,*) ' Npnts x/y/z ', nstepsx,nstepsy,nstepsz
       if(beta.gt.0)L_end = L_ini + 10  
       
       do i=N_ini,N_end
         do j=M_ini,M_end   !do j=1,Nstepsy

           hk=(i-N_ini)*dx*tan(beta)+j*dy*tan(theta)
           
           if(i.eq.N_ini.and.hk.lt.ZZmin)then
             ZZmin_BC1 = hk
           end if
           
    
           if(iBC.eq.2)then
             if(beta.gt.0.0)hk = hk + 0.5*dz    !Stops water particles being placed ontop of sloping bed particles
             if(lattice.eq.2)then
               ZZmin_BC2 = ZZmin_BC1 + 0.5*dz
             else  !if(lattice.eq.1)then
               ZZmin_BC2 = ZZmin_BC1 + dz
             endif
             ZZinf=max(ZZmin_BC2,hk)
             L_ini=nint(ZZinf/dz)
             L_end=nint(ZZmax/dz)
           else if(iBC.eq.1)then    !Repulsive force Boundary Condition
             ZZinf=min(ZZmin_BC1,hk)  !MIN ensures continuity of initial particle structure
             L_ini=int(ZZinf/dz)
             L_end=int(ZZmax/dz)
             if(L_end*dz.lt.ZZmax_initial)then
               L_end = L_end + 1         
             end if
           end if
           
            
           do k=L_ini,L_end
              
             x1=XXmin+(i-N_ini)*dx
             y1=YYmin+(j-M_ini)*dy   !y1=YYmin+(j-1)*dy             
             z1 = ZZinf+(k-L_ini)*dz
       
             !Check limits for objects
             if(iopt_wavemaker.eq.1)then
               if(i_paddleType.eq.2)then
                 XX_extra =  X_PaddleCentre 
     &               +0.5*(1.0+(z1 - paddle_SWL)/
     &                    (flap_length+paddle_SWL))*stroke
               elseif(i_paddleType.eq.3)then
                 XX_extra =  X_PaddleStart_3
               else
                 XX_extra =  X_PaddleCentre
               end if
               if(x1.gt.XX_extra + 0.5*dx)then
                 i_createParticle = 1
               else
                 i_createParticle = 0
               end if
             else if(iopt_RaichlenWedge.eq.1)then
               if(    x1.ge.block_xstart_point-0.5*dx
     &           .and.x1.le.block_xfinish_point+0.5*dx
     &           .and.y1.ge.block_ystart_point-0.5*dy
     &           .and.y1.le.block_yfinish_point+0.5*dy
     &           .and.z1.le.block_top+0.5*dz)then
                 i_createParticle = 0
               else
                 i_createParticle = 1
               end if
            
             else
               i_createParticle = 1
             end if

             z_clearanceFactor = 0.75  !YOU CAN CHANGE THIS!!
             if(i_obstacleShape.gt.1.and.i_createParticle.eq.1)then
             i_trapezoid = 0
c              do while(i_createParticle.eq.1
c     &             .or.i_trapezoid.lt.n_trapezoid)
             do while(i_trapezoid.lt.n_trapezoid)
             i_trapezoid = i_trapezoid + 1

               if(x1.ge.x_trapezoid(i_trapezoid,4))then
                 i_createParticle = 1
               elseif(x1.ge.x_trapezoid(i_trapezoid,3))then
                 trapezoid_slope1 =
     &           (z_trapezoid(i_trapezoid,4)-z_trapezoid(i_trapezoid,3))
     &          /(x_trapezoid(i_trapezoid,4)-x_trapezoid(i_trapezoid,3))            
                 z_trap_temp = z_trapezoid(i_trapezoid,3) + 
     &           (x1 - x_trapezoid(i_trapezoid,3))*trapezoid_slope1
                 !print*,'
                 if(z1.lt.z_trap_temp+(z_clearanceFactor+0.5)*dz)then
                   i_createParticle = 0
                   i_trapezoid = n_trapezoid + 1
                 else
                   i_createParticle = 1
                 endif
               elseif(x1.ge.x_trapezoid(i_trapezoid,2))then
                 z_trap_temp =
     &           (int(z_trapezoid(i_trapezoid,2)/dz) + 1)*dz   !z_trapezoid(2)
                 !print*,'
                 if(z1.lt.z_trap_temp+z_clearanceFactor*dz)then
                   i_createParticle = 0
                   i_trapezoid = n_trapezoid + 1
                 else
                   i_createParticle = 1
                 endif
               elseif(x1.ge.x_trapezoid(i_trapezoid,1))then
                 trapezoid_slope1 = 
     &           (z_trapezoid(i_trapezoid,2)-z_trapezoid(i_trapezoid,1))
     &          /(x_trapezoid(i_trapezoid,2)-x_trapezoid(i_trapezoid,1))            
                 z_trap_temp = z_trapezoid(i_trapezoid,1) + 
     &           (x1 - x_trapezoid(i_trapezoid,1))*trapezoid_slope1
                 !print*,'
                 if(z1.lt.z_trap_temp+z_clearanceFactor*dz)then
                   i_createParticle = 0
                   i_trapezoid = n_trapezoid + 1
                 else
                   i_createParticle = 1
                 endif
               else
                 i_createParticle = 1
               endif
               if(y1.lt.y_trapezoid(1)- z_clearanceFactor*dy.or.
     &            y1.gt.y_trapezoid(2)+ z_clearanceFactor*dy
     &                  +i_periodicOBs(2)*dy)then
                 i_createParticle = 1
               endif              
              enddo   !End of: do while(i_createParticle.eq.0)
             endif

             !- Floating Bodies -  For now, All objects are assumed to be square cylinders horizontally orientated
             if(num_FB.gt.0.and.i_createParticle.eq.1)then
               i_num_FB = 0
               i_outsideObject = 1
               do while (i_num_FB.lt.num_FB.and.i_outsideObject.eq.1)
                 i_num_FB = i_num_FB + 1
                 !- Define clearance limits around object
                 if(iopt_FloatingObject_type(i_num_FB).eq.1)then   !Square cylinder
                   !- Transform particle coordinates to Object Frame of reference -
                   !- rotate about Centre of Gravity (CofG) - 
                   dx_newParticle = x1 - Box_XC(i_num_FB)
                   dy_newParticle = y1 - Box_YC(i_num_FB)
                   dz_newParticle = z1 - Box_ZC(i_num_FB)
                   !- Generate 3-D Rotation Matrix -
                   sin_theta = sin(body_AngleZ(i_num_FB))
                   cos_theta = cos(body_AngleZ(i_num_FB))
                   sin_phi   = sin(body_AngleY(i_num_FB))
                   cos_phi   = cos(body_AngleY(i_num_FB))
                   sin_psi   = sin(body_AngleX(i_num_FB))
                   cos_psi   = cos(body_AngleX(i_num_FB))
                   Rot_11 = cos_phi*cos_theta
                   Rot_12 = cos_phi*sin_theta
                   Rot_13 = sin_phi
                   Rot_21 = -sin_psi*sin_phi*cos_theta-cos_psi*sin_theta
                   Rot_22 = -sin_psi*sin_phi*sin_theta+cos_psi*cos_theta
                   Rot_23 =  sin_psi*cos_phi
                   Rot_31 = -cos_psi*sin_phi*cos_theta+sin_psi*sin_theta
                   Rot_32 = -cos_psi*sin_phi*sin_theta-sin_psi*cos_theta
                   Rot_33 =  cos_psi*cos_phi
                   !- transformed coordinates -
                   x1_Tr =   dx_newParticle*Rot_11
     &                     + dy_newParticle*Rot_12
     &                     + dz_newParticle*Rot_13
                   y1_Tr =   dx_newParticle*Rot_21
     &                     + dy_newParticle*Rot_22
     &                     + dz_newParticle*Rot_23
                   z1_Tr =   dx_newParticle*Rot_31
     &                     + dy_newParticle*Rot_32
     &                     + dz_newParticle*Rot_33
                   clearance_factor = 1.49
                   xtmin = - 0.5*XcylinderDimension(i_num_FB)
     &                     - clearance_factor*dx   !+ 0.5*dx
                   xtmax =   0.5*XcylinderDimension(i_num_FB)
     &                     + clearance_factor*dx   !+ 0.50*dx
                   ytmin = - 0.5*YcylinderDimension(i_num_FB)
     &                     - clearance_factor*dx   !+ 0.5*dx
                   ytmax =   0.5*YcylinderDimension(i_num_FB)
     &                     + clearance_factor*dx   !+ 0.50*dx
                   ztmin = - 0.5*ZcylinderDimension(i_num_FB)
     &                     - clearance_factor*dz   !+ 0.5*dz
                   ztmax =   0.5*ZcylinderDimension(i_num_FB)
     &                     + clearance_factor*dz
                   if(x1_Tr.gt.xtmin.and.x1_Tr.lt.xtmax)then
                     if((z1_Tr.gt.ztmin.and.z1_Tr.lt.ztmax))then  !WP is within x-range of cylinder but above or below
                       if((y1_Tr.gt.ytmin.and.y1_Tr.lt.ytmax))then
                         i_outsideObject = 0
                       else
                         i_outsideObject = 1
                       endif
                     else
                       i_outsideObject = 1
                     end if
                   else
                     i_outsideObject = 1
                   end if
                 elseif(iopt_FloatingObject_type(i_num_FB).eq.2)then   !Other
                   !- Transform particle coordinates to Object Frame of reference -
                   !- rotate about bottom left-hand corner - 
                   print*
                   print*,'ERROR in fill_part'
                   print*,'Invalid option for FloatingObject_type'
                   print*,'i_num_FB ',i_num_FB
                   print*,'iopt_FloatingObject_type(i_num_FB) ',
     &                     iopt_FloatingObject_type(i_num_FB)
                   print*,'You will need to write your own code '
                   print*,'for your own object'
                   stop
                 endif
               enddo
               if(i_outsideObject.eq.1)then
                 i_createParticle = 1
               else
                 i_createParticle = 0
               end if
             endif   !End of Floating Body Check             
                          
             if(i_createParticle.eq.1)then
             
               if(iBC.eq.2)then   !Dalrymple BC
                 nn=nn+1       
                 call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
                 call pressure(nn,ZZmax,dx,dy,dz,expont,g)
               else if(iBC.eq.1)then   !Repulsive BC
                 !hk2 = (x1-N_ini*dx)*tan(beta)+j*dy*tan(theta)   
                 hk2 = (x1-vlx1)*tan(beta)+j*dy*tan(theta)   
                 if(z1.gt.(1.001*hk2+0.25*dz).and.
     &              z1.lt.1.001*ZZmax.and.
     &              y1.gt.0.999*YYmin_initial.and.
     &              y1.lt.0.999*YYmax_initial+0.5*dy.and.
     &              x1.gt.0.999*XXmin_initial.and.
     &              x1.lt.0.999*XXmax_initial+0.5*dx)then
                   nn=nn+1       
                   call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
                   call pressure(nn,ZZmax,dx,dy,dz,expont,g)
                 end if
               end if
               
               if (lattice.eq.2) then !BCC	

                   x1=XXmin+(i-N_ini+0.5)*dx
                   y1=YYmin+(j-M_ini+0.5)*dy   !y1=YYmin+(j-1+0.5)*dy
                   
                   hk2 = (x1-N_ini*dx)*tan(beta)+j*dy*tan(theta)   
                   z1=ZZinf+(k-L_ini+0.5)*dz
                   if(x1.le.1.001*XXmax.and.y1.le.1.001*YYmax.and.
     +                z1.le.1.001*ZZmax) then ! 1.01 to avoid roundoff
                     if(iBC.eq.2)then   !Dalrymple BC
                       nn=nn+1       
                       call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
                       call pressure(nn,ZZmax,dx,dy,dz,expont,g)
                     else if(iBC.eq.1)then   !Repulsive BC
                       hk2 = (x1-vlx1)*tan(beta)+j*dy*tan(theta)
                       if(z1.gt.1.001*hk2+0.25*dz.and.
     &                     z1.lt.1.001*ZZmax.and.
     &                     y1.gt.0.999*YYmin_initial.and.
     &                     y1.lt.0.999*YYmax_initial+0.25*dy.and.
     &                     x1.gt.0.999*XXmin_initial.and.
     &                     x1.lt.0.999*XXmax_initial+0.25*dx)then
                         nn=nn+1       
                         call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
                         call pressure(nn,ZZmax,dx,dy,dz,expont,g)
                       endif
                     end if
                   endif
                
               endif
             end if   !End of:   if(i_createParticle.eq.1)then
           enddo
         enddo
       enddo
       
       print*,'nn ',nn
       
       return       
       end
       
c	______
      
c	______

c	____________________ SUBROUTINE DROP

      subroutine drop(nn,g,dx,dy,dz,expont)
      include 'common.gen3D'


	write(*,*) ' Center of the drop: Xcen, Ycen, Zcen ??'  
	read (*,*)  Xcen, Ycen, Zcen			
	write(*,*)  Xcen, Ycen, Zcen

	write(*,*) ' Radius'
	read (*,*)  Radius
	write(*,*)  Radius

	write(*,*) ' Velocidad en X, en Y, en Z'   
	read (*,*)  uveloc,vveloc,wveloc
	write(*,*)  uveloc,vveloc,wveloc

	XXmin=Xcen-Radius
	XXmax=Xcen+Radius
	YYmin=Ycen-Radius
	YYmax=Ycen+Radius
	ZZmin=Zcen-Radius
	ZZmax=Zcen+Radius

	N_end=nint(XXmax/dx)
	N_ini=nint(XXmin/dx)

	M_end=nint(YYmax/dy)
	M_ini=nint(YYmin/dy)

	L_end=nint(ZZmax/dz)
	ZZmax=l_end*dz
	L_ini=nint(ZZmin/dz)
	ZZmin=L_ini*dz
	write(*,*) 'Recalculated max and min Z ',ZZmax,ZZmin
  
			    
	do i=N_ini,N_end
	do j=M_ini,M_end
	do k=L_ini,L_end
	       Xdif=(i+0.5)*dx-Xcen
	       Xdif=Xdif*Xdif
	       Ydif=(j+0.5)*dy-Ycen
		   Ydif=Ydif*Ydif
	       Zdif=(k+0.5)*dz-Zcen
	       Zdif=Zdif*Zdif

             if(abs(sqrt(Xdif+Ydif+Zdif)).le.radius) then
                nn=nn+1
                call pos_veloc(nn,(i+0.5)*dx,(j+0.5)*dy,
     +			  (k+0.5)*dz,uveloc,vveloc,wveloc)
	          call pressure(nn,ZZmax,dx,dy,dz,expont,g)
	          if (lattice.eq.2) then !BCC
				  nn=nn+1
                    call pos_veloc(nn,(i+1)*dx,(j+1)*dy,(k+1)*dz,
     +                          uveloc,vveloc,wveloc)
                    call pressure(nn,ZZmax,dx,dy,dz,expont,g)
	          endif
             endif
	enddo
	enddo
	enddo

      return

	end

c	______

c	____________________ SUBROUTINE WALL

      subroutine wall(nn,dx,dy,dz,beta,theta)
      include 'common.gen3D'

      double precision Xwall

	write(*,*) ' Wall position in X coordinates ??'
	write(*,*) ' X Wall ??'
	read(*,*) Xwall

	write(*,*) ' Wall height ??'
	write(*,*) ' Zwall ??'
	read(*,*) Zwall


	write(*,*) ' Start and end of the wall in Y ??' 
	write(*,*) ' YYMin, YYmax ??'
	read(*,*) YYmin,YYmax
	write(*,*) YYmin,YYmax
	M_ini=nint(YYmin/dy)
      M_end=nint(YYmax/dy)
	
	L_end=nint(Zwall/dz)
c	L_ini=0

	write(*,*)M_end,M_ini,L_end,L_ini
	write(*,*)'Begining of wall at ',nn+1

	do j=M_ini,M_end
	    hk=Xwall*tan(beta)+j*dy*tan(theta)
	    L_ini=nint(hk/dz)
	    do k=L_ini,L_end
	         nn=nn+1
	     call pos_veloc(nn,Xwall,j*dy,k*dz,0.,0.,0.)
		 
	       if((j+0.5)*dy.le.YYmax.and.(k+0.5)*dz.le.Zwall) then
  	         nn=nn+1
	         call pos_veloc(nn,Xwall+0.5*dx,(j+0.5)*dy,
     +		                   (k+0.5)*dz,0.,0.,0.)
	       endif
	   enddo
	enddo

	write(*,*)'End of wall at ',nn

	return
	end


c	______

c	____________________ SUBROUTINE WALL_SLOT

      subroutine wall_slot(nn,dx,dy,dz,beta,theta)
      include 'common.gen3D'

      double precision xpto,ypto,zpto
	double precision Xwall
	
	write(*,*)'wall slot beginning at',nn

	write(*,*) ' Wall position in X coordinates ??'
	write(*,*) ' X Wall ??'
	read(*,*)  Xwall
	write(*,*) Xwall

	write(*,*) ' Wall height ??'
	write(*,*) ' Zwall ??'
	read(*,*) Zwall
	write(*,*) Zwall

	write(*,*) ' Start and end of the wall in Y ??'	
	write(*,*) ' YYMin, YYmax ??'
	read(*,*) YYmin,YYmax
	write(*,*) YYmin,YYmax

	M_end=nint(YYmax/dy)
	M_ini=nint(YYmin/dy)

	L_end=nint(Zwall/dz)

c	L_ini=0

C	The slot
      write(*,*) ' Start and end of slot in Y ??'  
	write(*,*) ' YMin, Ymax ??'
	read(*,*) Ymin_slot,Ymax_slot
	write(*,*) Ymin_slot,Ymax_slot
	  	
	write(*,*) ' Start and end of slot in Z ??'
	write(*,*) ' ZMin, Zmax ??'
	read(*,*)  Zmin_slot,Zmax_slot
	write(*,*) Zmin_slot,Zmax_slot

	do j=M_ini,M_end
	    hk=Xwall*tan(beta)+j*dy*tan(theta)
	    L_ini=nint(hk/dz)
	    do k=L_ini,L_end

	      ypto=j*dy
	      zpto=k*dz
	      if(ypto.lt.Ymin_slot.or.ypto.gt.Ymax_slot.or.
     +         zpto.lt.Zmin_slot.or.zpto.gt.Zmax_slot) then
	         nn=nn+1
	         call pos_veloc(nn,Xwall,ypto,zpto,0.,0.,0.)

	      endif

	      ypto=(j+0.5)*dy
	      zpto=(k+0.5)*dz
	      if(ypto.lt.Ymin_slot.or.ypto.gt.Ymax_slot.or.
     +         zpto.lt.Zmin_slot.or.zpto.gt.Zmax_slot) then
	        if(ypto.le.YYmax.and.zpto.le.Zwall) then
  	          nn=nn+1
	          call pos_veloc(nn,Xwall+0.5*dx,ypto,zpto,0.,0.,0.)
	       endif
	     endif
	   enddo
	enddo
	
	return
	end

c	_____
c	____________________ SUBROUTINE WALL_HOLE

      subroutine wall_hole(nn,dx,dy,dz,beta,theta)
      include 'common.gen3D'

      double precision Xwall
	double precision ypto,zpto

	write(*,*)'wall hole begining at',nn

	write(*,*) ' Wall position in X coordinates ??'
	write(*,*) ' X Wall ??'
	read(*,*)  Xwall
	write(*,*) Xwall

	write(*,*) ' Wall height ??'
	write(*,*) ' Zwall ??'
	read(*,*) Zwall
	write(*,*) Zwall
      
	write(*,*) ' Start and end of the wall in Y ??'   	
      write(*,*) ' YYMin, YYmax ??'
      read(*,*) YYmin,YYmax
	write(*,*) YYmin,YYmax

      M_end=nint(YYmax/dy)
      M_ini=nint(YYmin/dy)

	L_end=nint(Zwall/dz)
c	L_ini=0

      write(*,*) ' Center of the hole: Ycen, Zcen ??'  	
	read (*,*)  Ycen, Zcen
	write(*,*)  Ycen, Zcen
	write(*,*) ' Radius'
	read (*,*)  Radius
	write(*,*)  Radius
    	    	
	do j=M_ini,M_end
	    hk=Xwall*tan(beta)+j*dy*tan(theta)
	    L_ini=nint(hk/dz)
	    do k=L_ini,L_end
	      ypto=j*dy
	      zpto=k*dz
	      ydif=ypto-Ycen
	      ydif=ydif*ydif
	      zdif=zpto-Zcen
	      zdif=zdif*zdif
	      dist=abs(sqrt(ydif+zdif))
	      if(dist.ge.radius) then
	         nn=nn+1
	        call pos_veloc(nn,Xwall,ypto,zpto,0.,0.,0.)		   
	      endif
	      ypto=(j+0.5)*dy
	      zpto=(k+0.5)*dz
		  ydif=ypto-Ycen
	      ydif=ydif*ydif
	      zdif=zpto-Zcen
	      zdif=zdif*zdif
	      dist=abs(sqrt(ydif+zdif))
	      if(dist.ge.radius) then
  	        nn=nn+1
	          call pos_veloc(nn,Xwall+0.5*dx,ypto,zpto,0.,0.,0.)
     	      endif   
	   enddo
	enddo


	return
	end

c	______________________ SUBROUTINE OBSTACLE


      subroutine obstacle(nn,dx,dy,dz,beta,theta,iopt_obst)
      include 'common.gen3D'

      double precision x1,y1,z1
      double precision dx1, dy1, dz1

      write(*,*) ' Which kind of obstacle'
      write(*,*) ' (1) Solid '
      write(*,*) ' (2) With Solid Walls'
      read(*,*) iopt_kind
      write(*,*) iopt_kind
      
      write(*,*) ' Density of points'
      read(*,*) ndens
      write(*,*) ndens
      dx1=dx/ndens
      dy1=dy/ndens
      dz1=dz/ndens

      write(*,*) ' Cube containing particles'
      write(*,*) ' XMin, Xmax ??'
      read(*,*) XXmin,XXmax
      write(*,*) XXmin,XXmax


      write(*,*) ' YMin, Ymax ??'
      read(*,*) YYmin,YYmax
      write(*,*) YYmin,YYmax


      write(*,*) ' ZMin, Zmax ??'
      read(*,*) ZZmin,ZZmax
      write(*,*) ZZmin,ZZmax

      write(*,*) ' slope in X direction??'
      read(*,*) slope
      write(*,*) slope

      slope=slope*pi/180

      if (slope.eq.pi/2) then 	
        valtan_inv=0
        Xtop=1.01*XXmax
      else 
        valtan_inv =1./tan(slope)
        kmax=nint(ZZmax/dz1)
        Xtop=1.01*(XXmax+kmax*dx1*valtan_inv)
      endif

      Nstepsx=nint((XXmax-XXmin)/dx1)+1
      Nstepsy=nint((YYmax-YYmin)/dy1)+1
      Nstepsz=nint((ZZmax-ZZmin)/dz1)+1

      write(*,*) 'Npnts x/y/z', nstepsx,nstepsy,nstepsz
      write(*,*) 'Beginning of obstacle at ',nn+1

      N_ini=nint(XXmin/dx1)
      N_end=nint(XXmax/dx1)
      i0=nint(vlx1/dx1)

      M_ini=nint(YYmin/dy1)
      M_end=nint(YYmax/dy1)

      write(*,*) 'Start of obstacle at ',nn+1

      if(iBC.eq.2)then

       do i=N_ini,N_end
       do j=1,Nstepsy

        hk=(i-i0)*dx1*tan(beta)+j*dy1*tan(theta)
        ZZinf=max(ZZmin,hk)

        L_ini=nint(ZZinf/dz1)
        L_end=nint(ZZmax/dz1)

        do k=L_ini,L_end
          if(iopt_kind.eq.1) then
            x1=XXmin+(i-N_ini)*dx1+(k-L_ini)*valtan_inv*dx1
            y1=YYmin+(j-1)*dy1
            z1=ZZinf+(k-L_ini)*dz1
            nn=nn+1
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)

            x1=XXmin+(i-N_ini-0.5)*dx1+(k-L_ini)*valtan_inv*dx1
            y1=YYmin+(j-0.5)*dy1
            z1=ZZinf+(k-L_ini-0.5)*dz1

            if(x1.le.Xtop.and.y1.le.1.01*YYmax.and.
     +         z1.le.1.01*ZZmax) then ! 1.01 to avoid the roundoff
               nn=nn+1
               call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
            endif
          else if(iopt_kind.eq.2) then
              if(i.eq.N_ini.or.i.eq.N_end.or.
     +          j.eq.1.or.j.eq.Nstepsy.or.k.eq.L_end) then
                x1=XXmin+(i-N_ini)*dx1+(k-L_ini)*valtan_inv*dx1
                y1=YYmin+(j-1)*dy1
                z1=ZZinf+(k-L_ini)*dz1
                nn=nn+1
                call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
              endif
          else
            write(*,*) ' Not a valid option'
            stop
          endif
        enddo
      enddo	
      enddo

      elseif(iBC.eq.1)then

c       -- Block face 1 -  x = const = N_ini*dx1
        i = N_ini
        do j = M_ini,M_end

          hk=(i-i0)*dx1*tan(beta)+j*dy1*tan(theta)
          ZZinf=max(ZZmin,hk)
          L_ini=nint(ZZinf/dz1)
          L_end=nint(ZZmax/dz1)

          do k = L_ini,L_end
            nn=nn+1
            x1=XXmin+(i-N_ini)*dx1+(k-L_ini)*valtan_inv*dx1
            y1 = j*dy1
            z1 = k*dz1
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
            if(k.eq.L_ini)then
              j_minus1 = nn
              j_plus1  = nn + 1
            else if(k.eq.L_end)then
              j_minus1 = nn - 1
              j_plus1  = nn
            else
              j_minus1 = nn - 1
              j_plus1  = nn + 1
            end if
            if(j.eq.M_ini)then
              i_minus1 = nn + (L_end - L_ini + 1)
              i_plus1  = nn
            else if(j.eq.M_end)then
              i_minus1 = nn
              i_plus1  = nn - (L_end - L_ini + 1)
            else
              i_minus1 = nn + (L_end - L_ini + 1)
              i_plus1  = nn - (L_end - L_ini + 1)
             end if
             !-- Normal information - neighbour data for        --
             !-- Repulsive Boundary Particles (BPs)             --
             iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
             iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
             iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
             iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          end do
        end do
c       -- Block face 2 -  x = const + width = N_end*dx1
        i = N_end
        do j = M_ini,M_end

          hk=(i-i0)*dx1*tan(beta)+j*dy1*tan(theta)
          ZZinf=max(ZZmin,hk)
          L_ini=nint(ZZinf/dz1)
          L_end=nint(ZZmax/dz1)

          do k = L_ini,L_end
            nn=nn+1
            x1=XXmin+(i-N_ini)*dx1+(k-L_ini)*valtan_inv*dx1
            y1 = j*dy1
            z1 = k*dz1
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
            if(k.eq.L_ini)then
              j_minus1 = nn + 1
              j_plus1  = nn
            else if(k.eq.L_end)then
              j_minus1 = nn
              j_plus1  = nn - 1
            else
              j_minus1 = nn + 1
              j_plus1  = nn - 1
            end if
            if(j.eq.M_ini)then
              i_minus1 = nn + (L_end - L_ini + 1)
              i_plus1  = nn
            else if(j.eq.M_end)then
              i_minus1 = nn
              i_plus1  = nn - (L_end - L_ini + 1)
            else
              i_minus1 = nn + (L_end - L_ini + 1)
              i_plus1  = nn - (L_end - L_ini + 1)
             end if
             !-- Normal information - neighbour data for        --
             !-- Repulsive Boundary Particles (BPs)             --
             iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
             iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
             iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
             iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          end do
        end do
c       -- Block face 3 -  y = const = M_ini*dy1
        j = M_ini
        do i = N_ini,N_end

          hk=(i-i0)*dx1*tan(beta)+j*dy1*tan(theta)
          ZZinf=max(ZZmin,hk)
          L_ini=nint(ZZinf/dz1)
          L_end=nint(ZZmax/dz1)

          do k = L_ini,L_end

            nn=nn+1
            x1=XXmin+(i-N_ini)*dx1+(k-L_ini)*valtan_inv*dx1
            y1 = j*dy1
            z1 = k*dz1
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
            if(k.eq.L_ini)then
              j_minus1 = nn + 1
              j_plus1  = nn
            else if(k.eq.L_end)then
              j_minus1 = nn
              j_plus1  = nn - 1
            else
              j_minus1 = nn + 1
              j_plus1  = nn - 1
            end if
            if(i.eq.N_ini)then
              i_minus1 = nn + (L_end - L_ini + 1)
              i_plus1  = nn
            else if(i.eq.N_end)then
              i_minus1 = nn
              i_plus1  = nn - (L_end - L_ini + 1)
            else
              i_minus1 = nn + (L_end - L_ini + 1)
              i_plus1  = nn - (L_end - L_ini + 1)
             end if
             !-- Normal information - neighbour data for        --
             !-- Repulsive Boundary Particles (BPs)             --
             iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
             iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
             iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
             iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          end do
        end do
c       -- Block face 4 -  y = const + width = M_end*dy1
        j = M_end
        do i = N_ini,N_end

          hk=(i-i0)*dx1*tan(beta)+j*dy1*tan(theta)
          ZZinf=max(ZZmin,hk)
          L_ini=nint(ZZinf/dz1)
          L_end=nint(ZZmax/dz1)

          do k = L_ini,L_end
            nn=nn+1
            x1=XXmin+(i-N_ini)*dx1+(k-L_ini)*valtan_inv*dx1
            y1 = j*dy1
            z1 = k*dz1
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
            if(k.eq.L_ini)then
              j_minus1 = nn
              j_plus1  = nn + 1
            else if(k.eq.L_end)then
              j_minus1 = nn - 1
              j_plus1  = nn
            else
              j_minus1 = nn - 1
              j_plus1  = nn + 1
            end if
            if(i.eq.N_ini)then
              i_minus1 = nn + (L_end - L_ini + 1)
              i_plus1  = nn
            else if(i.eq.N_end)then
              i_minus1 = nn
              i_plus1  = nn - (L_end - L_ini + 1)
            else
              i_minus1 = nn + (L_end - L_ini + 1)
              i_plus1  = nn - (L_end - L_ini + 1)
             end if
             !-- Normal information - neighbour data for        --
             !-- Repulsive Boundary Particles (BPs)             --
             iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
             iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
             iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
             iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          end do
        end do
c       -- Block face 5 - z = const = 
        L_end=nint(ZZmax/dz1)
        k = L_end
        do i = N_ini,N_end
          do j = M_ini,M_end
            nn=nn+1
            x1=XXmin+(i-N_ini)*dx1+(k-L_ini)*valtan_inv*dx1
            y1 = j*dy1
            z1 = k*dz1
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
            if(j.eq.M_ini)then
              j_minus1 = nn
              j_plus1  = nn + 1
            else if(j.eq.M_end)then
              j_minus1 = nn - 1
              j_plus1  = nn
            else
              j_minus1 = nn - 1
              j_plus1  = nn + 1
            end if
            if(i.eq.N_ini)then
              i_minus1 = nn
              i_plus1  = nn + (M_end - M_ini + 1)
            else if(i.eq.N_end)then
              i_minus1 = nn - (M_end - M_ini + 1)
              i_plus1  = nn
            else
              i_minus1 = nn - (M_end - M_ini + 1)
              i_plus1  = nn + (M_end - M_ini + 1)
            end if
            !-- Normal information - neighbour data for        --
            !-- Repulsive Boundary Particles (BPs)             --
            iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
            iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
            iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
            iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          end do
        end do

      endif     !End of:   if(iBC.eq.2)then

      write(*,*) 'End of obstacle at ',nn

      write(55,*) iopt_obst
      write(55,*) XXmin
      write(55,*) XXmax
      write(55,*) YYmin
      write(55,*) YYmax
      write(55,*) ZZinf
      write(55,*) ZZmax
      write(55,*) slope

      return
      end



c      ______________________ SUBROUTINE TRAPEZOID			


      subroutine trapezoid(nn,dx,dy,dz,beta,theta,iopt_obst)
      include 'common.gen3D'


      double precision x1,y1,z1,x2,y2,z2

      write(*,*) 'Start of trapezoid at ',nn+1

       n_trapezoid = n_trapezoid + 1
       if(n_trapezoid_max.gt.n_trapezoid_max)then
         print*
         print*,'ERROR in SPHYSICSgen_3D.f'
         print*,'n_trapezoid.gt.n_trapezoid_max'
         print*,'Adjust n_trapezoid_max in common.gen2D'
         stop
       endif
       print*,'Trapezoid Number = ',n_trapezoid
       write(*,*) ' Enter (x,y,z)-start  of trapezoid'
       read(*,*) x_trapezoid(n_trapezoid,1),z_trapezoid(n_trapezoid,1)
       write(*,*) x_trapezoid(n_trapezoid,1),z_trapezoid(n_trapezoid,1)
       write(*,*) ' Enter (x,y,z)-start  of trapezoid top'
       read(*,*) x_trapezoid(n_trapezoid,2),z_trapezoid(n_trapezoid,2)
       write(*,*) x_trapezoid(n_trapezoid,2),z_trapezoid(n_trapezoid,2)
       write(*,*) ' Enter (x,y,z)-finish of trapezoid top'
       read(*,*) x_trapezoid(n_trapezoid,3),z_trapezoid(n_trapezoid,3)
       write(*,*) x_trapezoid(n_trapezoid,3),z_trapezoid(n_trapezoid,3)
       write(*,*) ' Enter (x,y,z)-finish of trapezoid'
       read(*,*) x_trapezoid(n_trapezoid,4),z_trapezoid(n_trapezoid,4)
       write(*,*) x_trapezoid(n_trapezoid,4),z_trapezoid(n_trapezoid,4)
       write(*,*) ' Enter YYMin, YYMax  of trapezoid'
	 read(*,*) y_trapezoid(1), y_trapezoid(2)
	 write(*,*) y_trapezoid(1), y_trapezoid(2)

       
c       -- Trapezoid face 1: Up-slope - 
 
        N_start  = nint(x_trapezoid(n_trapezoid,1)/dx) !+ 1
        N_finish = nint(x_trapezoid(n_trapezoid,2)/dx) !+ 1 
        M_start  = nint(y_trapezoid(1)/dy)
        M_finish = nint(y_trapezoid(2)/dy)
        if(iBC.eq.2)then
          M_start  = M_start+1
          M_finish = M_finish-1
        endif
        L_start  = nint(z_trapezoid(n_trapezoid,1)/dz) !+ 1
        L_finish = nint(z_trapezoid(n_trapezoid,2)/dz) !+ 1
        trapezoid_slope1 = 
     &     (z_trapezoid(n_trapezoid,2) - z_trapezoid(n_trapezoid,1))/
     &     (x_trapezoid(n_trapezoid,2) - x_trapezoid(n_trapezoid,1))   
        ntemp = nn


        do i = N_start,N_finish
          do j = M_start,M_finish
            x1 = i*dx
            y1 = j*dy
            z1 = z_trapezoid(n_trapezoid,1)
     &       + (x1 - x_trapezoid(n_trapezoid,1))*trapezoid_slope1
            nn=nn+1
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)

            if(iBC.eq.1)then
              if(j.eq.M_start)then
                j_minus1 = nn
                j_plus1  = nn + 1
              else if(j.eq.M_finish)then
                j_minus1 = nn - 1
                j_plus1  = nn
              else
                j_minus1 = nn - 1
                j_plus1  = nn + 1
              end if
              if(i.eq.N_start)then
                i_minus1 = nn
                i_plus1  = nn + (M_finish - M_start + 1)
              else if(i.eq.N_finish)then
                i_minus1 = nn - (M_finish - M_start + 1)
                i_plus1  = nn
              else
                i_minus1 = nn - (M_finish - M_start + 1)
                i_plus1  = nn + (M_finish - M_start + 1)
              end if
              !-- Normal information - neighbour data for        --
              !-- Repulsive Boundary Particles (BPs)             --
              iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
              iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
              iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
              iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
            end if
            if(iBC.ne.1)then
              x2 = x1 + 0.5*dx
              y2 = y1 + 0.5*dy     
              z2 = z1 + 0.5*dz
              nn=nn+1
              call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
            end if

c            if(i.eq.N_start)then
c              print*,'Start of Trapezoid, x1,z1 ',x1,z1
c            endif

          enddo  ! do i
        enddo  ! do j
        z_lastPoint = z1
        x_lastpoint = x1

       if(iBC.eq.2)then

        j=M_start					
        do i=N_start,N_finish
            x1=i*dx
            ztemp = z_trapezoid(n_trapezoid,1)+
     &        (x1 - x_trapezoid(n_trapezoid,1))*trapezoid_slope1
            L_finish_temp=nint(ztemp/dz)
            ztemp2 =  z_trapezoid(n_trapezoid,1)+
     &        (x1 - x_trapezoid(n_trapezoid,1))*bslope
            L_start_temp = nint(ztemp2/dz)
            do k=L_start_temp,L_finish_temp
              nn=nn+1
              call pos_veloc(nn,x1,j*dy,k*dz,0.,0.,0.)
              if(iBC.ne.1)then
                x2 = x1   + 0.5*dx
                y2 = j*dy + 0.5*dy     
                z2 = k*dz + 0.5*dz
                nn=nn+1
                call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
              end if
            enddo
        enddo


        j=M_finish
        do i=N_start,N_finish
          x1=i*dx
          ztemp = z_trapezoid(n_trapezoid,1)+
     &        (x1 - x_trapezoid(n_trapezoid,1))*trapezoid_slope1
          L_finish_temp=nint(ztemp/dz)
              ztemp2 =  z_trapezoid(n_trapezoid,1)+
     &        (x1 - x_trapezoid(n_trapezoid,1))*bslope
          L_start_temp = nint(ztemp2/dz)
          do k=L_start_temp,L_finish_temp
            nn=nn+1
            call pos_veloc(nn,x1,j*dy,k*dz,0.,0.,0.)
            if(iBC.ne.1)then
              x2 = x1   + 0.5*dx
              y2 = j*dy + 0.5*dy     
              z2 = k*dz + 0.5*dz
              nn=nn+1
              call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
            end if
          enddo
        enddo

       endif    !End of:  if(iBC.eq.2)then

c        -- Not active yet (BDR) --
c        if(iBC.eq.1)then
c          !-- Normal information - neighbour data for              --
c          !-- first corner particle on cylinder side               --
c          iBP_Pointer_Info(ntemp+1,3) = ntemp+1        !i-1 neighbour     
c          iBP_Pointer_Info(ntemp+1,4) = ntemp+2        !i+1 neighbour
c          !-- last corner particle on cylinder side                --
c          iBP_Pointer_Info(nn,3) = nn -1         !i-1 neighbour     
c          iBP_Pointer_Info(nn,4) = nn            !i+1 neighbour
c          ntemp = nn
c        end if



c       -- Trapezoid face 2: Flat-Top - 
        N_start  = nint(x_trapezoid(n_trapezoid,2)/dx) !+ 1
        N_finish = nint(x_trapezoid(n_trapezoid,3)/dx) !+ 1 
        z1 = z_lastPoint
        L_start  = nint(z_trapezoid(n_trapezoid,1)/dz) 
        ntemp = nn

        do i = N_start,N_finish
          do j = M_start,M_finish
            nn=nn+1
            x1 = i*dx
            y1 = j * dy
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
            if(iBC.eq.1)then
              if(j.eq.M_start)then
                j_minus1 = nn
                j_plus1  = nn + 1
              else if(j.eq.M_finish)then
                j_minus1 = nn - 1
                j_plus1  = nn
              else
                j_minus1 = nn - 1
                j_plus1  = nn + 1
              end if
              if(i.eq.N_start)then
                i_minus1 = nn
                i_plus1  = nn + (M_finish - M_start + 1)
              else if(i.eq.N_finish)then
                i_minus1 = nn - (M_finish - M_start + 1)
                i_plus1  = nn
              else
                i_minus1 = nn - (M_finish - M_start + 1)
                i_plus1  = nn + (M_finish - M_start + 1)
              end if
              !-- Normal information - neighbour data for        --
              !-- Repulsive Boundary Particles (BPs)             --
              iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
              iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
              iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
              iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
            end if
            if(iBC.ne.1)then
              x2 = x1 + 0.5*dx
              y2 = y1 + 0.5*dy     
              z2 = z1 + 0.5*dz
              nn=nn+1
              call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
            end if
          end do

          x_lastpoint2=x1
        enddo
        x_TopFinish = x1

       if(iBC.eq.2)then

        j=M_start
        do i=N_start,N_finish
          x1=i*dx
          L_finish_temp=nint(z1/dz)
          ztemp2 =  z_trapezoid(n_trapezoid,1)+
     &        (x1 - x_lastpoint)*bslope
          L_start_temp = nint(ztemp2/dz)
          do k=L_start_temp,L_finish_temp
            nn=nn+1
            call pos_veloc(nn,x1,j*dy,k*dz,0.,0.,0.)
            if(iBC.ne.1)then
              x2 = x1   + 0.5*dx
              y2 = j*dy + 0.5*dy     
              z2 = k*dz + 0.5*dz
              nn=nn+1
              call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
            end if
          enddo
        enddo


       j=M_finish
       do i=N_start,N_finish
         x1=i*dx	
         L_finish_temp=nint(z1/dz)
         ztemp2 =  z_trapezoid(n_trapezoid,1)+
     &        (x1 - x_trapezoid(n_trapezoid,1))*bslope
         L_start_temp = nint(ztemp2/dx)
         do k=L_start_temp,L_finish_temp
           nn=nn+1
           call pos_veloc(nn,x1,j*dy,k*dz,0.,0.,0.)
           if(iBC.ne.1)then
             x2 = x1   + 0.5*dx
             y2 = j*dy + 0.5*dy     
             z2 = k*dz + 0.5*dz
             nn=nn+1
             call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
           end if
         enddo
       enddo

      endif  !End of:   if(iBC.eq.2)then

c        -- Not active yet (BDR) --
c        if(iBC.eq.1)then
c          !-- Normal information - neighbour data for              --
c          !-- first corner particle on cylinder side               --
c          iBP_Pointer_Info(ntemp+1,3) = ntemp+1        !i-1 neighbour     
c          iBP_Pointer_Info(ntemp+1,4) = ntemp+2        !i+1 neighbour
c          !-- last corner particle on cylinder side                --
c          iBP_Pointer_Info(nn,3) = nn -1         !i-1 neighbour     
c          iBP_Pointer_Info(nn,4) = nn            !i+1 neighbour
c          ntemp = nn
c        end if

c       -- Trapezoid face 3: Down-slope - 

        N_start  = nint(x_trapezoid(n_trapezoid,3)/dx) !+ 1
        N_finish = nint(x_trapezoid(n_trapezoid,4)/dx) !+ 1 
        L_start  = nint(z_lastPoint) !+ 1   !int(z_trapezoid(3)/dz) + 1
        L_finish = nint(z_trapezoid(n_trapezoid,4)/dz) !+ 1
        trapezoid_slope1 =
     &     (z_trapezoid(n_trapezoid,4) - z_trapezoid(n_trapezoid,3))/
     &     (x_trapezoid(n_trapezoid,4) - x_trapezoid(n_trapezoid,3))   
        print*,'x_TopFinish ',x_TopFinish
        print*,'N_start*dx ',N_start*dx
        !if(N_start*dx.lt.x_TopFinish) N_start = N_start + 1
        ntemp = nn
        do i = N_start,N_finish
          do j = M_start,M_finish
            nn=nn+1
            x1 = i*dx
            y1 = j*dy
            !z = z_trapezoid(3) + (x - x_trapezoid(3))*trapezoid_slope1
            z1 = z_lastPoint + (x1 - x_TopFinish)*trapezoid_slope1
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
            if(iBC.eq.1)then
              if(j.eq.M_start)then
                j_minus1 = nn
                j_plus1  = nn + 1
              else if(j.eq.M_finish)then
                j_minus1 = nn - 1
                j_plus1  = nn
              else
                j_minus1 = nn - 1
                j_plus1  = nn + 1
              end if
              if(i.eq.N_start)then
                i_minus1 = nn
                i_plus1  = nn + (M_finish - M_start + 1)
              else if(i.eq.N_finish)then
                i_minus1 = nn - (M_finish - M_start + 1)
                i_plus1  = nn
              else
                i_minus1 = nn - (M_finish - M_start + 1)
                i_plus1  = nn + (M_finish - M_start + 1)
              end if
              !-- Normal information - neighbour data for        --
              !-- Repulsive Boundary Particles (BPs)             --
              iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
              iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
              iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
              iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
            end if
            if(iBC.ne.1)then
              x2 = x1 + 0.5*dx
              y2 = y1 + 0.5*dy     
              z2 = z1 + 0.5*dz
              nn=nn+1
              call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
            end if
          end do

        enddo
 
      if(iBC.eq.2)then

        j=M_start
        do i=N_start,N_finish
          x1=i*dx
          ztemp = z_lastPoint + (x1 - x_TopFinish)*trapezoid_slope1
          L_finish_temp=nint(ztemp/dz)
          ztemp2 =  z_trapezoid(n_trapezoid,1)+
     &        (x1 - x_lastpoint2)*bslope
          L_start_temp = nint(ztemp2/dx)
          do k=L_start_temp,L_finish_temp
            nn=nn+1
            call pos_veloc(nn,x1,j*dy,k*dz,0.,0.,0.)
            if(iBC.ne.1)then
              x2 = x1   + 0.5*dx
              y2 = j*dy + 0.5*dy     
              z2 = k*dz + 0.5*dz
              nn=nn+1
              call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
            end if
          enddo
        enddo


        j=M_finish
        do i=N_start,N_finish
          x1=i*dx
          ztemp = z_lastPoint + (x1 - x_TopFinish)*trapezoid_slope1
          L_finish_temp=nint(ztemp/dz)
          ztemp2 =  z_trapezoid(n_trapezoid,1)+
     &        (x1 - x_trapezoid(n_trapezoid,1))*bslope
          L_start_temp = nint(ztemp2/dx)
          do k=L_start_temp,L_finish_temp
            nn=nn+1
            call pos_veloc(nn,x1,j*dy,k*dz,0.,0.,0.)
            if(iBC.ne.1)then
              x2 = x1   + 0.5*dx
              y2 = j*dy + 0.5*dy     
              z2 = k*dz + 0.5*dz
              nn=nn+1
              call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
            end if
          enddo
        enddo
      endif   !End of:   if(iBC.eq.2)then

c        -- Not active yet (BDR) --
c        if(iBC.eq.1)then
c          !-- Normal information - neighbour data for              --
c          !-- first corner particle on cylinder side               --
c          iBP_Pointer_Info(ntemp+1,3) = ntemp+1        !i-1 neighbour     
c          iBP_Pointer_Info(ntemp+1,4) = ntemp+2        !i+1 neighbour
c          !-- last corner particle on cylinder side                --
c          iBP_Pointer_Info(nn,3) = nn -1         !i-1 neighbour     
c          iBP_Pointer_Info(nn,4) = nn            !i+1 neighbour
c          ntemp = nn
c        end if
c       -- End of Trapezoid
        print*,'End of Trap, x1,z1 ',x1,z1


       write(*,*) 'End of trapezoid, n_trapezoid= ',n_trapezoid,
     &            ' at nn=',nn

      if(n_trapezoid.eq.1)then

      endif

       return
       end





c	____________________ SUBROUTINE GATE

      subroutine gate(nn,dx,dy,dz,beta,theta)
      include 'common.gen3D'

      double precision Xwall

	write(*,*) ' Gate position in X coordinates ??'
	write(*,*) ' X Wall ??'
	read(*,*) Xwall
	write(*,*) Xwall
      
	write(*,*) ' Start and end of the gate in Y ??'
	write(*,*) ' YYMin, YYmax ??'
	read(*,*) YYmin,YYmax
	write(*,*) YYmin,YYmax

	write(*,*) ' Start and end of the gate in Z ??'
	write(*,*) ' ZZMin, ZZmax ??'
	read(*,*) ZZmin,ZZmax
	write(*,*) ZZmin,ZZmax


	write(*,*) ' GATE Velocity  ?? '
	write(*,*) ' Vx,Vy,Vz??'
	read(*,*) VXgate,VYgate,VZgate
	write(*,*) VXgate,VYgate,VZgate


	write(*,*) ' Initial time to start gate movement??'
	write(*,*) ' tgate ??'
	read(*,*) tgate
	write(*,*) tgate

	M_end=nint(YYmax/dy)
	M_ini=nint(YYmin/dy)

	L_end=nint(ZZmax/dz)
	L_ini=nint(ZZmin/dz)


	write(*,*) M_end,M_ini,L_end,L_ini
	write(*,*)'Begining of gate at ',nn+1

	ngate_ini=nn+1

	do j=M_ini,M_end
	   do k=L_ini,L_end
	         nn=nn+1
	      call pos_veloc(nn,Xwall,j*dy,k*dz,0.,0.,0.)

	       if((j+0.5)*dy.le.YYmax.and.(k+0.5)*dz.le.ZZmax) then
  	        nn=nn+1
	        call pos_veloc(nn,Xwall+0.5*dx,(j+0.5)*dy,
     +                                (k+0.5)*dz,0.,0.,0.)
	       endif
	   enddo
	enddo

	write(*,*)'End of gate at ',nn

	ngate_end=nn

	write(77,*) ngate_ini
	write(77,*) ngate_end
	write(77,*) VXgate,VYgate,VZgate
      write(77,*) tgate

	return
	end


c	____________________ SUBROUTINE WAVEMAKER

       subroutine wavemaker(nn,dx,dy,dz,beta,theta)
       include 'common.gen3D'
       
      double precision XX_extra
       
       character (LEN=40) :: paddle_fileName 
       
       print*
       print*,'--- Generating Wavemaker ---'
       print*
       print*, ' Enter Paddle Type  ??'
       print*,' 1: Piston '
       print*,' 2: Piston-Flap (see Schafer et al. 1996)'
       print*,' 3: Piston with prescribed motion'
       read(*,*)  i_PaddleType
       print*,    i_PaddleType
       if(i_PaddleType.ne.1.and.i_PaddleType.ne.2
     &                     .and.i_PaddleType.ne.3)then
         print*,'Incorrect Paddle Type'
         stop
       end if
       
       print*,' Wavemaker Centre position in X coordinates ??'
       print*,' (Generally X_PaddleCentre = 0.5*stroke)'
       read(*,*)  X_PaddleCentre
       print*,    X_PaddleCentre
       
       if(i_paddleType.eq.2)then  !Info Needed for piston-flap paddle
         print*,' Info Needed for piston-flap paddle '
         print*,' Enter paddle Still Water Level (SWL)'
         read(*,*) paddle_SWL
         print*,   paddle_SWL
         print*,' Enter piston-flap flap_length'
         print*,' (distance under the bed of the pivot point' 
         read(*,*) flap_length
         print*,   flap_length
	   paddle_fileName = 'noPaddleFileName'
       else if(i_paddleType.eq.3)then  !Info Needed for piston paddle with presribed motion
         print*
         print*,' Info Needed for piston-flap paddle '
         print*,' Enter filename of prescribed motion'
         print*,
     &        ' NOTE file format must be: time, x-position, u-velocity'
         read(*,*) paddle_fileName       
         print*,' paddle_fileName = ',paddle_fileName
         !- Read initial position from file -
         open(61,file=paddle_fileName)
           read(61,*)time_temp,X_PaddleStart_3,u_temp
         close(61)
         print*
         print*,'X_PaddleStart_3 = ',X_PaddleStart_3
         print*
         print*,' Enter paddle Still Water Level (SWL)'
         read(*,*) paddle_SWL
         print*,   paddle_SWL
         flap_length = 0.0
       else
         paddle_SWL  = 0.0
         flap_length = 0.0
         paddle_fileName = 'noPaddleFileName'
       end if
       
  
         write(*,*) ' Start and end of the wavemaker in Y ??'
         write(*,*) ' YYMin, YYmax ??'
         read(*,*)  YYmin,YYmax
         write(*,*) YYmin,YYmax
  
       
       write(*,*) ' Start and end of the wavemaker in Z ??'
       write(*,*) ' ZZMin, ZZmax ??'
       read(*,*)  ZZmin,ZZmax
       write(*,*) ZZmin,ZZmax
       
       write(*,*) ' Initial time of wavemaker ??'
       write(*,*) ' twavemaker ??'
       read(*,*)  twavemaker
       write(*,*) twavemaker
       
       write(*,*) ' Number of frequencies  ?? '
       read(*,*)  Nfreq
       write(*,*) Nfreq
       
     
       do n=1,Nfreq
       
         if(i_paddleType.eq.2)then
           write(*,*) ' Wavemaker Stroke = 2*Amplitude   ?? '
           read(*,*)  stroke
           write(*,*) stroke
         elseif(i_paddleType.eq.3)then
           write(*,*) ' Enter ZERO Wavemaker Stroke = 2*Amplitude   ?? '
           read(*,*)  stroke
           write(*,*) stroke
         elseif(i_paddleType.eq.1)then
           write(*,*) ' Amplitude   ?? '
           read(*,*)  A_wavemaker(n)
           write(*,*) A_wavemaker(n)
            stroke=2*A_wavemaker(n)
         end if

         write(*,*) ' Period  ?? '
         read(*,*)  Period(n)
         write(*,*) Period(n)
     
         write(*,*) ' Phase  ?? '
         read(*,*)  Phase(n)
         write(*,*) Phase(n)
       
         write(*,*) ' twinitial  ?? ' 
         read(*,*)  twinitial(n)
         write(*,*) twinitial(n)

       enddo
                    
         if(i_periodicOBs(2).eq.1)then
           M_start  = nint(YYmin/dy) 
           M_finish = nint(YYmax/dy) - 1
         else
           M_start  = nint(YYmin/dy)
           M_finish = nint(YYmax/dy)
         end if

       
       L_end=nint(ZZmax/dz)
       L_ini=nint(ZZmin/dz)
       L_start = L_ini
       L_finish = L_end
       
       
       print*,'M_start, M_finish ',M_start, M_finish
       print*,'L_start, L_finish ',L_start, L_finish
       write(*,*)'Start of wavemaker at ',nn+1
       
       nwavemaker_ini=nn+1
       
       X_PaddleStart = 0.5*stroke
       
      if(iBC.eq.2)then        !Dalrymple BC - Fixed Fluid Particles

        do j=M_start,M_finish
          do k=L_start,L_finish

            if(i_paddleType.eq.2)then
             XX_extra =  X_PaddleCentre 
     &       +0.5*(1.0+(k*dz - paddle_SWL)/
     &       (flap_length+paddle_SWL))*stroke
            elseif(i_paddleType.eq.3)then
                XX_extra  = X_PaddleStart_3
            else
               XX_extra  = X_PaddleCentre 
            end if
            nn=nn+1
            call pos_veloc(nn,XX_extra,
     +                             j*dy,k*dz,0.,0.,0.)       
            if((j+0.5)*dy.le.YYmax.and.(k+0.5)*dz.le.ZZmax) then
              nn=nn+1
              call pos_veloc(nn,XX_extra+0.5*dx,
     &                           (j+0.5)*dy,(k+0.5)*dz,0.,0.,0.)
            endif
              
          enddo
        enddo
        
      else if(iBC.eq.1)then   !Repulsive BC - Repulsive Force Particles with Normals
        
       i=0
       do k=L_start,L_finish
         do j=M_start,M_finish
           !-- Start point is full extension --
           if(i_paddleType.eq.2)then
             XX_extra =  X_PaddleCentre 
     &       +0.5*(1.0+(k*dz - paddle_SWL)/
     &       (flap_length+paddle_SWL))*stroke
            elseif(i_paddleType.eq.3)then
              XX_extra  = X_PaddleStart_3
            else
              XX_extra  = X_PaddleCentre 
           end if
           nn=nn+1
           call pos_veloc(nn,XX_extra,j*dy,k*dz,0.,0.,0.)
           !3-D Normals
             if(j.eq.M_start)then
               j_minus1 = nn
               j_plus1  = nn + 1
             else if(j.eq.M_finish)then
               j_minus1 = nn - 1
               j_plus1  = nn
             else
               j_minus1 = nn - 1
               j_plus1  = nn + 1
             end if
             if(k.eq.L_start)then
               i_minus1 = nn + (M_finish - M_start + 1)
               i_plus1  = nn
             else if(k.eq.L_finish)then
               i_minus1 = nn 
               i_plus1  = nn - (M_finish - M_start + 1)
             else
               i_minus1 = nn + (M_finish - M_start + 1)
               i_plus1  = nn - (M_finish - M_start + 1)
             end if
             !-- Normal information - neighbour data for        --
             !-- Repulsive Boundary Particles (BPs)             --
             iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
             iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
             iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
             iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour

         enddo
       enddo
      
      end if     !End of:  if(iBC.eq.1)then
       
      write(*,*)'  End of wavemaker at ',nn
       
       
       nwavemaker_end=nn
       
       Xwavemaker=X_PaddleCentre
       
       write(66,*) i_paddleType
       write(66,*) nwavemaker_ini
       write(66,*) nwavemaker_end
       write(66,*) X_PaddleCentre
       write(66,*) X_PaddleStart
       write(66,*) paddle_SWL
       write(66,*) flap_length
       write(66,*) stroke
       write(66,*) twavemaker
       write(66,*) paddle_fileName
       write(66,*) Nfreq
       
       do n=1,Nfreq       
         write(66,*) A_wavemaker(n)
         write(66,*) Period(n)
         write(66,*) Phase(n)
         write(66,*) twinitial(n)       
       enddo 

       close(66)
    
       return
       end

c     ____
c      ____________________ SUBROUTINE RaichlenWedge_Particles

      subroutine RaichlenWedge_Particles(nn,N1,N,M,dx,dy,dz,beta)
      include 'common.gen3D'

      double precision x1,y1,z1,x2,y2,z2
      double precision dxW,dyW,dzW

c     This test is based loosely on the experiments of Synolakis et al. (####)

c       -- Read in Wedge parameters --
        write(*,*) 'Enter block-top elevation above SWL'
        read(*,*) bigDelta
        write(*,*) bigDelta
        write(*,*) 'Enter specific Weight'
        read(*,*) specificWeight
        write(*,*) specificWeight
        write(*,*) 'Enter block_length, block_height, block_width'
        read(*,*) block_length, block_height, block_width
        write(*,*) block_length, block_height, block_width
        if(iBC.eq.1)then
          write(*,*) 'Enter block discretisation size'
          read(*,*) dxW, dyW, dzW
          write(*,*) dxW, dyW, dzW
        else        
          dxW = dx
          dyW = dy
          dzW = dz
        end if
        bslope = tan(beta)
        x_beach_start = (nint((vlx1/dx))+0)*dx   !(int((vlx1/dx))+1)*dx
        shoreline_position = x_beach_start + h_SWL/bslope
        block_top = h_SWL + bigDelta
        block_xstart_point  = shoreline_position - 
     &                        ((block_height - bigDelta)/bslope)
        block_xfinish_point = block_xstart_point + block_length
        block_ystart_point  = 0.5*M*dy - 0.5*block_width
        block_yfinish_point = 0.5*M*dy + 0.5*block_width
        block_zstart_point  = (block_xstart_point-x_beach_start)*bslope

        M_block_start  = int(block_ystart_point /dyW)+1
        M_block_finish = int(block_yfinish_point/dyW)+1 

        print*
        print*,'-- Generating Sliding Wedge --'
        print*,'N1 ',N1
        print*,'N1*dx ',N1*dx
        print*,'x_beach_start ',x_beach_start
        print*,'bslope ',bslope
        print*,'h_SWL  ',h_SWL
        print*,'shoreline_position',shoreline_position
        print*,'block_top',block_top
        print*,'block_xstart_point ',block_xstart_point
        print*,'block_xfinish_point',block_xfinish_point
        print*,'block_ystart_point' ,block_ystart_point
        print*,'block_yfinish_point',block_yfinish_point
        print*,'block_zstart_point' ,block_zstart_point
        print*,'dxW',dxW
        print*,'dyW',dyW
        print*,'dzW',dzW
        print*

        nn_initial = nn
  

c       -- Block face 1 : y = const
        x1 = block_xstart_point
        y1 = M_block_start*dyW   !y1 = block_ystart_point
        N_start  = int(block_xstart_point /dxW)+1
        N_finish = int(block_xfinish_point/dxW) !+1   !Block end has been chopped!  RETURN TO THIS!!
        !L_start  = int(block_xstart_point/dxW)+1
        L_finish = int(block_top/dzW)+1
        do i = N_start,N_finish
          if(i.gt.N_start)then
             L_start_old = L_start
          end if
          !- Current Column  -
          x1 = i*dxW
          z_start = (x1 - x_beach_start)*bslope
          L_start = int(z_start/dzW) + 1
          !- Previous Column -
          if(i.eq.N_start)then
            L_start_previous = L_start
          else
            L_start_previous = L_start_old
          end if
          !- Next Column -
          if(i.eq.N_finish)then
            L_start_next = L_start
          else
            z_start_next = (x1+dxW - x_beach_start)*bslope
            L_start_next = int(z_start_next/dzW) + 1
          end if
          do k = L_start,L_finish
            nn=nn+1
            z1 = k*dzW
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
            if(iBC.eq.1)then
              if(k.eq.L_start)then
                j_minus1 = nn
                j_plus1  = nn + 1
                if(L_finish.eq.L_start)then !Triangle corner
                  j_minus1 = nn-2
                  if(zp(j_minus1).eq.zp(nn))then
                    j_minus1 = j_minus1 - 1
                  endif   
                  j_plus1  = nn
                endif
              else if(k.eq.L_finish)then
                j_minus1 = nn - 1
                j_plus1  = nn
              else
                j_minus1 = nn - 1
                j_plus1  = nn + 1
              end if
              !- Adjust i+1 neighbour for same L_start but different i -
              if(L_start_next.eq.L_start)then
                L_minus1 = 0
              else
                L_minus1 = 1
              end if
              if(i.eq.N_start)then
                if(k.eq.L_start)then
                  i_minus1 = nn
                  i_plus1  = nn + (L_finish - L_start + 1)
                else
                  i_minus1 = nn
                  i_plus1  = nn + (L_finish - L_start + 1 - L_minus1)
                end if
              else if(i.eq.N_finish)then
                i_minus1 = nn - (L_finish - L_start + 1)
                i_plus1  = nn
              else
                if(k.eq.L_start)then
                  i_minus1 = nn - (L_finish - L_start + 1)
                  i_plus1  = nn + (L_finish - L_start + 1)
                else
                  i_minus1 = nn - (L_finish - L_start + 1)
                  i_plus1  = nn + (L_finish - L_start + 1 - L_minus1)
                end if
              end if
              !-- Normal information - neighbour data for        --
              !-- Repulsive Boundary Particles (BPs)             --
              iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
              iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
              iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
              iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
            end if 
            if(iBC.ne.1)then
              x2 = x1 + 0.5*dxW
              y2 = y1 - 0.5*dyW     
              z2 = z1 + 0.5*dzW
              nn=nn+1
              call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
            end if    
            !z = z + dzW
          end do
        end do

c      -- Block face 2 - y = const + block_width
        x1 = block_xstart_point - dxW
        y1 = M_block_finish*dyW   !y1 = block_yfinish_point
        N_start  = int(block_xstart_point /dxW)+1
        N_finish = int(block_xfinish_point/dxW) !+1    !Block end has been chopped!  RETURN TO THIS!!
        L_finish = int(block_top/dzW)+1
        do i = N_start,N_finish
          if(i.gt.N_start)then
             L_start_old = L_start
          end if
          !- Current Column  -
          x1 = i*dxW
          z_start = (x1 - x_beach_start)*bslope
          L_start = int(z_start/dzW) + 1
          !- Previous Column -
          if(i.eq.N_start)then
            L_start_previous = L_start
          else
            L_start_previous = L_start_old
          end if
          !- Next Column -
          if(i.eq.N_finish)then
            L_start_next = L_start
          else
            z_start_next = (x1+dxW - x_beach_start)*bslope
            L_start_next = int(z_start_next/dzW) + 1
          end if
          do k = L_start,L_finish
            nn=nn+1
            z1 = k*dzW
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
            if(iBC.eq.1)then
              if(k.eq.L_start)then
                j_minus1 = nn
                j_plus1  = nn + 1
                if(L_finish.eq.L_start)then !Triangle corner
                  j_minus1 = nn-2   
                  if(zp(j_minus1).eq.zp(nn))then
                    j_minus1 = j_minus1 - 1
                  endif   
                  j_plus1 = nn
                endif
              else if(k.eq.L_finish)then
                j_minus1 = nn - 1
                j_plus1  = nn
              else
                j_minus1 = nn - 1
                j_plus1  = nn + 1
              end if
              !- Adjust i+1 neighbour for same L_start but different i -
              if(L_start_next.eq.L_start)then
                L_minus1 = 0
              else
                L_minus1 = 1
              end if
              if(i.eq.N_start)then
                if(k.eq.L_start)then
                  i_minus1 = nn + (L_finish - L_start + 1)
                  i_plus1  = nn
                else
                  i_minus1 = nn + (L_finish - L_start + 1 - L_minus1)
                  i_plus1  = nn
                end if
              else if(i.eq.N_finish)then
                i_minus1 = nn
                i_plus1  = nn - (L_finish - L_start + 1)
              else
                if(k.eq.L_start)then
                  i_minus1 = nn + (L_finish - L_start + 1)
                  i_plus1  = nn - (L_finish - L_start + 1)
                else
                  i_minus1 = nn + (L_finish - L_start + 1 - L_minus1)
                  i_plus1  = nn - (L_finish - L_start + 1)
                end if
              end if
              !-- Normal information - neighbour data for        --
              !-- Repulsive Boundary Particles (BPs)             --
              iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
              iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
              iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
              iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
            end if 
            if(iBC.ne.1)then
              x2 = x1 + 0.5*dxW
              y2 = y1 + 0.5*dyW     
              z2 = z1 + 0.5*dzW
              nn=nn+1
              call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
            end if
            !z1 = z1 + dzW
          end do
        end do
 
c       -- Block face 3 - x = const = block_xstart_point
        x1 = block_xstart_point 
        y1 = block_ystart_point
        z1 = block_zstart_point
        x1 = real(int(x1/dxW) + 1)*dxW
        M_start  = int(block_ystart_point /dyW)+1
        M_finish = int(block_yfinish_point/dyW)+1 
        L_start  = int(block_zstart_point /dzW)+1
        L_finish = int(block_top/dzW)+1
        do j = M_start,M_finish
          do k = L_start,L_finish
            nn=nn+1
            y1 = j*dyW
            z1 = k*dzW
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
            if(iBC.eq.1)then
                if(k.eq.L_start)then
                  j_minus1 = nn
                  j_plus1  = nn + 1
                else if(k.eq.L_finish)then
                  j_minus1 = nn - 1
                  j_plus1  = nn
                else
                  j_minus1 = nn - 1
                  j_plus1  = nn + 1
                end if
                if(j.eq.M_start)then
                  i_minus1 = nn + (L_finish - L_start + 1)
                  i_plus1  = nn
                else if(j.eq.M_finish)then
                  i_minus1 = nn
                  i_plus1  = nn - (L_finish - L_start + 1)
                else
                  i_minus1 = nn + (L_finish - L_start + 1)
                  i_plus1  = nn - (L_finish - L_start + 1)
                end if
                !-- Normal information - neighbour data for        --
                !-- Repulsive Boundary Particles (BPs)             --
                iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
                iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
                iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
                iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
            end if 
            !call pos_veloc(nn,x,y,z,0.,0.,0.)
            if(iBC.ne.1)then
              x2 = x1 + 0.5*dxW
              y2 = y1 + 0.5*dyW     
              z2 = z1 + 0.5*dzW
              nn=nn+1
              call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
            end if
            !z = z + dzW
          end do
        end do

c       -- Block face 4 - z = const = SWL + bigDelta
        x1 = block_xstart_point
        y1 = block_ystart_point
        z1 = (int(block_top/dzW)+1)*dzW
        M_start  = int(block_ystart_point /dyW)+1
        M_finish = int(block_yfinish_point/dyW)+1 
        N_start  = int(block_xstart_point /dxW)+1
        N_finish = int(block_xfinish_point/dxW)+1
        do i = N_start,N_finish
          do j = M_start,M_finish
            nn=nn+1
            x1 = i*dxW
            y1 = j*dyW
            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
            if(iBC.eq.1)then
                if(j.eq.M_start)then
                  j_minus1 = nn
                  j_plus1  = nn + 1
                else if(j.eq.M_finish)then
                  j_minus1 = nn - 1
                  j_plus1  = nn
                else
                  j_minus1 = nn - 1
                  j_plus1  = nn + 1
                end if
                if(i.eq.N_start)then
                  i_minus1 = nn
                  i_plus1  = nn + (M_finish - M_start + 1)
                else if(i.eq.N_finish)then
                  i_minus1 = nn - (M_finish - M_start + 1)
                  i_plus1  = nn
                else
                  i_minus1 = nn - (M_finish - M_start + 1)
                  i_plus1  = nn + (M_finish - M_start + 1)
                end if
                !-- Normal information - neighbour data for        --
                !-- Repulsive Boundary Particles (BPs)             --
                iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
                iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
                iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
                iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
              end if 
            if(iBC.ne.1)then
              x2 = x1 + 0.5*dxW
              y2 = y1 + 0.5*dyW    
              z2 = z1 + 0.5*dzW
              nn=nn+1
              call pos_veloc(nn,x2,y2,z2,0.,0.,0.)
            end if
          end do
        end do
c       -- End of Wedge

      print*
      write(*,*) 'no. of Wedge particles: ',nn
      print*
      
      write(88,*)bslope
111   format(3e18.10)
      open(unit=87,
     &  file='Benchmark_4_initialPositions.dat',
     &     status='unknown')
      do i = nn_initial+1,nn
        write(87,111)xp(i),yp(i),zp(i)
      end do
      close(87)

c     -------------------------------

      return
      end
c     ____
c      ____________________ SUBROUTINE FloatingBody_Particles

      subroutine FloatingBodies_Particles(nn,N1,N,M,dx,dy,dz,beta)
      include 'common.gen3D'

      write(*,*)
      write(*,*) ' Which type of Floating Object' 
      write(*,*) ' (1) Cube '
      write(*,*) ' (2) Other Shape'
      read(*,*) iopt_FloatingObject_temp
      write(*,*) iopt_FloatingObject_temp

      if(iopt_FloatingObject_temp.eq.1)then
        call FloatingCube_Particles(nn,N1,N,M,dx,dy,dz,beta)
      elseif(iopt_FloatingObject_temp.eq.2)then
        print*
        print*,'ERROR: Invalid Option'
        print*,'You will need to write your own subroutine '
        print*,'for a new shape'
        stop
        !call OtherShape_Particles(nn,N1,N,M,dx,dy,dz,beta)
      else
        print*
        write(*,*) 'Invalid Option '
        stop
      endif

      end subroutine
c      ____________________ SUBROUTINE FloatingSquare_Particles

      subroutine FloatingCube_Particles(nn,N1,N,M,dx,dy,dz,beta)
      include 'common.gen3D'

      double precision x1,y1,z1,x2,y2,z2
      double precision xtemp, ytemp, ztemp


      num_FB = num_FB + 1
      if(num_FB.gt.num_FB_max)then
        print*,'Number of floating Bodies exceeds max value'
        print*,'num_FB.gt.num_FB_max'
        print*,'Adjust num_FB_max in common.gen3D, num_FB_max = ',
     &          num_FB_max
        stop
      endif
      iopt_FloatingObject_type(num_FB) = 1
c     -- Read in Floating Body parameters --
      write(*,*) 'Enter square cylinder X, Y & Z Dimension'
      read(*,*)  XcylinderDimension(num_FB),YcylinderDimension(num_FB),
     &           ZcylinderDimension(num_FB)
      write(*,*) XcylinderDimension(num_FB),YcylinderDimension(num_FB),
     &           ZcylinderDimension(num_FB)     
      print*
      write(*,*) 'Enter specific Weight'
      read(*,*)  FB_specificWeight(num_FB)    != 1.0
      write(*,*) FB_specificWeight(num_FB)
      print*
      write(*,*) 'Enter x,y,z of Bottom Left Corner'
      read(*,*)  x_BottomLeft, y_BottomLeft, z_BottomLeft
      write(*,*) x_BottomLeft, y_BottomLeft, z_BottomLeft
      print*
      write(*,*) 'Enter (x,y,z) shift of Centre of Gravity '
      write(*,*) 'for use in Parallel Axis Theorem '
      read(*,*)  xdiff_CofG, ydiff_CofG, zdiff_CofG  !0.0*dz   !Shift Box Centre of Gravity to make slightly unbalanced
      write(*,*) xdiff_CofG, ydiff_CofG, zdiff_CofG
      print*
      write(*,*) 'Enter initial U,W velocity of Object'
      read(*,*)  bigU(num_FB), bigV(num_FB), bigW(num_FB)              !0.0, 0.0
      write(*,*) bigU(num_FB), bigV(num_FB), bigW(num_FB)
      print*
      write(*,*) 'Enter initial Body Angle (deg) in X,Y & Z Directions'
      read(*,*)  
     &     body_AngleX(num_FB), body_AngleY(num_FB), body_AngleZ(num_FB)      !0.0, 0.0*pi/3.0  - Positive anticlockwise
      write(*,*)   
     &     body_AngleX(num_FB), body_AngleY(num_FB), body_AngleZ(num_FB)
      !- Converting from deg to radians -
      if(body_AngleX(num_FB).gt.180.0)then
        body_AngleX(num_FB) = body_AngleX(num_FB) - 360.0
      endif
      body_AngleX(num_FB) = body_AngleX(num_FB)*pi/180.0
      !- Converting from deg to radians -
      if(body_AngleY(num_FB).gt.180.0)then
        body_AngleY(num_FB) = body_AngleY(num_FB) - 360.0
      endif
      body_AngleY(num_FB) = body_AngleY(num_FB)*pi/180.0
      !- Converting from deg to radians -
      if(body_AngleZ(num_FB).gt.180.0)then
        body_AngleZ(num_FB) = body_AngleZ(num_FB) - 360.0
      endif
      body_AngleZ(num_FB) = body_AngleZ(num_FB)*pi/180.0
      write(*,*) 'Enter initial Rotation Rate (Omega)'
      write(*,*) 'in X,Y & Z Directions'
      read(*,*)  bigOmegaX(num_FB), bigOmegaY(num_FB), bigOmegaZ(num_FB)       !0.0, 0.0*pi/3.0  - Positive anticlockwise
      write(*,*) bigOmegaX(num_FB), bigOmegaY(num_FB), bigOmegaZ(num_FB)
      print*
      write(*,*) 'Enter coefficient of Friction'
      read(*,*)  friction_coeff(num_FB)
      write(*,*) friction_coeff(num_FB)

      print*

      cylinderDimensionX = XcylinderDimension(num_FB)
      cylinderDimensionY = YcylinderDimension(num_FB)
      cylinderDimensionZ = ZcylinderDimension(num_FB)
      cylinderDensity(num_FB) = rho0 * FB_specificWeight(num_FB)
      bigMass(num_FB) = cylinderDensity(num_FB)
     &                *(cylinderDimensionX*
     &                  cylinderDimensionY*
     &                  cylinderDimensionZ)
      bigInertiaXX(num_FB) = bigMass(num_FB)
     &          *(cylinderDimensionY**2 + cylinderDimensionZ**2)/12.0
      bigInertiaYY(num_FB) = bigMass(num_FB)
     &          *(cylinderDimensionX**2 + cylinderDimensionZ**2)/12.0
      bigInertiaZZ(num_FB) = bigMass(num_FB)
     &          *(cylinderDimensionX**2 + cylinderDimensionY**2)/12.0
      Box_XC(num_FB) = x_BottomLeft + 0.5*cylinderDimensionX
c     &                              - 0.5*dx + dx 
      Box_YC(num_FB) = y_BottomLeft + 0.5*cylinderDimensionY
c     &                              - 0.5*dy + dy 
      Box_ZC(num_FB) = z_BottomLeft + 0.5*cylinderDimensionZ
c     &                               + dy + 0.5*dy
      Box_XC(num_FB) = Box_XC(num_FB) + xdiff_CofG
      Box_YC(num_FB) = Box_YC(num_FB) + ydiff_CofG
      Box_ZC(num_FB) = Box_ZC(num_FB) + zdiff_CofG
      bigInertiaXX(num_FB) = bigInertiaXX(num_FB)
     &                + bigMass(num_FB)
     &                * (ydiff_CofG**2 + zdiff_CofG**2)  !Parallel Axis Theroem
      bigInertiaYY(num_FB) = bigInertiaYY(num_FB)
     &                + bigMass(num_FB)
     &                * (xdiff_CofG**2 + zdiff_CofG**2)  !Parallel Axis Theroem
      bigInertiaZZ(num_FB) = bigInertiaZZ(num_FB)
     &                + bigMass(num_FB)
     &                * (xdiff_CofG**2 + ydiff_CofG**2)  !Parallel Axis Theroem
      print*
      print*,'-- Generating Floating Body --'
      print*,'Floating Body Number : ',num_FB
      print*,'Initial Conditions:'
      print*,'cylinderDimensionX   ',XcylinderDimension(num_FB)
      print*,'cylinderDimensionY   ',YcylinderDimension(num_FB)
      print*,'cylinderDimensionZ   ',ZcylinderDimension(num_FB)
      print*,'cylinderDensity      ',cylinderDensity(num_FB)
      print*,'bigMass              ',bigMass(num_FB)
      print*,'bigInertiaXX,YY,ZZ   ',bigInertiaXX(num_FB),
     &                               bigInertiaYY(num_FB),
     &                               bigInertiaZZ(num_FB)
      print*,'xdiff_CofG           ',xdiff_CofG
      print*,'ydiff_CofG           ',ydiff_CofG
      print*,'zdiff_CofG           ',zdiff_CofG
      print*,'Box_XC, Box_YC, Box_ZC ',
     &        Box_XC(num_FB), Box_YC(num_FB), Box_ZC(num_FB)
      print*,'bigU  , bigV  , bigW   ',
     &        bigU(num_FB), bigV(num_FB), bigW(num_FB)
      print*,'body_AngleX, body_AngleY, body_AngleZ ',
     &    body_AngleX(num_FB), body_AngleY(num_FB), body_AngleZ(num_FB) 
      print*,'OmegaX, OmegaY, OmegaZ ',
     &     bigOmegaX(num_FB),bigOmegaY(num_FB),bigOmegaZ(num_FB)

      nn_initial = nn
       
      !- Generate 3-D Rotation Matrix -
      sin_theta = sin(body_AngleZ(num_FB))
      cos_theta = cos(body_AngleZ(num_FB))
      sin_phi   = sin(body_AngleY(num_FB))
      cos_phi   = cos(body_AngleY(num_FB))
      sin_psi   = sin(body_AngleX(num_FB))
      cos_psi   = cos(body_AngleX(num_FB))
      Rot_11 = cos_phi*cos_theta
      Rot_12 = cos_phi*sin_theta
      Rot_13 = sin_phi
      Rot_21 = -sin_psi*sin_phi*cos_theta - cos_psi*sin_theta
      Rot_22 = -sin_psi*sin_phi*sin_theta + cos_psi*cos_theta
      Rot_23 =  sin_psi*cos_phi
      Rot_31 = -cos_psi*sin_phi*cos_theta + sin_psi*sin_theta
      Rot_32 = -cos_psi*sin_phi*sin_theta - sin_psi*cos_theta
      Rot_33 =  cos_psi*cos_phi
       
      !- Set Limits of Object
      x_cyl_min(num_FB) = x_BottomLeft
      x_cyl_max(num_FB) = x_BottomLeft + cylinderDimensionX
      y_cyl_min(num_FB) = y_BottomLeft
      y_cyl_max(num_FB) = y_BottomLeft + cylinderDimensionY
      z_cyl_min(num_FB) = z_BottomLeft
      z_cyl_max(num_FB) = z_BottomLeft + cylinderDimensionZ
      print*,'x_cyl_min, x_cyl_max    ',
     &         x_cyl_min(num_FB), x_cyl_max(num_FB)
      print*,'y_cyl_min, y_cyl_max    ',
     &         y_cyl_min(num_FB), y_cyl_max(num_FB)
      print*,'z_cyl_min, z_cyl_max    ',
     &         z_cyl_min(num_FB), z_cyl_max(num_FB)
      N_start  = int( x_cyl_min(num_FB)/dx) !+1
      N_finish = int((x_cyl_min(num_FB)
     &                 + cylinderDimensionX)/dx) !+1
      M_start  = int( y_cyl_min(num_FB)/dy) !+1
      M_finish = int((y_cyl_min(num_FB)
     &                 + cylinderDimensionY)/dy) !+1
      L_start  = int( z_cyl_min(num_FB)/dz) !+1
      L_finish = int((z_cyl_min(num_FB)
     &                 + cylinderDimensionZ)/dz)!+1
      
      z_finish = L_finish*dz
      if( z_finish .lt. z_cyl_max(num_FB)-0.5*dz )then
        L_finish = L_finish + 1
      endif

      print*,'M_start, M_finish       ',M_start, M_finish
      print*,'N_start, N_finish       ',N_start, N_finish
      print*,'L_start, L_finish       ',L_start, L_finish
    
      x = (N_start - 1) * dx
      y = (M_start - 1) * dy
      z = (L_start - 1) * dz
      z = z - dz
       
      print*,'Initial x,z ',x,z
      !stop

      !-- Side 1:  x = x1 = x2 + cylinderDimensionX
      !print*,'Side 1:  x = x1'
      ntemp = nn
      i = N_finish
      do j = M_start,M_finish 
        do k = L_start,L_finish
          x = i*dx
          y = j*dy
          z = k*dz
          nn=nn+1
          dx_Box = x - Box_XC(num_FB)
          dy_Box = y - Box_YC(num_FB)
          dz_Box = z - Box_ZC(num_FB)
          xp_temp = dx_Box*Rot_11 + dy_Box*Rot_12 + dz_Box*Rot_13
          yp_temp = dx_Box*Rot_21 + dy_Box*Rot_22 + dz_Box*Rot_23
          zp_temp = dx_Box*Rot_31 + dy_Box*Rot_32 + dz_Box*Rot_33
          x1=Box_XC(num_FB) + xp_temp
          y1=Box_YC(num_FB) + yp_temp
          z1=Box_ZC(num_FB) + zp_temp
          u1 = bigU(num_FB) + ( bigOmegaY(num_FB)*(z1-Box_ZC(num_FB))
     &                        - bigOmegaZ(num_FB)*(y1-Box_YC(num_FB)) )
          v1 = bigV(num_FB) + ( bigOmegaZ(num_FB)*(x1-Box_XC(num_FB))
     &                        - bigOmegaX(num_FB)*(z1-Box_ZC(num_FB)) )
          w1 = bigW(num_FB) + ( bigOmegaX(num_FB)*(y1-Box_YC(num_FB))
     &                        - bigOmegaY(num_FB)*(x1-Box_XC(num_FB)) )
          call pos_veloc(nn,x1,y1,z1,u1,v1,w1)
          call pressure(nn,ZZmax,dx,dy,dz,expont,g)
          if(iBC.eq.1)then
            if(k.eq.L_start)then
              j_minus1 = nn
              j_plus1  = nn + 1
            else if(k.eq.L_finish)then
              j_minus1 = nn - 1
              j_plus1  = nn
            else
              j_minus1 = nn - 1
              j_plus1  = nn + 1
            end if
            if(j.eq.M_start)then
              i_minus1 = nn
              i_plus1  = nn + (L_finish - L_start + 1)
            else if(j.eq.M_finish)then
              i_minus1 = nn - (L_finish - L_start + 1)
              i_plus1  = nn 
            else
              i_minus1 = nn - (L_finish - L_start + 1)
              i_plus1  = nn + (L_finish - L_start + 1)
            end if
            !-- Normal information - neighbour data for        --
            !-- Repulsive Boundary Particles (BPs)             --
            iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
            iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
            iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
            iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          end if 
c          if(iBC.ne.1)then
c            xtemp = x + 0.5*dx
c            ytemp = y + 0.5*dy
c            ztemp = z + 0.5*dz
c            nn=nn+1
c            call pos_veloc(nn,xtemp,ytemp,ztemp,0.,0.,0.)
c          end if
          !print*,'k, x1,z1 ',k,x1,z1
        end do
      end do
       
      !-- Side 2:  x = x2
      !print*,'Side 2:  x = x2'
      ntemp = nn
      i = N_start
      do j = M_start,M_finish 
        do k = L_start,L_finish
          x = i*dx
          y = j*dy
          z = k*dz
          nn=nn+1
          dx_Box = x - Box_XC(num_FB)
          dy_Box = y - Box_YC(num_FB)
          dz_Box = z - Box_ZC(num_FB)
          xp_temp = dx_Box*Rot_11 + dy_Box*Rot_12 + dz_Box*Rot_13
          yp_temp = dx_Box*Rot_21 + dy_Box*Rot_22 + dz_Box*Rot_23
          zp_temp = dx_Box*Rot_31 + dy_Box*Rot_32 + dz_Box*Rot_33
          x1=Box_XC(num_FB) + xp_temp
          y1=Box_YC(num_FB) + yp_temp
          z1=Box_ZC(num_FB) + zp_temp
          u1 = bigU(num_FB) + ( bigOmegaY(num_FB)*(z1-Box_ZC(num_FB))
     &                        - bigOmegaZ(num_FB)*(y1-Box_YC(num_FB)) )
          v1 = bigV(num_FB) + ( bigOmegaZ(num_FB)*(x1-Box_XC(num_FB))
     &                        - bigOmegaX(num_FB)*(z1-Box_ZC(num_FB)) )
          w1 = bigW(num_FB) + ( bigOmegaX(num_FB)*(y1-Box_YC(num_FB))
     &                        - bigOmegaY(num_FB)*(x1-Box_XC(num_FB)) )
          call pos_veloc(nn,x1,y1,z1,u1,v1,w1)
          call pressure(nn,ZZmax,dx,dy,dz,expont,g)
          if(iBC.eq.1)then
            if(k.eq.L_start)then
              j_minus1 = nn
              j_plus1  = nn + 1
            else if(k.eq.L_finish)then
              j_minus1 = nn - 1
              j_plus1  = nn
            else
              j_minus1 = nn - 1
              j_plus1  = nn + 1
            end if
            if(j.eq.M_start)then
              i_minus1 = nn + (L_finish - L_start + 1)
              i_plus1  = nn
            else if(j.eq.M_finish)then
              i_minus1 = nn
              i_plus1  = nn - (L_finish - L_start + 1)
            else
              i_minus1 = nn + (L_finish - L_start + 1)
              i_plus1  = nn - (L_finish - L_start + 1)
            end if
            !-- Normal information - neighbour data for        --
            !-- Repulsive Boundary Particles (BPs)             --
            iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
            iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
            iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
            iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          end if 
c          if(iBC.ne.1)then
c            xtemp = x + 0.5*dx
c            ytemp = y + 0.5*dy
c            ztemp = z + 0.5*dz
c            nn=nn+1
c            call pos_veloc(nn,xtemp,ytemp,ztemp,0.,0.,0.)
c          end if
          !print*,'k, x1,z1 ',k,x1,z1
        end do
      end do

      !-- Side 3:  y = y1 = y2 + cylinderDimensionY
      !print*,'Side 3:  y = y1'
      ntemp = nn
      j = M_finish
      do i = N_start,N_finish 
        do k = L_start,L_finish
          x = i*dx
          y = j*dy
          z = k*dz
          nn=nn+1
          dx_Box = x - Box_XC(num_FB)
          dy_Box = y - Box_YC(num_FB)
          dz_Box = z - Box_ZC(num_FB)
          xp_temp = dx_Box*Rot_11 + dy_Box*Rot_12 + dz_Box*Rot_13
          yp_temp = dx_Box*Rot_21 + dy_Box*Rot_22 + dz_Box*Rot_23
          zp_temp = dx_Box*Rot_31 + dy_Box*Rot_32 + dz_Box*Rot_33
          x1=Box_XC(num_FB) + xp_temp
          y1=Box_YC(num_FB) + yp_temp
          z1=Box_ZC(num_FB) + zp_temp
          u1 = bigU(num_FB) + ( bigOmegaY(num_FB)*(z1-Box_ZC(num_FB))
     &                        - bigOmegaZ(num_FB)*(y1-Box_YC(num_FB)) )
          v1 = bigV(num_FB) + ( bigOmegaZ(num_FB)*(x1-Box_XC(num_FB))
     &                        - bigOmegaX(num_FB)*(z1-Box_ZC(num_FB)) )
          w1 = bigW(num_FB) + ( bigOmegaX(num_FB)*(y1-Box_YC(num_FB))
     &                        - bigOmegaY(num_FB)*(x1-Box_XC(num_FB)) )
          call pos_veloc(nn,x1,y1,z1,u1,v1,w1)
          call pressure(nn,ZZmax,dx,dy,dz,expont,g)
          if(iBC.eq.1)then
            if(k.eq.L_start)then
              j_minus1 = nn + 1
              j_plus1  = nn
            else if(k.eq.L_finish)then
              j_minus1 = nn
              j_plus1  = nn - 1
            else
              j_minus1 = nn + 1
              j_plus1  = nn - 1
            end if
            if(i.eq.N_start)then
              i_minus1 = nn
              i_plus1  = nn + (L_finish - L_start + 1)
            else if(i.eq.N_finish)then
              i_minus1 = nn - (L_finish - L_start + 1)
              i_plus1  = nn 
            else
              i_minus1 = nn - (L_finish - L_start + 1)
              i_plus1  = nn + (L_finish - L_start + 1)
            end if
            !-- Normal information - neighbour data for        --
            !-- Repulsive Boundary Particles (BPs)             --
            iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
            iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
            iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
            iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          end if 
c          if(iBC.ne.1)then
c            xtemp = x + 0.5*dx
c            ytemp = y + 0.5*dy
c            ztemp = z + 0.5*dz
c            nn=nn+1
c            call pos_veloc(nn,xtemp,ytemp,ztemp,0.,0.,0.)
c          end if
          !print*,'k, x1,z1 ',k,x1,z1
        end do
      end do
       
      !-- Side 4:  y = y2
      !print*,'Side 4:  y = y2'
      ntemp = nn
      j = M_start
      do i = N_start,N_finish 
        do k = L_start,L_finish
          x = i*dx
          y = j*dy
          z = k*dz
          nn=nn+1
          dx_Box = x - Box_XC(num_FB)
          dy_Box = y - Box_YC(num_FB)
          dz_Box = z - Box_ZC(num_FB)
          xp_temp = dx_Box*Rot_11 + dy_Box*Rot_12 + dz_Box*Rot_13
          yp_temp = dx_Box*Rot_21 + dy_Box*Rot_22 + dz_Box*Rot_23
          zp_temp = dx_Box*Rot_31 + dy_Box*Rot_32 + dz_Box*Rot_33
          x1=Box_XC(num_FB) + xp_temp
          y1=Box_YC(num_FB) + yp_temp
          z1=Box_ZC(num_FB) + zp_temp
          u1 = bigU(num_FB) + ( bigOmegaY(num_FB)*(z1-Box_ZC(num_FB))
     &                        - bigOmegaZ(num_FB)*(y1-Box_YC(num_FB)) )
          v1 = bigV(num_FB) + ( bigOmegaZ(num_FB)*(x1-Box_XC(num_FB))
     &                        - bigOmegaX(num_FB)*(z1-Box_ZC(num_FB)) )
          w1 = bigW(num_FB) + ( bigOmegaX(num_FB)*(y1-Box_YC(num_FB))
     &                        - bigOmegaY(num_FB)*(x1-Box_XC(num_FB)) )
          call pos_veloc(nn,x1,y1,z1,u1,v1,w1)
          call pressure(nn,ZZmax,dx,dy,dz,expont,g)
          if(iBC.eq.1)then
            if(k.eq.L_start)then
              j_minus1 = nn + 1
              j_plus1  = nn
            else if(k.eq.L_finish)then
              j_minus1 = nn
              j_plus1  = nn - 1
            else
              j_minus1 = nn + 1
              j_plus1  = nn - 1
            end if
            if(i.eq.N_start)then
              i_minus1 = nn + (L_finish - L_start + 1)
              i_plus1  = nn
            else if(i.eq.N_finish)then
              i_minus1 = nn
              i_plus1  = nn - (L_finish - L_start + 1)
            else
              i_minus1 = nn + (L_finish - L_start + 1)
              i_plus1  = nn - (L_finish - L_start + 1)
            end if
            !-- Normal information - neighbour data for        --
            !-- Repulsive Boundary Particles (BPs)             --
            iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
            iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
            iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
            iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          end if 
c          if(iBC.ne.1)then
c            xtemp = x + 0.5*dx
c            ytemp = y + 0.5*dy
c            ztemp = z + 0.5*dz
c            nn=nn+1
c            call pos_veloc(nn,xtemp,ytemp,ztemp,0.,0.,0.)
c          end if
          !print*,'k, x1,z1 ',k,x1,z1
        end do
      end do

      !-- Side 5:  z = z1 = z2 + cylinderDimensionZ
      !print*,'Side 5:  z = z1'
      ntemp = nn
      k = L_finish
      do j = M_start,M_finish 
        do i = N_start,N_finish
          x = i*dx
          y = j*dy
          z = k*dz
          nn=nn+1
          dx_Box = x - Box_XC(num_FB)
          dy_Box = y - Box_YC(num_FB)
          dz_Box = z - Box_ZC(num_FB)
          xp_temp = dx_Box*Rot_11 + dy_Box*Rot_12 + dz_Box*Rot_13
          yp_temp = dx_Box*Rot_21 + dy_Box*Rot_22 + dz_Box*Rot_23
          zp_temp = dx_Box*Rot_31 + dy_Box*Rot_32 + dz_Box*Rot_33
          x1=Box_XC(num_FB) + xp_temp
          y1=Box_YC(num_FB) + yp_temp
          z1=Box_ZC(num_FB) + zp_temp
          u1 = bigU(num_FB) + ( bigOmegaY(num_FB)*(z1-Box_ZC(num_FB))
     &                        - bigOmegaZ(num_FB)*(y1-Box_YC(num_FB)) )
          v1 = bigV(num_FB) + ( bigOmegaZ(num_FB)*(x1-Box_XC(num_FB))
     &                        - bigOmegaX(num_FB)*(z1-Box_ZC(num_FB)) )
          w1 = bigW(num_FB) + ( bigOmegaX(num_FB)*(y1-Box_YC(num_FB))
     &                        - bigOmegaY(num_FB)*(x1-Box_XC(num_FB)) )
          call pos_veloc(nn,x1,y1,z1,u1,v1,w1)
          call pressure(nn,ZZmax,dx,dy,dz,expont,g)
          if(iBC.eq.1)then
            if(i.eq.N_start)then
              j_minus1 = nn + 1
              j_plus1  = nn
            else if(i.eq.N_finish)then
              j_minus1 = nn
              j_plus1  = nn - 1
            else
              j_minus1 = nn + 1
              j_plus1  = nn - 1
            end if
            if(j.eq.M_start)then
              i_minus1 = nn
              i_plus1  = nn + (N_finish - N_start + 1)
            else if(j.eq.M_finish)then
              i_minus1 = nn - (N_finish - N_start + 1)
              i_plus1  = nn 
            else
              i_minus1 = nn - (N_finish - N_start + 1)
              i_plus1  = nn + (N_finish - N_start + 1)
            end if
            !-- Normal information - neighbour data for        --
            !-- Repulsive Boundary Particles (BPs)             --
            iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
            iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
            iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
            iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          end if 
c          if(iBC.ne.1)then
c            xtemp = x + 0.5*dx
c            ytemp = y + 0.5*dy
c            ztemp = z + 0.5*dz
c            nn=nn+1
c            call pos_veloc(nn,xtemp,ytemp,ztemp,0.,0.,0.)
c          end if
          !print*,'k, x1,z1 ',k,x1,z1
        end do
      end do
       
      !-- Side 6:  z = z2
      !print*,'Side 6:  z = z2'
      ntemp = nn
      k = L_start
      do j = M_start,M_finish 
        do i = N_start,N_finish
          x = i*dx
          y = j*dy
          z = k*dz
          nn=nn+1
          dx_Box = x - Box_XC(num_FB)
          dy_Box = y - Box_YC(num_FB)
          dz_Box = z - Box_ZC(num_FB)
          xp_temp = dx_Box*Rot_11 + dy_Box*Rot_12 + dz_Box*Rot_13
          yp_temp = dx_Box*Rot_21 + dy_Box*Rot_22 + dz_Box*Rot_23
          zp_temp = dx_Box*Rot_31 + dy_Box*Rot_32 + dz_Box*Rot_33
          x1=Box_XC(num_FB) + xp_temp
          y1=Box_YC(num_FB) + yp_temp
          z1=Box_ZC(num_FB) + zp_temp
          u1 = bigU(num_FB) + ( bigOmegaY(num_FB)*(z1-Box_ZC(num_FB))
     &                        - bigOmegaZ(num_FB)*(y1-Box_YC(num_FB)) )
          v1 = bigV(num_FB) + ( bigOmegaZ(num_FB)*(x1-Box_XC(num_FB))
     &                        - bigOmegaX(num_FB)*(z1-Box_ZC(num_FB)) )
          w1 = bigW(num_FB) + ( bigOmegaX(num_FB)*(y1-Box_YC(num_FB))
     &                        - bigOmegaY(num_FB)*(x1-Box_XC(num_FB)) )
          call pos_veloc(nn,x1,y1,z1,u1,v1,w1)
          call pressure(nn,ZZmax,dx,dy,dz,expont,g)
          if(iBC.eq.1)then
            if(i.eq.N_start)then
              j_minus1 = nn + 1
              j_plus1  = nn
            else if(i.eq.N_finish)then
              j_minus1 = nn
              j_plus1  = nn - 1
            else
              j_minus1 = nn + 1
              j_plus1  = nn - 1
            end if
            if(j.eq.M_start)then
              i_minus1 = nn + (N_finish - N_start + 1)
              i_plus1  = nn
            else if(j.eq.M_finish)then
              i_minus1 = nn
              i_plus1  = nn - (N_finish - N_start + 1)
            else
              i_minus1 = nn + (N_finish - N_start + 1)
              i_plus1  = nn - (N_finish - N_start + 1)
            end if
            !-- Normal information - neighbour data for        --
            !-- Repulsive Boundary Particles (BPs)             --
            iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
            iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
            iBP_Pointer_Info(nn,5) = j_minus1       !j-1 neighbour     
            iBP_Pointer_Info(nn,6) = j_plus1        !j+1 neighbour
          end if 
c          if(iBC.ne.1)then
c            xtemp = x + 0.5*dx
c            ytemp = y + 0.5*dy
c            ztemp = z + 0.5*dz
c            nn=nn+1
c            call pos_veloc(nn,xtemp,ytemp,ztemp,0.,0.,0.)
c          end if
          !print*,'k, x1,z1 ',k,x1,z1
        end do
      end do
       

       nb_FB(num_FB) = nn
       write(*,*) 'Object number: ',num_FB
       write(*,*) 'no. of Object particles: nb_FB',nb_FB(num_FB)

       write(88,*)num_FB
       write(88,*)bigMass(num_FB)
       write(88,*)bigInertiaXX(num_FB),
     &            bigInertiaYY(num_FB),bigInertiaZZ(num_FB)
       write(88,*)XcylinderDimension(num_FB),YcylinderDimension(num_FB),
     &            ZcylinderDimension(num_FB)
       write(88,*)cylinderDensity(num_FB)
       write(88,*)FB_SpecificWeight(num_FB)
       write(88,*)friction_coeff(num_FB)
       write(88,*)Box_XC(num_FB),Box_YC(num_FB),Box_ZC(num_FB)
       write(88,*)bigU(num_FB),bigV(num_FB),bigW(num_FB),
     &       bigOmegaX(num_FB),bigOmegaY(num_FB),bigOmegaZ(num_FB)
       write(88,*)nb_FB(num_FB)

      return
      end

c     ____________________ SUBROUTINE WAVE

      subroutine wave(nn,XXmin,XXmax,YYmin,YYmax,ZZmin,ZZmax,
     +	    		     g,dx,dy,dz,expont)
      include 'common.gen3D'

      double precision x1,y1,z1,hh

      write(*,*) ' Cube containing particles'
      write(*,*) ' XMin, Xmax ??'
      read(*,*) XXmin,XXmax
      write(*,*) XXmin,XXmax
      write(*,*) ' YMin, Ymax ??'       
      read(*,*) YYmin,YYmax
      write(*,*) YYmin,YYmax
      write(*,*) ' ZZMin ?? '
      read(*,*) ZZmin
      write(*,*) ZZmin
      
      write(*,*) ' depth ??'
      read(*,*) D
      write(*,*) D
      write(*,*) ' amplitude ??'
      read(*,*) A
      write(*,*) A

      vlong=sqrt(0.75*(D**3)/A)

      write(*,*) ' x0 ??'
      read(*,*) x0
      write(*,*) x0

      Nstepsy=nint((YYmax-YYmin)/dy)+1



      N_end=nint(XXmax/dx)
      N_ini=nint(XXmin/dx)


      do j=1,Nstepsy	
        do i=N_ini,N_end
       
          x=i*dx
          alt=A/(cosh((x-x0)/vlong)*cosh((x-x0)/vlong))
          vx=alt*(sqrt(9.81/D))
          hh=D+alt
          L_ini=nint(ZZmin/dz)
          L_end=nint(h/dz)
          
          do K=L_ini,L_end
            x1=XXmin+(i-N_ini)*dx
            y1=YYmin+(j-1)*dy
            z1=ZZmin+(k-L_ini)*dz
            nn=nn+1
            call pos_veloc(nn,x1,y1,z1,vx,0.,0.)
            call pressure(nn,hh,dx,dy,dz,expont,g)
              

              x1=XXmin+(i-N_ini+0.5)*dx
              y1=YYmin+(j-1+0.5)*dy
              z1=ZZmin+(k-L_ini+0.5)*dz
              if(x1.le.1.01*XXmax.and.y1.le.1.01*YYmax.and.
     &           z1.le.1.01*ZZmax) then ! 1.01 to avoid the roundoff
                nn=nn+1
                call pos_veloc(nn,x1,y1,z1,vx,0.,0.)
                call pressure(nn,hh,dx,dy,dz,expont,g)
              endif
           enddo
        enddo
      enddo

      return
      end

c     ____

c     ____________________ SUBROUTINE NORMALS_CALC_3D
c
      subroutine normals_Calc_3D
      
      include 'common.gen3D'

      double precision dxpb1, dxpb2
      
c       Subroutine calculates tangents and normals for a surface given 
c       by three points:
c
c       Vectors t, s, n form a righ-handed (orthogonal) system
c
c       (xi     , yi    , zi ) = point of interest 
c       (xt_next,yt_next,zt_next) = next point in traverse of plane
c       (xs_next,ys_next,zs_next) = corresponding point in orthogonal traverse

!               ^ (drs)
!              /
!            
!       ^(n) o(3)
!       |   /
!       |  /
!       | /
!       |/ )
!    (i)o---------o(2)  -->(drt)
c
c       Specifically written for use in Monaghan's Repulsive BC

      !print*,'i,     xp,      yp,      zp    i-1     i+1    j-1    j+1'
      
      do i=1,nb
        
        xp_i = xp(i)
        yp_i = yp(i)
        zp_i = zp(i)


        if(iBP_Pointer_Info(i,3).eq.0.and.
     &     iBP_Pointer_Info(i,4).eq.0)then
          i_plus1  = i + 1
          i_minus1 = i - 1
        else   !Prescribed special neighbours for difficult points
          i_minus1 = iBP_Pointer_Info(i,3)
          i_plus1  = iBP_Pointer_Info(i,4)
        end if
        if(iBP_Pointer_Info(i,5).eq.0.and.
     &     iBP_Pointer_Info(i,6).eq.0)then
           j_plus1  = i + 1
           j_minus1 = i - 1
        else   !Prescribed special neighbours for difficult points
          j_minus1 = iBP_Pointer_Info(i,5)
          j_plus1  = iBP_Pointer_Info(i,6)
        end if
        
        !print*,i,xp(i),yp(i),zp(i),i_minus1,i_plus1,j_minus1,j_plus1

        if(i.eq.i_minus1)then
          xt_prev = xp_i - (xp(i_plus1)-xp_i)
          yt_prev = yp_i - (yp(i_plus1)-yp_i)
          zt_prev = zp_i - (zp(i_plus1)-zp_i)
          xt_next = xp(i_plus1)
          yt_next = yp(i_plus1)
          zt_next = zp(i_plus1)
        else if(i.eq.i_plus1)then
          xt_prev = xp(i_minus1)
          yt_prev = yp(i_minus1)
          zt_prev = zp(i_minus1)
          xt_next = xp_i + (xp_i-xp(i_minus1))
          yt_next = yp_i + (yp_i-yp(i_minus1))
          zt_next = zp_i + (zp_i-zp(i_minus1))
        else
          xt_prev = xp(i_minus1)
          yt_prev = yp(i_minus1)
          zt_prev = zp(i_minus1)
          xt_next = xp(i_plus1)
          yt_next = yp(i_plus1)
          zt_next = zp(i_plus1)
        end if
        if(i.eq.j_minus1)then
          xs_prev = xp_i - (xp(j_plus1)-xp_i)
          ys_prev = yp_i - (yp(j_plus1)-yp_i)
          zs_prev = zp_i - (zp(j_plus1)-zp_i)
          xs_next = xp(j_plus1)
          ys_next = yp(j_plus1)
          zs_next = zp(j_plus1)
        else if(i.eq.j_plus1)then
          xs_prev = xp(j_minus1)
          ys_prev = yp(j_minus1)
          zs_prev = zp(j_minus1)
          xs_next = xp_i + (xp_i-xp(j_minus1))
          ys_next = yp_i + (yp_i-yp(j_minus1))
          zs_next = zp_i + (zp_i-zp(j_minus1))
        else
          xs_prev = xp(j_minus1)
          ys_prev = yp(j_minus1)
          zs_prev = zp(j_minus1)
          xs_next = xp(j_plus1)
          ys_next = yp(j_plus1)
          zs_next = zp(j_plus1)
        end if
                
        iBP_Pointer_Info(i,3) = i_minus1
        iBP_Pointer_Info(i,4) = i_plus1
        iBP_Pointer_Info(i,5) = j_minus1
        iBP_Pointer_Info(i,6) = j_plus1
        BP_xyz_Data(i,1) = xp_i
        BP_xyz_Data(i,2) = yp_i
        BP_xyz_Data(i,3) = zp_i                      

c        xtb,ytb,ztb are components of tangential
c       
        dxt_fwd = xt_next - xp_i
        dyt_fwd = yt_next - yp_i
        dzt_fwd = zt_next - zp_i
        dxt_back = (xp_i - xt_prev)
        dyt_back = (yp_i - yt_prev)
        dzt_back = (zp_i - zt_prev)

        call periodicityCheck(dxt_fwd,  dyt_fwd , dyt_fwd ,
     &                 xp_i, xt_next, yp_i, yt_next, zp_i, zt_next)
        call periodicityCheck(dxt_back, dyt_back, dyt_back,
     &                 xp_i, xt_prev, yp_i, yt_prev, zp_i, zt_prev)
        dxt = dxt_fwd + dxt_back
        dyt = dyt_fwd + dyt_back
        dzt = dzt_fwd + dzt_back

c        xsb,ysb,zsb are components of orthogonal tangential

c              
        dxs_fwd = xs_next - xp_i
        dys_fwd = ys_next - yp_i
        dzs_fwd = zs_next - zp_i
        dxs_back = (xp_i - xs_prev)
        dys_back = (yp_i - ys_prev)
        dzs_back = (zp_i - zs_prev)
        
        call periodicityCheck(dxs_fwd,  dys_fwd , dys_fwd ,
     &                 xp_i, xs_next, yp_i, ys_next, zp_i, zs_next)
        call periodicityCheck(dxs_back, dys_back, dys_back,
     &                 xp_i, xs_prev, yp_i, ys_prev, zp_i, zs_prev)
        dxs = dxs_fwd + dxs_back
        dys = dys_fwd + dys_back
        dzs = dzs_fwd + dzs_back

c       normal = vec(drt) x vec(drs)     :vector cross-product

        dxt_c = dxt_fwd + dxt_back
        dyt_c = dyt_fwd + dyt_back
        dzt_c = dzt_fwd + dzt_back
        dxs_c = dxs_fwd + dxs_back
        dys_c = dys_fwd + dys_back
        dzs_c = dzs_fwd + dzs_back

        dxn = dyt_c*dzs_c - dzt_c*dys_c   !dyt*dzr - dzt*dyr
        dyn = dzt_c*dxs_c - dxt_c*dzs_c   !dzt*dxr - dxt*dzr
        dzn = dxt_c*dys_c - dyt_c*dxs_c   !dxt*dyr - dyt*dxr
        
        drt = sqrt(dxt*dxt + dyt*dyt + dzt*dzt)
        xtb(i) = dxt/drt
        ytb(i) = dyt/drt
        ztb(i) = dzt/drt
        
        drs = sqrt(dxs*dxs + dys*dys + dzs*dzs)
        xsb(i) = dxs/drs
        ysb(i) = dys/drs
        zsb(i) = dzs/drs
        
c       normal = vec(drt) x vec(drs)     :vector cross-product
        drn = sqrt(dxn*dxn + dyn*dyn + dzn*dzn)
        xnb(i) = dxn/drn
        ynb(i) = dyn/drn
        znb(i) = dzn/drn

        deltapxb(i,1) = sqrt((dxt_back)**2 + (dyt_back)**2 
     &                     + (dzt_back)**2)
        deltapxb(i,2) = sqrt((dxt_fwd)**2 + (dyt_fwd)**2
     &                     + (dzt_fwd)**2)
        deltapyb(i,1) = sqrt((dxs_back)**2 + (dys_back)**2 
     &                     + (dzs_back)**2)
        deltapyb(i,2) = sqrt((dxs_fwd)**2 + (dys_fwd)**2
     &                     + (dzs_fwd)**2)

    
     
      enddo
      
      print*
      print*,'NORMALS calculated'
      print*

      end subroutine  

c     ____

c     ____________________ SUBROUTINE NORMALS_FILEWRITE_3D
c
      subroutine normals_FileWrite_3D
      
      include 'common.gen3D'

c
c     Writes the output file NORMALS.init for input into SPH code
      
      
      open(21,file='NORMALS.init')

22    format(9(e16.8,' '),6(i6,' '),3(e16.8,' '))
      do i=1,nb
                
        
        iBP_Pointer_Info(i,1) = i  !Default MPI index
        iBP_Pointer_Info(i,2) = 0  !Default MPI Rank
        
        !-- Diagnostic Check --
        if(i.eq.0)then
          print*,'iBP_Pointer_Info(i,1)',
     &            iBP_Pointer_Info(i,1)     
          print*,'iBP_Pointer_Info(i,2)',
     &            iBP_Pointer_Info(i,2)     
          print*,'iBP_Pointer_Info(i,3)',
     &            iBP_Pointer_Info(i,3)     
          write(*,22) 
     &    xnb(i),ynb(i),znb(i),
     &    xtb(i),ytb(i),ztb(i),
     &    xsb(i),ysb(i),zsb(i),
     &    iBP_Pointer_Info(i,1),
     &    iBP_Pointer_Info(i,2),
     &    iBP_Pointer_Info(i,3),
     &    iBP_Pointer_Info(i,4),
     &    iBP_Pointer_Info(i,5),
     &    iBP_Pointer_Info(i,6),
     &    BP_xyz_Data(i,1),
     &    BP_xyz_Data(i,2),
     &    BP_xyz_Data(i,3)
        end if
        !---------------------
        
        write(21,22) 
     &    xnb(i),ynb(i),znb(i),
     &    xtb(i),ytb(i),ztb(i),
     &    xsb(i),ysb(i),zsb(i),
     &    iBP_Pointer_Info(i,1),
     &    iBP_Pointer_Info(i,2),
     &    iBP_Pointer_Info(i,3),
     &    iBP_Pointer_Info(i,4),
     &    iBP_Pointer_Info(i,5),
     &    iBP_Pointer_Info(i,6),
     &    BP_xyz_Data(i,1),
     &    BP_xyz_Data(i,2),
     &    BP_xyz_Data(i,3)
        
      enddo
      close(21)
      
      print*
      print*,'NORMALS.init file written'

      end subroutine  
c     ____

c     ____________________ SUBROUTINE PERIODICITY_CHECK


      subroutine periodicityCheck(drxp, dryp, drzp,
     &                            xp_i, xp_other,
     &                            yp_i, yp_other,
     &                            zp_i, zp_other)
      
      include 'common.gen3D'

      double precision dxpb1,dxpb2
      double precision dypb1,dypb2
      double precision dzpb1,dzpb2
      
      
c     ---  Subroutine modifies differences in position if periodicity is activated ---      
      
      
        !--- X-Direction Periodicity ---
        if(i_periodicOBs(1).eq.1)then
          if(drxp.gt.6.0*h)then
            dxpb1 = dble(xb_max+dpx)-dble(xp_other)   !xb_max_double-dble(xp_next)
            dxpb2 = dble(xp_i)-dble(xb_min)      !dble(xp_i)-xb_min_double
            drxp = -real(dxpb1+dxpb2)
          else if(drxp.lt.-6.0*h)then
            dxpb1 = dble(xb_max+dpx)-dble(xp_i)    !xb_max_double-dble(xp_i)
            dxpb2 = dble(xp_other)-dble(xb_min)     !dble(xp_next)-xb_min_double
            drxp = real(dxpb1+dxpb2)
          end if
        end if
        !--- Y-Direction Periodicity ---
        if(i_periodicOBs(2).eq.1)then
          if(dryp.gt.6.0*h)then
            dypb1 = dble(yb_max+dpy)-dble(yp_other)   !xb_max_double-dble(xp_next)
            dypb2 = dble(yp_i)-dble(yb_min)      !dble(xp_i)-xb_min_double
            dryp = -real(dypb1+dypb2)
          else if(dryp.lt.-6.0*h)then
            dypb1 = dble(yb_max+dpy)-dble(yp_i)    !xb_max_double-dble(xp_i)
            dypb2 = dble(yp_other)-dble(yb_min)     !dble(xp_next)-xb_min_double
            dryp = real(dypb1+dypb2)
          end if
        end if
        !--- Z-Direction Periodicity ---
        if(i_periodicOBs(3).eq.1)then
          if(drzp.gt.6.0*h)then
            dzpb1 = dble(zb_max+dpz)-dble(zp_other)   !xb_max_double-dble(xp_next)
            dzpb2 = dble(zp_i)-dble(zb_min)      !dble(xp_i)-xb_min_double
            drzp = -real(dzpb1+dzpb2)
          else if(drzp.lt.-6.0*h)then
            dzpb1 = dble(zb_max+dpz)-dble(zp_i)    !xb_max_double-dble(xp_i)
            dzpb2 = dble(zp_other)-dble(zb_min)     !dble(xp_next)-xb_min_double
            drzp = real(dzpb1+dzpb2)
          end if
        end if
      
      end subroutine  


c     ____

c     ____________________ SUBROUTINE TOCOMPILE_mpi

      subroutine tocompile_mpi
      include 'common.gen3D'
      CHARACTER(LEN=10) :: FMT,FMT1,FIN2
      CHARACTER(LEN=1)  :: TAB,LS
      CHARACTER(LEN=11) :: FIN
      CHARACTER(LEN=16) :: FIN3, FIN4
      
      TAB=CHAR(9)
      LS =CHAR(92)

      FIN  = '_MPI_3D.o \'
      FIN2 = '_MPI_3D.o '
     
      FMT="(A)"
      FMT1="(2A)"
      open(22,file='SPHYSICS.mak')
      write(22,FMT) 'FC=mpif90'
      write(22,FMT) 'OPTIONS= -O3 -mcmodel=medium'
      !- Optimisation options: Uncomment as required -
c     &   //' -ipo'             !ifort only as underlying compiler
     &   //' -shared-intel'    !ifort only as underlying compiler
c     &   //' -march=native'    !gfortran only as underlying compiler
c     &   //' -ffast-math'      !gfortran only as underlying compiler
c     &   //' -funroll-loops'   !gfortran only as underlying compiler
!       !- Debugging options for mpif90=gfortran -
!      &   //' -fbounds-check -frange-check -g'
! !      &   //' -Wunderflow'
!      &   //' -Wuninitialized'
!      &   //' -ffpe-trap=invalid,zero,overflow'
!      &   //' -fstack-check'
!      &   //' -ftrapv'
c     &   //' -finit-real=snan'
c     &   //' -finit-integer=-100'
c     &   //' -fstack-protector'
!       !- Debugging options for mpif90=ifort -
!      &   //' -g -debug all'
!      &   //' -check all'
cc     &   //' -inline-debug-info'
cc     &   //' -implicitnone'
cc     &   //' -warn unused'
cc     &   //' -warn truncated_source'
cc     &   //' -fp-stack-check'
cc     &   //' -fpstkchk'
cc     &   //' -fp'
cc     &   //' -heap-arrays'
c     &   //' -fstack-security-check'
c     &   //' -fstack-protector'
c     &   //' -fp-stack-check'
c     &   //' -ftrapuv'
c     &   //' -check bounds'
c     &   //' -check pointer'
c     &   //' -check uninit'
c     &   //' -traceback'
      write(22,FMT) 'srcdir=.'
      write(22,FMT) 'idir=../../execs'
      write(22,FMT) 'bakdir=../../execs.bak'
      write(22,FMT) 'objects=energy'//FIN
      write(22,FMT1)TAB,'recover_list'//FIN 
      write(22,FMT1)TAB,'ini_divide'//FIN
      write(22,FMT1)TAB,'keep_list'//FIN
      write(22,FMT1)TAB,'SPHYSICS'//FIN
      write(22,FMT1)TAB,'getdata'//FIN
      write(22,FMT1)TAB,'check_limits'//FIN                  
      write(22,FMT1)TAB,'divide'//FIN
      write(22,FMT1)TAB,'vorticity'//FIN
      write(22,FMT1)TAB,'movingObjects'//FIN
      write(22,FMT1)TAB,'updateNormals'//FIN
      write(22,FMT1)TAB,'movingGate'//FIN
      write(22,FMT1)TAB,'movingPaddle'//FIN
      write(22,FMT1)TAB,'movingWedge'//FIN
      write(22,FMT1)TAB,'periodicityCorrection'//FIN

      !- Kernel Corrections
      if (i_kernelcorrection.eq.0) then
        write(22,FMT1)TAB,'ac_NONE'//FIN
        write(22,FMT1)TAB,'kernel_correction_NC'//FIN
      elseif (i_kernelcorrection.eq.2) then
        write(22,FMT1)TAB,'ac_KGC'//FIN
        write(22,FMT1)TAB,'kernel_correction_KGC'//FIN
        write(22,FMT1)TAB,'pre_self_KGC'//FIN
        write(22,FMT1)TAB,'pre_celij_KGC'//FIN
      elseif (i_kernelcorrection.eq.1) then
        write(22,FMT1)TAB,'ac_KC'//FIN
        write(22,FMT1)TAB,'kernel_correction'//FIN
      endif

      if(i_ConservativeFormulation.eq.0)then
        write(22,FMT1)TAB,'ac'//FIN
        write(22,FMT1)TAB,'poute'//FIN
        write(22,FMT1)TAB,'gradients_calc_basic'//FIN
      else
        write(22,FMT1)TAB,'ac_Conservative'//FIN
        write(22,FMT1)TAB,'poute_Conservative'//FIN
        write(22,FMT1)TAB,'gradients_calc_Conservative'//FIN
      endif

      !- Boundary Conditions
      if(iBC.eq.1) then
        if(num_FB.eq.0)then
          write(22,FMT1)TAB,'monaghanBC'//FIN
          if(iRiemannSolver.lt.1)then 
            write(22,FMT1)TAB,'self_BC_Monaghan'//FIN
            write(22,FMT1)TAB,'celij_BC_Monaghan'//FIN
          else
            if(iRiemannSolver.eq.1)then 
              write(22,FMT1)TAB,
     &         'self_BC_Monaghan_RiemannConservative'//FIN
              write(22,FMT1)TAB,
     &        'celij_BC_Monaghan_RiemannConservative'//FIN
            elseif(iRiemannSolver.eq.2)then 
              write(22,FMT1)TAB,
     &         'self_BC_Monaghan_RiemannNonConservative'//FIN
              write(22,FMT1)TAB,
     &        'celij_BC_Monaghan_RiemannNonConservative'//FIN
            endif
          endif
        else
          !- FLOATING BODIES
          write(22,FMT1)TAB,'monaghanBC_FloatingBodies'//FIN
c          write(22,FMT1)TAB,'monaghanBC_FloatingBodies_'
c     &                             //'AngMomCorrection'//FIN
          if(iRiemannSolver.lt.1)then 
            write(22,FMT1)TAB,
     &                'self_BC_Monaghan_FloatingBodies'//FIN
            write(22,FMT1)TAB,
     &               'celij_BC_Monaghan_FloatingBodies'//FIN
          else
            if(iRiemannSolver.eq.1)then 
              write(22,FMT1)TAB,
     &         'self_BC_Monaghan_FloatingBodies_'
     &                               //'RiemannConservative'//FIN
              write(22,FMT1)TAB,
     &        'celij_BC_Monaghan_FloatingBodies_'
     &                               //'RiemannConservative'//FIN
            elseif(iRiemannSolver.eq.2)then 
              write(22,FMT1)TAB,
     &         'self_BC_Monaghan_FloatingBodies_'
     &                               //'RiemannNonConservative'//FIN
              write(22,FMT1)TAB,
     &        'celij_BC_Monaghan_FloatingBodies_'
     &                               //'RiemannNonConservative'//FIN
            endif
          endif
        endif
      else !(iBC.eq.2) 
        if(num_FB.eq.0)then
           write(22,FMT1)TAB,'self_BC_Dalrymple'//FIN
           write(22,FMT1)TAB,'celij_BC_Dalrymple'//FIN
        else
           write(22,FMT1)TAB,'self_BC_Dalrymple_FloatingBodies'//FIN
           write(22,FMT1)TAB,'celij_BC_Dalrymple_FloatingBodies'//FIN
        endif
      endif

      !- Rigid Body Motion 
      if(i_ConservativeFormulation.eq.0)then
        write(22,FMT1)TAB,'rigid_body_motion'//FIN
      else
        write(22,FMT1)TAB,'rigid_body_motion_Conservative'//FIN
      endif

      !- Variable Time Step 
      if(i_ConservativeFormulation.eq.0)then
        write(22,FMT1)TAB,'variable_time_step'//FIN
      else
        write(22,FMT1)TAB,'variable_time_step_Conservative'//FIN
      endif

      !- Approximate Riemann Solver
      if(iRiemannSolver.gt.0)then 
        if(i_ConservativeFormulation.eq.0)then
          write(22,FMT1)TAB,'approx_RiemannSolver_'
     &                           //'NonConservative'//FIN
        else
          write(22,FMT1)TAB,'approx_RiemannSolver_'
     &                           //'Conservative'//FIN
        endif
        i_limiterChoice = 1  !Temporary Default Value
        if(i_limiterChoice.eq.1)then
          write(22,FMT1)TAB,'limiter_betaMinMod'//FIN
        else
          write(22,FMT1)TAB,'limiter_betaMinMod'//FIN
        endif
      endif

      !- Viscosity
      if (i_viscos.eq.1) then
          write(22,FMT1)TAB,'viscosity_artificial'//FIN
      else if (i_viscos.eq.2) then
          write(22,FMT1)TAB,'viscosity_laminar'//FIN
      else
          write(22,FMT1)TAB,'viscosity_laminar+SPS'//FIN
      endif
		
      if(i_viscos.eq.3) then
        if(i_ConservativeFormulation.eq.0)then
          write(22,FMT1)TAB,'correct_SPS'//FIN
        else
          print*
          print*,'Option not yet available: '
          print*,'SPS model in Conservative formulation'
          stop
          write(22,FMT1)TAB,'correct_SPS_Conservative'//FIN
        endif
      else
        if(i_ConservativeFormulation.eq.0)then
          write(22,FMT1)TAB,'correct'//FIN
        else
          write(22,FMT1)TAB,'correct_Conservative'//FIN
        endif
      endif
        

c	    Kernels
c	    (1) Gaussian; (2)Quadratic;  (3)Cubic  ; (5) Wendland Quintic
      if (i_kernel.eq.1) then
             write(22,FMT1)TAB,'kernel_gaussian'//FIN
      else if (i_kernel.eq.2) then 
             write(22,FMT1)TAB,'kernel_quadratic'//FIN
      else if (i_kernel.eq.3) then 
             write(22,FMT1)TAB,'kernel_cubic'//FIN
      else if (i_kernel.eq.5) then
	     write(22,FMT1)TAB,'kernel_wendland5'//FIN
      endif

c         Equation of State
      if (i_EoS.eq.1) then
             write(22,FMT1)TAB,'EoS_Tait'//FIN
      else if (i_EoS.eq.2) then
             write(22,FMT1)TAB,'EoS_IdealGas'//FIN
      else if (i_EoS.eq.3) then
             write(22,FMT1)TAB,'EoS_Morris'//FIN
      else
             write(22,FMT1)TAB,'EoS_Poisson'//FIN
      endif

c         Density Reinitialisation
      if (i_densityFilter.eq.1) then
         write(22,FMT1)TAB,'densityFilter_Shepard'//FIN
         write(22,FMT1)TAB,'ac_Shepard'//FIN
         write(22,FMT1)TAB,'pre_celij_Shepard'//FIN
         write(22,FMT1)TAB,'pre_self_Shepard'//FIN
      else if (i_densityFilter.eq.2) then
         write(22,FMT1)TAB,'densityFilter_MLS'//FIN
         write(22,FMT1)TAB,'ac_MLS'//FIN
         write(22,FMT1)TAB,'LU_decomposition'//FIN
         write(22,FMT1)TAB,'pre_celij_MLS'//FIN
         write(22,FMT1)TAB,'pre_self_MLS'//FIN
      else   
         write(22,FMT1)TAB,'densityFilter_NONE'//FIN
      endif

c         Algorithm 
      if(i_ConservativeFormulation.eq.0)then
        if (i_algorithm.eq.1) then       !Predictor Corrector
          write(22,FMT1)TAB,'step_predictor_corrector'//FIN
        elseif (i_algorithm.eq.2) then   !Verlet
          write(22,FMT1)TAB,'step_verlet'//FIN
        elseif (i_algorithm.eq.3) then   !Symplectic
          write(22,FMT1)TAB,'step_symplectic'//FIN
        else
          write(22,FMT1)TAB,'step_beeman'//FIN
        endif
      elseif(i_ConservativeFormulation.eq.1)then   !ConservativeFormulation
        if (i_algorithm.eq.1) then       !Predictor Corrector
          write(22,FMT1)TAB,'step_predictor_corrector_'
     &                    //'Conservative'//FIN
        elseif (i_algorithm.eq.2) then   !Verlet
          write(22,FMT1)TAB,'step_verlet'//FIN
          print*
          print*,'Not a valid Option : '
          print*,'step_verlet in Conservative formulation'
          stop
        elseif (i_algorithm.eq.3) then   !Symplectic
          write(22,FMT1)TAB,'step_symplectic_Conservative'//FIN
        else
          write(22,FMT1)TAB,'step_beeman'//FIN
          print*
          print*,'Not a valid Option : '
          print*,'step_beeman in Conservative formulation'
          stop
        endif
      else
        print*
        print*,'Not a valid Option : '
        print*,'SPS model in Conservative formulation'
        stop
      endif

      !- Extra MPI routines -
      FIN3 = '_NONE_MPI_3D.o \'
      if(i_ConservativeFormulation.eq.0)then
        write(22,FMT1)TAB,'update_accnSummations_fromWest'//FIN
        write(22,FMT1)TAB,'SendRecv_Data_toWest'//FIN
        write(22,FMT1)TAB,'index_check_EastWest'//FIN
        if(MPI_CartDims.eq.1)then
          write(22,FMT1)TAB,'update_accnSummations_fromBelow'//FIN3
          write(22,FMT1)TAB,'SendRecv_Data_toBelow'//FIN3
          write(22,FMT1)TAB,'index_check_UpDown'//FIN3
          write(22,FMT1)TAB,'update_accnSummations_fromSouth'//FIN3
          write(22,FMT1)TAB,'SendRecv_Data_toSouth'//FIN3
          write(22,FMT1)TAB,'index_check_NorthSouth'//FIN3
        elseif(MPI_CartDims.eq.2)then
          write(22,FMT1)TAB,'update_accnSummations_fromBelow'//FIN
          write(22,FMT1)TAB,'SendRecv_Data_toBelow'//FIN
          write(22,FMT1)TAB,'index_check_UpDown'//FIN
          write(22,FMT1)TAB,'update_accnSummations_fromSouth'//FIN3
          write(22,FMT1)TAB,'SendRecv_Data_toSouth'//FIN3
          write(22,FMT1)TAB,'index_check_NorthSouth'//FIN3
        else
          write(22,FMT1)TAB,'update_accnSummations_fromBelow'//FIN
          write(22,FMT1)TAB,'SendRecv_Data_toBelow'//FIN
          write(22,FMT1)TAB,'index_check_UpDown'//FIN
          write(22,FMT1)TAB,'update_accnSummations_fromSouth'//FIN
          write(22,FMT1)TAB,'SendRecv_Data_toSouth'//FIN
          write(22,FMT1)TAB,'index_check_NorthSouth'//FIN
        endif
      else
        write(22,FMT1)TAB,
     &          'update_accnSummations_Conservative_fromWest'//FIN
        write(22,FMT1)TAB,'SendRecv_Data_Conservative_toWest'//FIN
        write(22,FMT1)TAB,'index_check_Conservative_EastWest'//FIN
        if(MPI_CartDims.eq.1)then
          write(22,FMT1)TAB,
     &            'update_accnSummations_Conservative_fromBelow'//FIN3
          write(22,FMT1)TAB,'SendRecv_Data_Conservative_toBelow'//FIN3
          write(22,FMT1)TAB,'index_check_Conservative_UpDown'//FIN3
          write(22,FMT1)TAB,
     &            'update_accnSummations_Conservative_fromSouth'//FIN3
          write(22,FMT1)TAB,'SendRecv_Data_Conservative_toSouth'//FIN3
          write(22,FMT1)TAB,'index_check_Conservative_NorthSouth'//FIN3
        elseif(MPI_CartDims.eq.2)then
          write(22,FMT1)TAB,
     &            'update_accnSummations_Conservative_fromBelow'//FIN
          write(22,FMT1)TAB,'SendRecv_Data_Conservative_toBelow'//FIN
          write(22,FMT1)TAB,'index_check_Conservative_UpDown'//FIN
          write(22,FMT1)TAB,
     &            'update_accnSummations_Conservative_fromSouth'//FIN3
          write(22,FMT1)TAB,'SendRecv_Data_Conservative_toSouth'//FIN3
          write(22,FMT1)TAB,'index_check_Conservative_NorthSouth'//FIN3
        else
          write(22,FMT1)TAB,
     &            'update_accnSummations_Conservative_fromBelow'//FIN
          write(22,FMT1)TAB,'SendRecv_Data_Conservative_toBelow'//FIN
          write(22,FMT1)TAB,'index_check_Conservative_UpDown'//FIN
          write(22,FMT1)TAB,
     &            'update_accnSummations_Conservative_fromSouth'//FIN
          write(22,FMT1)TAB,'SendRecv_Data_Conservative_toSouth'//FIN
          write(22,FMT1)TAB,'index_check_Conservative_NorthSouth'//FIN
        endif
      endif
      !- Kernel Corrections
      if (i_kernelcorrection.eq.2) then
        write(22,FMT1)TAB,'update_KGC_Summations_fromWest'//FIN
        write(22,FMT1)TAB,'SendRecv_KGC_Matrices_toWest'//FIN
        if(MPI_CartDims.eq.1)then
          write(22,FMT1)TAB,'update_KGC_Summations_fromBelow'//FIN3
          write(22,FMT1)TAB,'SendRecv_KGC_Matrices_toBelow'//FIN3
          write(22,FMT1)TAB,'update_KGC_Summations_fromSouth'//FIN3
          write(22,FMT1)TAB,'SendRecv_KGC_Matrices_toSouth'//FIN3
        elseif(MPI_CartDims.eq.2)then
          write(22,FMT1)TAB,'update_KGC_Summations_fromBelow'//FIN
          write(22,FMT1)TAB,'SendRecv_KGC_Matrices_toBelow'//FIN
          write(22,FMT1)TAB,'update_KGC_Summations_fromSouth'//FIN3
          write(22,FMT1)TAB,'SendRecv_KGC_Matrices_toSouth'//FIN3
        else
          write(22,FMT1)TAB,'update_KGC_Summations_fromBelow'//FIN
          write(22,FMT1)TAB,'SendRecv_KGC_Matrices_toBelow'//FIN
          write(22,FMT1)TAB,'update_KGC_Summations_fromSouth'//FIN
          write(22,FMT1)TAB,'SendRecv_KGC_Matrices_toSouth'//FIN
        endif
      endif
      !- Density Reinitialisation
      if (i_densityFilter.eq.1) then
        write(22,FMT1)TAB,'update_Shepard_Summations_fromWest'//FIN
        if(MPI_CartDims.eq.1)then
          write(22,FMT1)TAB,'update_Shepard_Summations_fromBelow'//FIN3
          write(22,FMT1)TAB,'update_Shepard_Summations_fromSouth'//FIN3
        elseif(MPI_CartDims.eq.2)then
          write(22,FMT1)TAB,'update_Shepard_Summations_fromBelow'//FIN
          write(22,FMT1)TAB,'update_Shepard_Summations_fromSouth'//FIN3
        else
          write(22,FMT1)TAB,'update_Shepard_Summations_fromBelow'//FIN
          write(22,FMT1)TAB,'update_Shepard_Summations_fromSouth'//FIN
        endif
      else if (i_densityFilter.eq.2) then
        write(22,FMT1)TAB,'SendRecv_MLS_Matrices_toWest'//FIN
        write(22,FMT1)TAB,'update_MLS_Summations_fromWest'//FIN
        write(22,FMT1)TAB,'update_MLS_densitySummations_fromWest'//FIN
        if(MPI_CartDims.eq.1)then
          write(22,FMT1)TAB,'SendRecv_MLS_Matrices_toBelow'//FIN3
          write(22,FMT1)TAB,'update_MLS_Summations_fromBelow'//FIN3
          write(22,FMT1)TAB,
     &               'update_MLS_densitySummations_fromBelow'//FIN3
          write(22,FMT1)TAB,'SendRecv_MLS_Matrices_toSouth'//FIN3
          write(22,FMT1)TAB,'update_MLS_Summations_fromSouth'//FIN3
          write(22,FMT1)TAB,
     &             'update_MLS_densitySummations_fromSouth'//FIN3
        elseif(MPI_CartDims.eq.2)then
          write(22,FMT1)TAB,'SendRecv_MLS_Matrices_toBelow'//FIN
          write(22,FMT1)TAB,'update_MLS_Summations_fromBelow'//FIN
          write(22,FMT1)TAB,
     &               'update_MLS_densitySummations_fromBelow'//FIN
          write(22,FMT1)TAB,'SendRecv_MLS_Matrices_toSouth'//FIN3
          write(22,FMT1)TAB,'update_MLS_Summations_fromSouth'//FIN3
          write(22,FMT1)TAB,
     &             'update_MLS_densitySummations_fromSouth'//FIN3
        else
          write(22,FMT1)TAB,'SendRecv_MLS_Matrices_toBelow'//FIN
          write(22,FMT1)TAB,'update_MLS_Summations_fromBelow'//FIN
          write(22,FMT1)TAB,
     &               'update_MLS_densitySummations_fromBelow'//FIN
          write(22,FMT1)TAB,'SendRecv_MLS_Matrices_toSouth'//FIN
          write(22,FMT1)TAB,'update_MLS_Summations_fromSouth'//FIN
          write(22,FMT1)TAB,
     &             'update_MLS_densitySummations_fromSouth'//FIN
        endif
      endif
      if (i_densityFilter.ge.1) then
        write(22,FMT1)TAB,'SendRecv_filteredDensities_toWest'//FIN
        if(MPI_CartDims.eq.1)then
          write(22,FMT1)TAB,'SendRecv_filteredDensities_toBelow'//FIN3
          write(22,FMT1)TAB,'SendRecv_filteredDensities_toSouth'//FIN3
        elseif(MPI_CartDims.eq.2)then
          write(22,FMT1)TAB,'SendRecv_filteredDensities_toBelow'//FIN
          write(22,FMT1)TAB,'SendRecv_filteredDensities_toSouth'//FIN3
        else
          write(22,FMT1)TAB,'SendRecv_filteredDensities_toBelow'//FIN
          write(22,FMT1)TAB,'SendRecv_filteredDensities_toSouth'//FIN
        endif
      endif
      write(22,FMT1)TAB,'update_vorticitySummations_fromWest'//FIN
      write(22,FMT1)TAB,'identify_Ps_for_Exporting_toWest'//FIN
      if(MPI_CartDims.eq.1)then
        write(22,FMT1)TAB,'update_vorticitySummations_fromBelow'//FIN3
        write(22,FMT1)TAB,'identify_Ps_for_Exporting_toBelow'//FIN3
        write(22,FMT1)TAB,'update_vorticitySummations_fromSouth'//FIN3
        write(22,FMT1)TAB,'identify_Ps_for_Exporting_toSouth'//FIN3
      elseif(MPI_CartDims.eq.2)then
        write(22,FMT1)TAB,'update_vorticitySummations_fromBelow'//FIN
        write(22,FMT1)TAB,'identify_Ps_for_Exporting_toBelow'//FIN
        write(22,FMT1)TAB,'update_vorticitySummations_fromSouth'//FIN3
        write(22,FMT1)TAB,'identify_Ps_for_Exporting_toSouth'//FIN3
      else
        write(22,FMT1)TAB,'update_vorticitySummations_fromBelow'//FIN
        write(22,FMT1)TAB,'identify_Ps_for_Exporting_toBelow'//FIN
        write(22,FMT1)TAB,'update_vorticitySummations_fromSouth'//FIN
        write(22,FMT1)TAB,'identify_Ps_for_Exporting_toSouth'//FIN
      endif
      write(22,FMT1)TAB,'update_BPInfo_onRoot'//FIN
      write(22,FMT1)TAB,'ipcount_to_i'//FIN
      write(22,FMT1)TAB,'divide_ParallelPrep'//FIN
      write(22,FMT1)TAB,'DomainProcs'//FIN
      write(22,FMT1)TAB,'Adapt_Regrid'//FIN
      write(22,FMT1)TAB,'Adapt_Check_EastWest'//FIN
      if(MPI_CartDims.eq.1)then
        write(22,FMT1)TAB,'Adapt_Check_UpDown'//FIN3
        write(22,FMT1)TAB,'Adapt_Check_NorthSouth'//FIN3
      elseif(MPI_CartDims.eq.2)then
        write(22,FMT1)TAB,'Adapt_Check_UpDown'//FIN
        write(22,FMT1)TAB,'Adapt_Check_NorthSouth'//FIN3
      else
        write(22,FMT1)TAB,'Adapt_Check_UpDown'//FIN
        write(22,FMT1)TAB,'Adapt_Check_NorthSouth'//FIN
      endif
      write(22,FMT1)TAB,'Adapt_ini'//FIN2

      write(22,FMT)'#'      
      write(22,FMT)'SPHYSICS_3D: $(objects)'
      write(22,FMT1)TAB,'$(FC) $(OPTIONS) -o SPHYSICS_3D $(objects)'
      write(22,FMT)'#'
      write(22,FMT1)TAB,'if [ -d $(bakdir) ]; then \'
      write(22,FMT1)TAB,'echo "execs.bak Directory Exists"; else \'
      write(22,FMT1)TAB,'mkdir $(bakdir); \'
      write(22,FMT1)TAB,'echo "execs.bak Directory Created"; \'
      write(22,FMT1)TAB,'fi'
      write(22,FMT)'#'
      write(22,FMT1)TAB,'if [ -d $(idir) ]; then \'
      write(22,FMT1)TAB,'echo "execs Directory Exists"; else \'
      write(22,FMT1)TAB,'mkdir $(idir); \'
      write(22,FMT1)TAB,'echo "execs Directory Created"; \'
      write(22,FMT1)TAB,'fi'
      write(22,FMT)'#' 
      write(22,FMT1)TAB,'-if [ -f $(idir)/SPHYSICS_3D ]; then \'
      write(22,FMT1)TAB,'mv -f $(idir)/SPHYSICS_3D $(bakdir)/; \'
      write(22,FMT1)TAB,'echo Old SPHYSICS_3D moved to execs.bak'
     &//' from execs; \'
      write(22,FMT1)TAB,'fi'
      write(22,FMT)'#'
      write(22,FMT1)TAB,'mv SPHYSICS_3D $(idir)'
      write(22,FMT1)TAB,'echo New SPHYSICS_3D moved to execs'
      write(22,FMT)'#'
      write(22,FMT)'clean:'
      write(22,FMT1)TAB,'rm *.o'
      write(22,FMT1)TAB,'rm *~' 
      write(22,FMT)'#'
      write(22,FMT)'%.o: %.f'
      write(22,FMT1)TAB,'$(FC) $(OPTIONS) -c -o $@ $<'
       
      close(22)
      
      return
      end	
c     ____
  

       
       
C-------SUBROUTINE TO ENSURE THAT PARTICLES ARE NOT TOO
C       CLOSE TO EACH OTHER
c
c     For Repulsive Boundary Force BC (iBC.eq.1), Boundary Particles
c     can be on top of each other
c     However, for Dalrymple BC (iBC.eq.2) particles ontop of each
c     will cause the code to crash
c
c
      subroutine position_check(dx,dy,dz)
      include 'common.gen3D'
      
      dx_thresh=0.10*dx
      dy_thresh=0.10*dy
      dz_thresh=0.10*dz

      !- Generate checking grid -
      one_over_2h = 1.0/(2.0*h)
      four_h = 4.0*h
      
      xGC_min = 0.0 - 4.0*h
      xGC_max = vlx
      yGC_min = 0.0 - 4.0*h
      yGC_max = vly
      zGC_min = 0.0 - 4.0*h
      zGC_max = vlz      
       
      ncx = int( (xGC_max-xGC_min)*one_over_2h ) + 1
      ncy = int( (yGC_max-yGC_min)*one_over_2h ) + 1
      ncz = int( (zGC_max-zGC_min)*one_over_2h ) + 1      
      nsheet  = ncx*ncy ! Number of cells in a XY sheet
      nct     = nsheet*ncz
      nc = 0
                   
      if(nct .ge. nct_max) then
        print*
        print*,'ERROR in position_check'
        print*,'No. of cells exceeds nct_max in common.gen3D'
        print*,'nct ',nct
        print*,'nct_max   ',nct_max
        print*
        stop
      endif 

      if(i_periodicOBs(2).eq.1)then
        if(vly.lt.5*h)then
          print*
          print*,'ERROR in position_check'
          print*,'Periodicity does not work properly with
     & low resolution in Y direction '
          print*,'vly, dy ',vly, dy
          print*,'Min value, 5h  ',5*h
          print*
          stop
	  endif
      endif 



                   
      !-- New 2-D Call numbers --
      ncall1  = -ncx+1               	!South-East
      ncall2  =  ncx+1               	!North-East
      ncall3  = -nsheet+1            	!East       & Down
      ncall4  =  nsheet+1		!East       & Up
      ncall5  =  nsheet+ncx    		!North      & Up
      ncall6  = -nsheet+ncx +1 		!North-East & Down
      ncall7  =  ncall5+1                 !North-East & Up
      ncall8  =  nsheet-ncx    		!South      & Up
      ncall9  = -nsheet-ncx+1  		!South-East & Down
      ncall10 =  ncall8+1                 !South-East & Up
      
      print*
      print*,'-- Checking particles initial Positions --'
      print*,'dx, dy, dz ',dx, dy, dz
      print*,'dx_thresh ',dx_thresh
      print*,'dy_thresh ',dy_thresh
      print*,'dz_thresh ',dz_thresh
      print*,'ncx, ncy, ncz ',ncx,ncy,ncz

      call divide_dr_check(1,np)
      call ac_dr_check(dx_thresh,dy_thresh,dz_thresh)
      nb1 = nb+1

      print*,'--> Particle Positions Okay'
      print*

      return
      end

c     ____
  

c     ____________________ SUBROUTINE divide_dr_check

      
      subroutine divide_dr_check(n_start,n_end)
      include 'common.gen3D'
      
       
       do k=n_start,n_end

           dxp = xp(k) - xGC_min
           dyp = yp(k) - yGC_min
           dzp = zp(k) - zGC_min

           icell = int( dxp * one_over_2h ) + 1
           jcell = int( dyp * one_over_2h ) + 1
           kcell = int( dzp * one_over_2h ) + 1

           !--- Periodic OBs correction ---
           !activated when not using cartesian topology in direction 1-3
           if(i_periodicOBs(1).eq.1.and.icell.gt.ncx)icell=ncx  !Periodic Open Boundary correction X-Direction   
           if(i_periodicOBs(2).eq.1.and.jcell.gt.ncy)jcell=ncy  !Periodic Open Boundary correction Y-Direction   
           if(i_periodicOBs(3).eq.1.and.kcell.gt.ncz)kcell=ncz  !Periodic Open Boundary correction Z-Direction   
           
           ! ii is the linear cell position in the matrix of 2h cells
           ii = icell + (jcell - 1)*ncx +(kcell - 1)*nsheet

          if(ii.lt.1)then
           print*
           print*,'ERROR in divide_2D.f'
           print*,'ii.lt.1'
           print*,'n_start,n_end ',n_start,n_end
           print*,'k',k
           print*,'xp(k), yp(k), zp(k)  ',xp(k), yp(k), zp(k)
           print*,'xGC_min, yGC_min, zGC_min ',xGC_min, yGC_min, zGC_min
           print*,'dxp, dyp , dzp ',dxp, dyp, dzp 
           print*,'one_over_2h  ',one_over_2h
           print*,'icell, jcell , kcell ',icell, jcell, kcell
           print*,'Box ii ',ii
           print*,'nc(ii)',nc(ii)
           print*,'ncx, ncy , ncz ',ncx, ncy , ncz
           stop
          end if
                                                        
           ! nc is the number of particles in cell ii
           nc(ii) = nc(ii)+1       
                                      
          if(nc(ii).gt.nplink_max)then
           print*
           print*,'ERROR in divide_dr_check'
           print*,'nc(ii) >= nplink_max'
           print*,'nc(ii)',nc(ii)
           print*,'nplink_max',nplink_max
           print*,'n_start,n_end ',n_start,n_end
           print*,'k',k
           print*,'xp(k), yp(k), zp(k)  ',xp(k), yp(k), zp(k)
           print*,'xGC_min, yGC_min, zGC_min ',xGC_min, yGC_min, zGC_min
           print*,'dxp, dyp , dzp ',dxp, dyp, dzp 
           print*,'one_over_2h  ',one_over_2h
           print*,'icell, jcell , kcell ',icell, jcell, kcell
           print*,'Box ii ',ii
           print*,'nc(ii)',nc(ii)
           print*,'ncx, ncy , ncz ',ncx, ncy , ncz
          end if

          ibox(ii,nc(ii))=k  !Tells us that particle with array location k (i.e. xp(k) )  
                             !is in box ii which, so far, contains "nc(ii,mkind)" particles

       enddo 
       
       return
       end
c     ____
  

c     ____________________ SUBROUTINE ac_dr_check

      subroutine ac_dr_check(dx_thresh,dy_thresh,dz_thresh)
      include 'common.gen3D'
      

      ncx_start = 1
      ncx_finish = ncx
      ncy_start = 1
      ncy_finish = ncy
      ncz_start = 1
      ncz_finish = ncz
      
       do lz=ncz_start,ncz_finish
       do ly=ncy_start,ncy_finish
       do lx=ncx_start,ncx_finish
       
         j1 = lx + (ly-1)*ncx + (lz-1)*nsheet

c         if(rank_id.eq.3)then
c           print*,'k1, lx,ly,lz, j1, nc ',
c     &             kind_p1,lx,ly,lz, j1, nc(j1,kind_p1)
c         endif
         
         if(nc(j1).gt.0) then
c                            ! if the cell is not empty, then
c                            ! loop over it and over neighboring
c                            ! cells

c         print*,'kind_p1, lx, lz, j1 ',kind_p1,lx, lz, j1

c         !-- Cells in the same XY sheet --
          lx2 = lx+1
          ly2 = ly+1
          lz2 = lz+1
          !- EAST -
          if(lx2.le.ncx)then
            call celij(j1,j1+1,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,1)     !East
          end if

          !- NORTH -
          if(ly2.le.ncy)then
            call celij(j1,j1+ncx,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,3)     !North
          !- NORTH-EAST -  
            if(lx2.le.ncx)then 
            call celij(j1,j1+ncall2,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,5)     !North-East
            endif
          endif

          !- SOUTH-EAST -
          if(lx2.le.ncx.and.ly2.gt.2)then
            call celij(j1,j1+ncall1,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,9)     !South-East
          endif

          !-- XY Sheet Above: UP --
          lz2=lz+1
          if(lz2.le.ncz)then
            call celij(j1,j1+nsheet,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,13)    !Up only
            !- EAST -
            if(lx2.le.ncx)then
              call celij(j1,j1+ncall4,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,14)    !Up & East
            !- NORTH-EAST -
              if(ly2.le.ncy)then
              call celij(j1,j1+ncall7,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,20)    !Up & North-East
              endif
            !- SOUTH-EAST -
              if(ly2.gt.2)then
              call celij(j1,j1+ncall10,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,24)    !Up & South-East
              endif
            end if

            !- NORTH -
            if(ly2.le.ncy)then
              call celij(j1,j1+ncall5,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,16)    !Up & North
            end if

            !- SOUTH -
            if(ly2.gt.2) then
              call celij(j1,j1+ncall8,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,18)    !Up & South
            end if


          endif   !End of:  if(lz2.le.ncz)then

          !-- XY Sheet Below: DOWN --
          lz2=lz+1
          if(lz.gt.1)then

            !- EAST -
            if(lx2.le.ncx)then
              call celij(j1,j1+ncall3,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,28)    !Down & East
            !- NORTH-EAST -                          
              if(ly2.le.ncy)then
              call celij(j1,j1+ncall6,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,30)    !Down & North-East
              endif
            !- SOUTH-EAST -
              if(ly2.gt.2)then
              call celij(j1,j1+ncall9,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,34)    !Down & South-East
              endif
            end if

          end if   !End of:  if(lz2.eq.2)then


          !-- PERIODIC CALLS ---
          
          !- Z-periodicity Info - 
          if(i_periodicOBs(3).eq.1)then
            ncall_zdiff_up   = -nct
            ncall_zdiff_down =  nct
            lz2_max = ncz + 1
            lz2_min = 0
          else
            ncall_zdiff_up   =  0
            ncall_zdiff_down =  0
            lz2_max = ncz
            lz2_min = 1
          endif
          
          !-- Cells in the same XY sheet --
          !- X-Dir Periodic -
          if(i_periodicOBs(1).eq.1.and.lx.eq.ncx)then
            call celij(j1,j1+1-ncx,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,2)                        !East        Periodic X-Dir only
            if(ly2.le.ncy)then
              call celij(j1,j1+ncall2-ncx,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,6)                        !North-East  Periodic X-Dir only
            endif
            if(ly2.gt.2)then
              call celij(j1,j1+ncall1-ncx,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,10)                       !South-East  Periodic X-Dir only
            endif
            if(i_periodicOBs(2).eq.1)then
              if(ly.eq.ncy)then
                call celij(j1,j1+ncall2-ncx-nsheet,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,7)                        !North-East  Periodic X-Dir & Y-Dir
              else if(ly.eq.1)then
                call celij(j1,j1+ncall1-ncx+nsheet,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,11)                       !South-East  Periodic X-Dir & Y-Dir
              endif
            endif
          endif
          !- Y-Dir Periodic Only -
          if(i_periodicOBs(2).eq.1)then 
            if(ly.eq.ncy)then
              call celij(j1,j1+ncx-nsheet,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,4)                        !North       Periodic Y-Dir only
              if(lx2.le.ncx)then
                call celij(j1,j1+ncall2-nsheet,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,8)                        !North-East  Periodic Y-Dir only
              end if
            endif
            if(ly2.eq.2.and.lx2.le.ncx)then
              call celij(j1,j1+ncall1+nsheet,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,12)                       !South-East  Periodic Y-Dir only
            end if
          end if
          !-- XY Sheet Above: UP --
          lz2=lz+1
          if(lz2.le.lz2_max)then
            !- X-Dir Periodic -
            if(i_periodicOBs(1).eq.1.and.lx.eq.ncx)then
              call celij(j1,j1+ncall4-ncx+ncall_zdiff_up,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,15)                       !Up & East        Periodic X-Dir only
              if(ly2.le.ncy)then
                call celij(j1,j1+ncall7-ncx+ncall_zdiff_up,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,21)                       !Up & North-East  Periodic X-Dir only
              endif
              if(ly2.gt.2)then
                call celij(j1,j1+ncall10-ncx+ncall_zdiff_up,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,25)                       !Up & South-East  Periodic X-Dir only
              endif
              if(i_periodicOBs(2).eq.1)then
                if(ly.eq.ncy)then
                  call celij(j1,j1+ncall7-nsheet+ncall_zdiff_up,
     &                 lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,22)                       !Up & North-East  Periodic X-Dir & Y-Dir
                else if(ly.eq.1)then
                  call celij(j1,
     &                 j1+ncall10-ncx+nsheet+ncall_zdiff_up,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,26)                       !Up & South-East  Periodic X-Dir & Y-Dir
                end if
              endif
            endif
            !- Y-Dir Periodic Only -
            if(i_periodicOBs(2).eq.1)then
              if(ly.eq.ncy)then 
                call celij(j1,j1+ncall5-nsheet+ncall_zdiff_up,
     &                 lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,17)                       !Up & North       Periodic Y-Dir only
                if(lx2.le.ncx)then
                  call celij(j1,j1+ncall7-nsheet+ncall_zdiff_up,
     &                 lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,23)                       !Up & North-East  Periodic Y-Dir only
                endif
              endif
              if(ly.eq.1)then 
                call celij(j1,j1+ncall8+nsheet+ncall_zdiff_up,
     &                 lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,19)                       !Up & South       Periodic Y-Dir only
              endif
              if(ly2.eq.2.and.lx2.le.ncx)then
                call celij(j1,j1+ncall10+nsheet+ncall_zdiff_up,
     &                 lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,27)                       !Up & South-East  Periodic Y-Dir only
              end if
            endif
          endif   !End of: if(lz2.le.ncz)then
          
          !-- XY Sheet Below: DOWN --
          lz2=lz+1
          if(lz.gt.lz2_min)then
            !- X-Dir Periodic -
            if(i_periodicOBs(1).eq.1.and.lx.eq.ncx)then
              call celij(j1,j1+ncall3-ncx+ncall_zdiff_down,
     &                 lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,29)                       !Down & East        Periodic X-Dir only
              if(ly2.le.ncy)then
                call celij(j1,j1+ncall6-ncx+ncall_zdiff_down,
     &                 lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,31)                       !Down & North-East  Periodic X-Dir only
              endif
              if(ly2.gt.2)then
                call celij(j1,j1+ncall9-ncx+ncall_zdiff_down,
     &                 lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,35)                       !Down & South-East  Periodic X-Dir only
              endif
              if(i_periodicOBs(2).eq.1)then
                if(ly.eq.ncy)then
                  call celij(j1,j1+ncall6-nsheet+ncall_zdiff_down,
     &                 lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,32)                       !Down & North-East  Periodic X-Dir & Y-Dir
                else if(ly.eq.1)then
                 call celij(j1,
     &                j1+ncall9-ncx+nsheet+ncall_zdiff_down,
     &                 lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,36)                       !Down & South-East  Periodic X-Dir & Y-Dir
                end if
              end if
            end if
            !- Y-Dir Periodic Only -
            if(i_periodicOBs(2).eq.1.and.lx2.le.ncx)then
              if(ly.eq.ncy)then
                call celij(j1,j1+ncall6-nsheet+ncall_zdiff_down,
     &                 lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,33)    !Down & North-East  Periodic Y-Dir only
              endif
              if(ly2.eq.2)then
                call celij(j1,j1+ncall9+nsheet+ncall_zdiff_down,
     &                 lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,37)  !Down & South-East  Periodic Y-Dir only
              end if
            endif
          
          endif    !End of:  if(lz.gt.1)then

        endif  !End of: if(nc(j1,kind_p1).gt.0)then

      enddo
      enddo
      enddo

              
       !do j1=1,nct
       do j1x = ncx_start, ncx_finish
       do j1y = ncy_start, ncy_finish
       do j1z = ncz_start, ncz_finish
         j1 = j1x + (j1y-1)*ncx + (j1z-1)*nsheet
           if(nc(j1).gt.0)
     +		call self(j1,dx_thresh,dy_thresh,dz_thresh)
       enddo
       enddo
       enddo
      
      end subroutine
c     ____
  

c     ____________________ SUBROUTINE celij_dr_check

      subroutine celij(j1,j2,lx2,ly2,lz2,
     &                 dx_thresh,dy_thresh,dz_thresh,id_call)
      include 'common.gen3D'

      double precision xmin_container_double, xmax_container_double
      double precision ymin_container_double, ymax_container_double
      double precision zmin_container_double, zmax_container_double

      xmin_container_double = dble(xb_min)
      xmax_container_double = dble(xb_max)
      ymin_container_double = dble(yb_min)
      ymax_container_double = dble(yb_max)
      zmin_container_double = dble(zb_min)
      zmax_container_double = dble(zb_max)

      
      do ii=1,nc(j1)
        i = ibox(j1,ii)
         
        do jj=1,nc(j2)
          j = ibox(j2,jj)

          drx = xp(i) - xp(j)
          dry = yp(i) - yp(j)
          drz = zp(i) - zp(j)
      

           !-- Periodicity Correction --
           !- X-Direction -
           if(lx2.gt.ncx)then
              if(drx.gt.four_h)then
                dxp_dble1 = xmax_container_double-dble(xp(i))
                dxp_dble2 = dble(xp(j))-xmin_container_double
                drx = -real(dxp_dble1+dxp_dble2)
              end if
           elseif(lx2.lt.3)then
              if(-drx.gt.four_h)then
                dxp_dble1 = dble(xp(i))-xmin_container_double
                dxp_dble2 = xmax_container_double-dble(xp(j))
                drx =  real(dxp_dble1+dxp_dble2)
              end if
           end if
           !- Y-Direction -
           if(ly2.gt.ncy)then
              if(dry.gt.four_h)then
                dyp_dble1 = ymax_container_double-dble(yp(i))
                dyp_dble2 = dble(yp(j))-ymin_container_double
                dry = -real(dyp_dble1+dyp_dble2)
              end if
           elseif(ly2.lt.3)then
              if(-dry.gt.four_h)then
                dyp_dble1 = dble(yp(i))-ymin_container_double
                dyp_dble2 = ymax_container_double-dble(yp(j))
                dry =  real(dyp_dble1+dyp_dble2)
              end if
           end if
           !- Z-Direction -
           if(lz2.gt.ncz)then
              if(drz.gt.four_h)then
                dzp_dble1 = zmax_container_double-dble(zp(i))
                dzp_dble2 = dble(zp(j))-zmin_container_double
                drz = -real(dzp_dble1+dzp_dble2)
              end if
           elseif(lz2.lt.3)then
              if(-drz.gt.four_h)then
                dzp_dble1 = dble(zp(i))-zmin_container_double
                dzp_dble2 = zmax_container_double-dble(zp(j))
                drz =  real(dzp_dble1+dzp_dble2)
              end if
           end if
          
          
          delta_x=abs(drx)
          delta_y=abs(dry)         
          delta_z=abs(drz)
          if(delta_x.lt.dx_thresh.and.
     &       delta_y.lt.dy_thresh.and.
     &       delta_z.lt.dz_thresh) then          
            print*
            write(*,*) 'WARNING: The following Particles are closer'
            write(*,*) 'than dx_thresh, dy_thresh or dz_thresh', i,j
            print*,'xp(i), yp(i), zp(i) ',xp(i), yp(i), zp(i)
            print*,'xp(j), yp(j), zp(j) ',xp(i), yp(j), zp(j)
            if(delta_x.lt.0.1*dx_thresh.and.
     &         delta_y.lt.0.1*dy_thresh.and.
     &         delta_z.lt.0.1*dz_thresh)then     
              if((iBC.eq.1.and.(i.gt.nb.or.j.gt.nb)).or.iBC.eq.2)then
                print*,'Particles are too close and will cause code'
                print*,'code to crash'
c                stop
              end if              
            end if
          endif
      
        enddo
      enddo
      
      end subroutine
      
c     ____
  
c     ____________________ SUBROUTINE self_dr_check

      subroutine self(j1,dx_thresh,dy_thresh,dz_thresh)
      include 'common.gen3D'
      
      jj_start = 1
      do ii=1,nc(j1)
        i = ibox(j1,ii)
         
        jj_start = jj_start + 1
         
        do jj=jj_start,nc(j1)
          j = ibox(j1,jj)

          drx = xp(i) - xp(j)
          dry = yp(i) - yp(j)
          drz = zp(i) - zp(j)
      
          delta_x=abs(drx)
          delta_y=abs(dry)         
          delta_z=abs(drz)
          if(delta_x.lt.dx_thresh.and.
     &       delta_z.lt.dz_thresh.and.
     &       delta_y.lt.dy_thresh) then          
            print*
            write(*,*) 'WARNING: The following Particles are closer'
            write(*,*) 'than dx_thresh, dy_thresh or dz_thresh', i,j
            print*,'xp(i), yp(i), zp(i) ',xp(i), yp(i), zp(i)
            print*,'xp(j), yp(j), zp(j) ',xp(i), yp(j), zp(j)
            if(delta_x.lt.0.1*dx_thresh.and.
     &         delta_y.lt.0.1*dy_thresh.and.
     &         delta_z.lt.0.1*dz_thresh)then     
              if((iBC.eq.1.and.(i.gt.nb.or.j.gt.nb)).or.iBC.eq.2)then
                print*,'Particles are too close and will cause code'
                print*,'code to crash'
c                stop
              end if              
            end if
          endif
      
        enddo
      enddo
      
      end subroutine

C-------SUBROUTINE TO Choose precision of SPHYSICS variables:
c       xp, yp, zp, drx, dry, drz
c
c

      subroutine precisionWrite(i_compile_opt)
      include 'common.gen3D'
      
      print*
      print*,'Enter Desired Precision of XYZ variables'
      print*,'1 = Single Precision '
      print*,'2 = Double Precision '
      read(*,*)  i_Precision
      write(*,*) i_Precision
         
      if(i_Precision.eq.1)then
        kind_XYZ = kind(0.0)
        print*,'Single Precision kind number is ',kind(0.0)
      elseif(i_Precision.eq.2)then
        kind_XYZ = kind(0D0)
        print*,'Double Precision kind number is ',kind(0D0)
      else
        print*,'Invalid Choice for XYZ Precision'
        stop
      endif  
       
      print*,'Opening source\SPHYSICS3D\precision_kind.3D, '
      if(i_compile_opt.eq.3.or.i_compile_opt.eq.4)then   !Windows Choice
        open(unit=19,file='..\..\source\SPHYSICS3D\precision_kind.3D')
      else
        open(unit=19,file='../../source/SPHYSICS3D/precision_kind.3D')
      endif
      
      write(19,190)'      parameter(kind_XYZ=',kind_XYZ,')'
190   format(a26,i2,a1)

      close(19)
      print*
      
      return
      end
